      real function getamgn()
      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      getamgn=amgn
      return
      end

      integer function getbcol(i)
      include "cluster.inc"
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev
      getbcol=bcol(i)
      return
      end

      integer function getibwdt(i)
      include "cluster.inc"
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev
      getibwdt=bwdt(i)
      return
      end

      subroutine patom(na,ith,np,rad,ne,hb,d,iflag,ips,iat,icase)
      real rad(*),hb(3,*),d(*)
      integer iflag(*)

      include "cluster.inc"
      real xa(3,namax),mpl(namax),uixy(6,namax),p123(3,namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft,uixy,p123

      integer ie1(nemax),ie2(nemax),jas(namax)
      common /cpatom1/ ie1,ie2,jas

      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev

      integer isk(0:48,namax),irs(0:48,namax)
      integer inumb(namax),jnumb(namax)
      real dmin(namax),dmax(namax)
      character(8) jsymb(namax)
      common /cpatom/inumb,jnumb,dmin,dmax,jsymb

      real elmx(3,namax),r(namax),xt(3,namax)
      real uit(6,namax),elmu(6,namax)
      real sd(3),rx(3)
      integer icell(3,8)
      real xcl(3,8),x1(3),x2(3)
      real sx(3),x(3),xd(3),ori(3,3),or(3,3)
      character(8) ctemp(namax)
      integer nelmx(nemax)
      real xc(3)
      integer ipc(2,12)
      integer ip(nemax),iarc(nemax)

      real xtemp(namax)
      integer jtemp(namax)
      integer nold(namax),ytemp(namax*2)

      common /cwflag/ iwb,iwc,iwa,iww
      common /cidm/ jdm, czmin(nemax), czmax(nemax)
      real trc(3,4)
      integer atom
      character(8) atomsymb
      common /cltc/ atom(namax), atomsymb(namax)

      real fxyz(3),rxyz(3),rang,pxyz(3),on(3,3),xvp(3)
      common /crotat/ fxyz,rxyz,rang,pxyz,on,xvp,amgn
      integer sij
      common /ctrns/ sij(3,3),tj(3)
      common /clrng/ lxmin,lxmax,lymin,lymax,lzmin,lzmax
      character str*3
      character(2) symbol
      common /csymb/ symbol(nemax)
      real x0(3),ui(6),uid(6)
      integer hmax(2)
      integer mm(3)
      integer h(2)
      integer od(2)             ! occupation domain number
      integer gethkltoj,getiaslct,getnct,getltype,getislct1
      integer getnclc,getnb,getiel
      character(3) strnn
      data icell/0,0,0,1,0,0,1,1,0,0,1,0,0,0,1,1,0,1,1,1,1,0,1,1/
      data ipc/1,2,2,3,3,4,4,1,5,6,6,7,7,8,8,5,1,5,2,6,3,7,4,8/
      data eps/0.001/
      nct=getnct()
      call gettrc(trc)
c     write(6,*) 'nct=',nct
      call getisk(isk)
      call getirs(irs)

      hmax(1)=ne                ! 2d array into 1d array
      hmax(2)=namax/ne
      call setmm(hmax)
      nb=getnb()
c ********************************************************************
c *   projection of crystal structures surrounded by the scissoring  *
c *             boundary planes  ( max. 10 planes )                  *
c ********************************************************************
c     na: number of independent atoms <=namax
c     ns: number of symmetry operators 1<=ns<=48
c     nct: number of centering translations 1<=nct<=4
c     i:  i-th shell
c     np: number of element pairs to be joined by bonds
c     xa: coordinates of independent atoms
c     isft: element number for xa
c     ias: if ias(i)=1, then i-th atom is plotted
c     rr: rotational part of symmetry operators
c     tt: translational part of symmetry operators
c     trc: centering translations
c     rad: rad(i), radius of i-th element
c     ne: number of elements
c     ie1(i),ie2(i) : i-th pair of elements to be joined by bond
c     dmin, dmax: minimum and maximum distances of bonds
c     elmx: work area
c     hb,d: h,k,l and distances of boundary planes
c     amgn: magnification
c     iwb=0: write bonds
c     iwc=0: write unit cell
c     iwa=0: write all atoms, =1: write only atoms joined by bonds
c     iww=1: write x,y,z coordinates of atoms
c     ips=1: perspective drawing
c     xvp:   visual point in primary system

c*****initialize*******************************
      call zerovi(iarc,ne)
      call zerovi(nelmx,ne)
c     get x0,rmin and rmax for i-th shell

c      call rotaxs(or,ori,angl1,rm)
c     rm: rotation matrix around a given axis
      ltype=getltype()
      if(ltype.eq.0) then
********* non periodic case 
           lxmin=0
           lxmax=0
           lymin=0
           lymax=0
           lzmin=0
           lzmax=0
      end if
c*****genelation of equivalent atoms**********
      iaslct=getiaslct()
      write(6,*) 'iaslct=',iaslct
      nclc=getnclc()
      do i=1,na
         ke=nct
         if(iaslct.eq.1) then
            ie=isft(i)
            if(jas(ie).eq.0) go to 20
         else if(iaslct.eq.2) then
            if(jas(atom(i)).eq.0) go to 20
         else if(iaslct.eq.3) then
            if(jas(i).eq.0) go to 20
         end if
         nrx=0

         do k=1,ke !  trc loop
            do j=1,isk(0,i) ! symmetry op. loop
               ns1=isk(j,i)
               call rednsic(ns1,ns,ic)
               call getrx(xa(1,i),rx,ns,ic) ! rx : rotated xa
c               call wtvctrrf('xa=',xa(1,i),3,'(3f10.5)')
c               call wtvctrrf('rx=',rx,3,'(3f10.5)')
               call vsumr(rx,trc(1,k),x,3) ! x  : translated rx
               if(icase.eq.0) then
                  call getruirt(uixy(1,i),ui,ns,ic) ! ui : rotated uij
                  call settng1(ui,uid,sij) !  transformation for ui
               else
                  call zerovr(uid,6)
               end if
c*****positioning a unit cell************
               if(ltype.gt.0) then
                  call reduc(x)
               end if
c 23            continue
c*****position in the nearest cells*******
               do  l1=lxmin,lxmax
                  do  l2=lymin,lymax
                     do  l3=lzmin,lzmax
                        xd(1)=x(1)+l1
                        xd(2)=x(2)+l2
                        xd(3)=x(3)+l3
                        islct=getislct1(xd,ith)
                        if(islct.eq.1) then
c     atoms within the shell
                           ie=isft(i)
                           if(ie.gt.ne) then
                              write(6,*) 'ie=',ie,' ne=',ne
                              call quit('ie is larger than ne')
                           end if
                           if(ie.gt.nemax.or.ie.lt.1) then
                              write(6,*) 'i,isft(i)=',i,ie
                              write(6,*) 'nemax >=',nemax
                              call quit('isft(i) > nemax or < 1')
                           end if
                           nelmx(ie)=nelmx(ie)+1
                           n=nelmx(ie)
                           ien=gethkltoj(ie,n)
                           call settng(xd,sij,tj) ! setting dependent transformation for x
                           call vcpyr(xd,xt(1,ien),3)
                           call vcpyr(uid,uit(1,ien),6)
                           inumb(ien)=i ! atom number
                           if(iat.eq.0) then
                              jnumb(ien)=atom(i) ! occupation domain number
                           else
                              jsymb(ien)=atomsymb(i) ! atom symbol
                           end if
c     this is only valid under identity operation (j=1,ic=0)
                        end if
                     end do
                  end do
               end do
            end do
         end do
 20      continue
      end do

c     xt(i,ien)   x,y,z coordinates generated
c     uit(i,ien)  u11,u22,u33,u23,u31,u12
      do ie=1,ne
         do n=1,nelmx(ie) 
            ien=gethkltoj(ie,n)
            call vcpyr(xt(1,ien),sd,3)   ! xt : before viewing transformation
            call rmx(sd,xc,ips,fact)     ! xc : viewing transformation
            call vcpyr(uit(1,ien),uid,6) ! uit : before viewing transformation
            call rotui(uid)      !  rotation by orientation matrix
c            write(6,*) 'ie,n,ien=',ie,n,ien
c            write(6,*) 'rad,fact,amgn=',rad(ie),fact,amgn
            if(fact.ge.0) then
               if(ips.eq.0) then  ! viewing transformation for radius
                  r(ien)=rad(ie)*getamgn()
               else
                  r(ien)=rad(ie)*getamgn()*fact
               end if
c               write(6,*) 'n,ie,ien=',n,ie,ien
c     save atom coordinates in the plotter system
               call vcpyr(xc,elmx(1,ien),3)  ! elmx : xt after viewing trnsf.
               call vcpyr(uid,elmu(1,ien),6) ! elmu : ui after viewing trnsf.
            end if            
         end do
      end do

c*****sort so that elmx(3,ien) > elmx(3,ie,n-1)
      do ie=1,ne
         if(nelmx(ie).gt.namax) then
            nelmx(ie)=namax
            write(6,'(1h ,a)') 'too many atoms > namax'
         end if
         neie=nelmx(ie)
         do n=1,neie
            ien=gethkltoj(ie,n)
            xtemp(n)=elmx(3,ien)
         end do

c     rearrange xtemp in ascending order of xtemp
         call qsort(xtemp,ytemp,nold,neie)

c     rearrange corresponding elmx  (element number)
         call arrngr(elmx,3,ne,ie,xtemp,nold,neie)
c     rearrange corresponding xt
         call arrngr(xt,3,ne,ie,xtemp,nold,neie)
c     rearrange corresponding r
         call arrngr(r,1,ne,ie,xtemp,nold,neie)
c     rearrange corresponding inumb  (atom number)
         call arrngi(inumb,1,ne,ie,jtemp,nold,neie)
c     rearrange corresponding jnumb (occupation domain number)
         if(iat.eq.0) then  ! quasicrystals
            call arrngi(jnumb,1,ne,ie,jtemp,nold,neie)
         else if(iat.eq.1) then ! crystals
            call arrngc(jsymb,1,ne,ie,ctemp,nold,neie)
         end if
c     rearrange corresponding uixy
         call arrngr(elmu,6,ne,ie,xtemp,nold,neie)
         call arrngr(uit,6,ne,ie,xtemp,nold,neie)
      end do

      call getavrx0(nclc,x0)  ! get average cluster center coord x0
      if(iww.eq.1) then
c        printout x, y, z coordinates
         if(iat.eq.0) then
            call wtatm0(ne,nelmx,xt,uit,inumb,jnumb,x0,jc,np)
         else
            call wtatm1(ne,nelmx,xt,uit,inumb,jsymb,x0,jc,np)
         end if
      end if


c*****selectatoms joined by bonds
      if(iwa.eq.0) then
         do i=1,np
            do j=1,nelmx(ie1(i))
               if(ie1(i).eq.ie2(i)) then
                  ks=j+1
               else
                  if(j.eq.1) then
                     ks=1
                     kd=1
                  else
                     ks=kd
                  end if
               end if
               do k=ks,nelmx(ie2(i))
                  ie1j=gethkltoj(ie1(i),j)
                  ie2k=gethkltoj(ie2(i),k)
                  dx=(elmx(3,ie2k)-elmx(3,ie1j))/amgn
                  if(-dx.gt.dmax(i)) kd=k
                  if(dx.gt.dmax(i)) go to 52
                  call vcpyr(xt(1,ie1j),x1,3)
                  call vcpyr(xt(1,ie2k),x2,3)
                  call vsubr(x2,x1,sx,3)
                  dx=absx(sx)
                  if(dx.ge.dmin(i).and.dx.le.dmax(i)) then ! for bond
                     iflag(ie1j)=1
                     iflag(ie2k)=1
                  end if
 52               continue
               end do
            end do
         end do

         do ie=1,ne
            k=0
            do j=1,nelmx(ie)
c     select atoms joined by bonds
               iej=gethkltoj(ie,j)
               if(iflag(iej).eq.0) go to 55
               k=k+1
               iek=gethkltoj(ie,k)
               call vcpyr(xt(1,iej),xt(1,iek),3)
               call vcpyr(elmu(1,iej),elmu(1,iek),6)
               r(iek)=r(iej)
               inumb(iek)=inumb(iej)
c     if(iat.eq.0) then
c     jnumb(ie,k)=jnumb(ie,j)
c     else
c     jsymb(ie,k)=jsymb(ie,j)
c     end if
 55            continue
            end do
            nelmx(ie)=k
         end do
      end if

c*****plot atoms*********
      call zerovi(ip,ne)
      write(6,*) 'nelmx=',(nelmx(ie),ie=1,ne)
      icount=0
c        ip: number of ie-th elements plotted
c***  beginning of loop
 42   continue
      if(iend(ip,nelmx,ne).eq.1) then
         go to 43
      else
         icount=icount+1
c        write(6,*) 'icount=',icount
      end if
      zmin=1.e32
c***  compare minimum z-coordinates in each element
c               and select minimum among them
      ielm=0
      do ie=1,ne
         if(ip(ie).ne.nelmx(ie)) then
            ipd=ip(ie)+1
            ieipd=gethkltoj(ie,ipd)
            if(elmx(3,ieipd).lt.zmin) then
               ielm=ie
               zmin=elmx(3,ieipd)
            end if
         end if
      end do
      if(ielm.eq.0) then
         write(6,*) 'ielm in patom=',ielm
         call quit('invalid ielm')
      end if
c     ielm: element of atom with minimum z-coordinate

      ipd=ip(ielm)+1
      ielmipd=gethkltoj(ielm,ipd) ! original index
      call vcpyr(elmx(1,ielmipd),x1,3)
c      do ix=1,3
c         x1(ix)=elmx(ix,ielmipd)
c      end do
      ien=getiel(inumb(ielmipd)) ! color (1,2 or 3) determind by p1,p2,p3
c     write(6,*) 'ielmipd,getiel(ielmipd)',ielmipd,getiel(ielmipd)
      rc=r(ielmipd)
      if(rc.le.0) then
         call quit('rc <= 0')
      end if

c     plot atoms (generate ps files)
c     rc=0.1
      if(jmod.eq.0.or.jmod.eq.3.or.jmod.eq.4) then
         call pltat0(x1,rc,acol(ielm))  ! plot atoms
      else if(jmod.eq.5) then
         call pltat0(x1,rc,acol(ien))  ! plot atoms
      else if(jmod.eq.1) then
         call pltat1(x1,rc,acol(ielm))
      else if(jmod.eq.2) then
         call pltat0(x1,rc,acol(ielm))
         inumdd=inumb(ielmipd)
         if(inumdd.lt.10) then
            write(str,'(i1)') inumdd
            nchr=1
         else if(inumdd.lt.100) then
            write(str,'(i2)') inumdd
            nchr=2
         else if(inumdd.lt.1000) then
            write(str,'(i3)') inumdd
            nchr=3
         else
            call quit('inumb too large')
         end if
         call csymbol(x1(1)+0.1,x1(2)+0.1,0.2,str,0.,nchr)
      else
         write(6,*) 'jmod in patom=',jmod 
         call quit('invalid jmod')
      end if
      ip(ielm)=ip(ielm)+1
      go to 42
c***  end of loop
 43   continue

      if(jmod.eq.3) then
         call wtbsspec(nelmx,ne)   ! generate bs file for xbs
      end if

      write(6,*) 'np=',np
      if(jmod.eq.3) then
         write(51,*) ' '
      end if
c*****plot bonds*********
      if(iwb.eq.0) then
         do i=1,np              ! pair number
            write(6,'(a,i2,a)') '********* shell ',ith,' ***********'
            write(6,*) ' atom pair joined by a bond'
            write(6,'(3a)') ' No. OD1 OD2     x1        y1        z1',
     *           '        x2        y2        z2        dst'
            if(jmod.le.2.or.jmod.eq.5) then
               write(52,'(a,i2,a)') '********* shell ',ith,' *********'
               write(52,*) ' atom pair joined by a bond'
               write(52,'(3a)') ' No. OD1 OD2     x1       y1       z1',
     *              '        x2        y2        z2        dst'
            end if
            do j=1,nelmx(ie1(i))
               if(ie1(i).eq.ie2(i)) then
                  ks=j+1
               else
                  if(j.eq.1) then
                     ks=1
                     kd=1
                  else
                     ks=kd
                  end if
               end if
c               write(6,*) 'ks,ie2(i)=',ks,ie2(i)
               do k=ks,nelmx(ie2(i))
                  ie1j=gethkltoj(ie1(i),j) ! original index
                  ie2k=gethkltoj(ie2(i),k) ! original index
                  dx=(elmx(3,ie2k)-elmx(3,ie1j))/amgn
                  od(1)=jnumb(ie1j)
                  od(2)=jnumb(ie2k)
                  if(-dx.gt.dmax(i)) kd=k
                  if(dx.gt.dmax(i)) go to 31
                  do ix=1,3
                     x1(ix)=elmx(ix,ie1j)
                     x2(ix)=elmx(ix,ie2k)
                  end do
                  call vsubr(xt(1,ie2k),xt(1,ie1j),sx,3)
                  dx=absx(sx)
                  if(dx.ge.dmin(i).and.dx.le.dmax(i)) then ! write bond
                     call setdminmax(dmin(i),dmax(i))
                     call wrt2(i,ie1(i),j,ie2(i),k,ne,nelmx,xt,dx,od)
                     call bond(x1,x2,r,elmx,nelmx,ne,bwdt(i),bcol(i))
                  end if
               end do
 31            continue
            end do
            if(jmod.le.2) then
               write(52,'(a)') 'end'
            end if
         end do
         if(jmod.eq.3) then
            write(51,'(a)') ' '
            write(51,'(a,9f10.3)') 'tmat', 1.000,0.000,0.000,0.000,
     *           -0.500,-0.866,0.000,0.866,-0.50
            write(51,'(a,f10.3)') 'dist', 38.018
            write(51,'(a,f10.3)') 'inc', 5.000
            write(51,'(a,f10.3)') 'scale',14.214
            write(51,'(a,f10.3)') 'rfac', 1.00
            write(51,'(a,f10.3)') 'bfac', 1.00
            write(51,'(a,2f10.3)') 'pos', 0.000, 0.000
            write(51,'(a,9i2)') 'switches ',1,0,1,0,0,1,1,0,0
         end if
      end if

c*****plot unit cell**************************************************
c      if(iwc.eq.0) then
c           do 14 i=1,8
c           do j=1,3
c           x1(j)=icell(j,i)
c           end do
cc
cc          transformation to the plotter system
c
c           call rmx(x1,x2,ips,fact)
cc          if(rmx.lt.0) go to 14
c           do 16 j=1,3
c 16        xcl(j,i)=x2(j)
c 14        continue
c
c          do 10 i=1,12
c          do 11 ix=1,3
c          x1(ix)=xcl(ix,ipc(1,i))
c11        x2(ix)=xcl(ix,ipc(2,i))
c
c           call bond(x1,x2,r,elmx,nelmx,ne,3,ccol)
c 10        continue
c      end if
      return
      end

      integer function getislct1(xd,ith)
      real xd(3)
      real x0(3),sx(3),sd(3)
      integer getnclc,getnb
      getislct1=0
      nclc=getnclc()
      nb=getnb()
      do m=1,nclc               ! nclc : number of cluster centers
         im=ith+nb*(m-1)        ! ith boundary
         call getrmm(im,x0,rmin,rmax,jc)
c     write(6,*) 'x0=',x0
         call vsubr(xd,x0,sx,3)
         call vcpyr(sx,sd,3)
         call xxx(sd)
         rd=vabs(sd,3)
         if(rd.ge.rmin.and.rd.le.rmax) then
            getislct1=1
            return
         end if
      end do
      return
      end 

      integer function getislct2(xd,ith)  ! for cylindorical boundary
      real xd(3)
      real x0(3),sx(3),sd(3)
      im=ith
c     call getrmm(im,x0,rmin,rmax,jc)
c     call getrmm1(im,x0,rmin,rmax,zmin,zmax,jc)
c     write(6,*) 'x0=',x0
      call vsubr(xd,x0,sx,3)
      call vcpyr(sx,sd,3)
      call xxx(sd)
      rd=vabs(sd,2)
      getislct2=0
      if(sd(3).ge.zmin.and.sd(3).le.zmax) then
         if(rd.ge.rmin.and.rd.le.rmax) then
            getislct2=1
         end if
      end if
      if(rd.ge.rmin.and.rd.le.rmax) then
         write(6,*) 'center ',m
         write(6,'(a,i3,5f10.5)')
     *        "im,rmin,rmax,x0 ",i,rmin,rmax,x0
      end if
      return
      end
      
      subroutine wtbsspec(nelmx,ne)     ! generates xbs input file
      integer nelmx(*)
      include "cluster.inc"
      real xa(3,namax),mpl(namax),uixy(6,namax),p123(3,namax)
      integer isft(namax)
      common /strinf1/ xa,mpl,isft,uixy,p123

      integer ie1(nemax),ie2(nemax),jas(namax)
      common /cpatom1/ ie1,ie2,jas

      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev
      character(2) symbol
      common /csymb/ symbol(nemax)
      character(3) strnn

      write(51,'(a)') ' '
      do i=1,ne
         call icol2rgb(acol(i),red,green,blue)            
         nn=0                   ! added
         do j=1,nelmx(i)        ! added
            nn=nn+1
            call getstrnn(strnn,nn)
            l1=istrln(symbol(i))
            ra=getrad(i)*getamgn()*3 ! *3 for compativility
c     write(6,*) 'getrad(i)=',getrad(i)
            if(acol(i).le.10) then ! B&W
               grey=float(acol(i))/10
               write(51,'(a,2x,2a,4f10.3)') 'spec',symbol(i)(1:l1),
     *              strnn,max(ra,0.01),grey,grey,grey
            else                ! color
               write(51,'(a,2x,2a,4f10.3)') 'spec',symbol(i)(1:l1),
     *              strnn,max(ra,0.01),red,green,blue
            end if
         end do
      end do
      return
      end

      subroutine setdminmax(dmind,dmaxd)
      common /cdminmax/ dmin, dmax
      dmin=dmind
      dmax=dmaxd
      return
      end

      subroutine getdminmax(dmind,dmaxd)
      common /cdminmax/ dmin, dmax
      dmind=dmin
      dmaxd=dmax
      return
      end

      subroutine arrngr(elmx,m,ne,ie,xtemp,nold,neie)
      real elmx(m,*), xtemp(*)
      integer nold(*)
      integer gethkltoj
      do kk=1,m
         do n=1,neie
            ien=gethkltoj(ie,n)
            xtemp(n)=elmx(kk,ien)
         end do
         do n=1,neie
            ien=gethkltoj(ie,n)
            elmx(kk,ien)=xtemp(nold(n))
         end do
      end do
      return
      end

      subroutine arrngi(elmx,m,ne,ie,xtemp,nold,neie)
      integer elmx(m,*), xtemp(*)
      integer nold(*)
      integer gethkltoj
      do kk=1,m
         do n=1,neie
            ien=gethkltoj(ie,n)
            xtemp(n)=elmx(kk,ien)
         end do
         do n=1,neie
            ien=gethkltoj(ie,n)
            elmx(kk,ien)=xtemp(nold(n))
         end do
      end do
      return
      end

      subroutine arrngc(elmx,m,ne,ie,xtemp,nold,neie)
      character(8) elmx(m,*), xtemp(*)
      integer nold(*)
      integer gethkltoj
      do kk=1,m
         do n=1,neie
            ien=gethkltoj(ie,n)
            xtemp(n)=elmx(kk,ien)
         end do
         do n=1,neie
            ien=gethkltoj(ie,n)
            elmx(kk,ien)=xtemp(nold(n))
         end do
      end do
      return
      end

      subroutine pltat0(x1,r1,ncol)
      dimension x1(3)
      data pi/3.14159/
      call fillarea(1)
      call fillcolor(ncol)
      call circle(0.,360.,r1,x1,0)
      call fillarea(0)
      call fillcolor(0)
      call circle(0.,360.,r1,x1,0)
      return
      end

      subroutine pltat1(x1,r1,ncol)
      real x1(3)
      integer color
      kcol=ncol-mod(ncol,10)
      color=ncol-5+1
      if(color.lt.kcol+1) then
           color=kcol+1
      else if(color.gt.kcol+9) then
           color=kcol+9
      end if
      call atmout(x1(1),x1(2),r1,color,0.3,0.3)
      return
      end

c     for quasicrystals
      subroutine wtatm0(ne,nelmx,xt,uit,inumb,jnumb,x0,jc,np)
      include 'cluster.inc'
      real xt(3,*),x0(*),uit(6,*)
      integer nelmx(*),inumb(*),jnumb(*)

      real x(3,nnn),xd(3,nnn),d(nnn**2),xc(3)
      real y(3),yd(3),sx(3)
      integer st(2*nnn**2),ip(nnn**2)
      integer gethkltoj
      character(50) frmt
      character(2) symbol
      common /csymb/ symbol(nemax)
      common /cwtxyz/ iel0(nemax)  ! for jmod=4
      character(3) strnn
      integer od  ! OD number for quasicrystals
      integer getiel,getodno
      
      call getjmod(jmod)
c      do ie=1,ne
c         write(6,*) (inumb(ien),jnumb(ien),n=1,nelmx(ie))
c      end do

      write(6,*) 'ne,nelmx(1)',ne,nelmx(1)
      write(6,'(1h ,4a)') ' no atom   x           y           z',
     *     '         r     atom OD',
     *     '     u11       u22       u33',
     *     '       u23       u31       u12'
      if(jmod.le.2.or.jmod.eq.5) then
         write(51,*) 'ne,nelmx(1)',ne,nelmx(1)
         write(51,'(1h ,4a)') ' no atom   x           y           z',
     *        '         r     atom OD',
     *        '     u11       u22       u33',
     *        '       u23       u31       u12'
      end if
      frmt='(1h ,2i4,4f10.4,2i5,6f10.5)'
      n=0
      xc(1)=0
      xc(2)=0
      xc(3)=0
      do i=1,ne
         nn=0
         do j=1,nelmx(i)
            ij=gethkltoj(i,j)
            call vcpyr(xt(1,ij),y,3)
            call vsumr(xc,y,xc,3)
            if(jc.eq.0) then
               call vcpyr(y,yd,3)
            else
               call vsubr(y,x0,yd,3)
            end if
            call xxx(yd)
            r=vabs(yd,3)
c     if(r.ge.dmin.and.r.le.dmax) then
            n=n+1
            nn=nn+1
            call vcpyr(yd,xd(1,n),3)

            write(6,frmt) n,i,(xt(k,ij),k=1,3),
     *           r,inumb(ij),jnumb(ij),(uit(k,ij),k=1,6)

            if(jmod.le.2.or.jmod.eq.5) then
               write(51,frmt) n,i,(xt(k,ij),k=1,3),
     *              r,inumb(ij),jnumb(ij),(uit(k,ij),k=1,6)
            else if(jmod.eq.3) then
               call getstrnn(strnn,nn)
               l1=istrln(symbol(i))
               write(51,'(a,2x,2a,3f10.3)') 'atom ',symbol(i)(1:l1),
     *              strnn,(xt(k,ij),k=1,3)
            else if(jmod.eq.4) then
c     inumb(ij) atom number in the input file
               in=getiel(inumb(ij))
               od=getodno(inumb(ij))
c     iel0(i) atom number in Periodic Table for i-th atom
               write(51,'(3(f10.3,a),i3,a,i4)') (xt(k,ij),',',k=1,3),
     *              iel0(in),',',od
            end if

c     end if
         end do
      end do
      if(n.gt.0) then
         xc(1)=xc(1)/n
         xc(2)=xc(2)/n
         xc(3)=xc(3)/n
      end if
      k=0
      do i=1,n-1
         do j=i+1,n
            call vsubr(xd(1,i),xd(1,j),sx,3)
            k=k+1
            d(k)=vabs(sx,3)
         end do
      end do
      call qsort(d,st,ip,k)

      nd=1
      do i=2,k
         if(abs(d(i)-d(nd)).gt.0.0001) then
            nd=nd+1
            d(nd)=d(i)
         end if
      end do
      ie=min(nd,10)  ! intrinsic fortran function
      write(6,'(a,10f10.5)') 'nearest distances=',(d(i),i=1,ie)
      write(6,'(a,3f10.5)') 'deviation of center =', xc(1),xc(2),xc(3)
      if(jmod.le.2.or.jmod.eq.5) then
         write(51,'(a,10f10.5)') 'nearest distances=',(d(i),i=1,ie)
         write(51,'(a,3f10.5)') 'deviation of center =', 
     *        xc(1),xc(2),xc(3)
      end if
      return
      end

      subroutine getstrnn(strnn,nn)
      character(3) strnn
      if(nn.lt.10) then
         write(strnn,'(i1)') nn
      else if(nn.lt.100) then
         write(strnn,'(i2)') nn
      else if(nn.lt.1000) then
         write(strnn,'(i2)') nn
      else
         call quit('nn >=1000')
      end if         
      return
      end

      subroutine wtatm1(ne,nelmx,xt,uit,inumb,jsymb,x0,jc,np)
      real xt(3,*),x0(*),uit(6,*)
      integer nelmx(*),inumb(*)
      character(8) jsymb(*)
      include 'cluster.inc'
      real x(3,nnn),xd(3,nnn),d(nnn**2),xc(3)
      real y(3),yd(3),sx(3)
      integer st(2*nnn**2),ip(nnn**2)
      integer gethkltoj
      character(50) frmt
      character(2) symbol
      common /csymb/ symbol(nemax)
      common /cwtxyz/ iel0(nemax)  ! for jmod=4
      character(3) strnn
      integer getiel
      call getjmod(jmod)
c      do ie=1,ne
c     write(6,*) (inumb(gethkltoj(ie,n)),
c     *    jnumb(gethkltoj(ie,n)),n=1,nelmx(ie))
c      end do
      write(6,*) 'ne,nelmx(1)',ne,nelmx(1)
      write(6,'(1h ,2a)') ' no atom  x           y           z',
     *     '         r     atom symb'
      if(jmod.le.2.or.jmod.eq.5) then
         write(51,*) 'ne,nelmx(1)',ne,nelmx(1)
         write(51,'(1h ,2a)') ' no atom  x           y           z',
     *        '         r     atom symb'
      end if
      frmt='(2i4,4f10.4,i5,2a,6f10.5)'
      n=0
      xc(1)=0
      xc(2)=0
      xc(3)=0
      do i=1,ne
         nn=0
         do j=1,nelmx(i)
            ij=gethkltoj(i,j)
            call vcpyr(xt(1,ij),y,3)
            call vsumr(xc,y,xc,3)
            if(jc.eq.0) then
               call vcpyr(y,yd,3)
            else
               call vsubr(y,x0,yd,3)
            end if
            call xxx(yd)
            r=vabs(yd,3)
c     if(r.ge.dmin.and.r.le.dmax) then
            n=n+1
            nn=nn+1
            call vcpyr(yd,xd(1,n),3)
c     frmt='(2i4,4f10.4,i5,2a,6f10.5)'
            write(6,frmt) n,i,
     *           (xt(k,ij),k=1,3),r,inumb(ij),'  ',
     *           jsymb(ij),(uit(k,ij),k=1,6)
            if(jmod.le.2.or.jmod.eq.5) then
               write(51,frmt) n,i,
     *              (xt(k,ij),k=1,3),r,inumb(ij),'  ',
     *              jsymb(ij),(uit(k,ij),k=1,6)
            else if(jmod.eq.3) then
               call getstrnn(strnn,nn)
               l1=istrln(symbol(i))
               write(51,'(a,2x,2a,3f10.3)') 'atom ',symbol(i)(1:l1),
     *              strnn,(xt(k,ij),k=1,3)
            else if(jmod.eq.4) then
c     inumb(ij) atom number in the input file
               in=getiel(inumb(ij))
c     iel0(i) atom number in Periodic Table for i-th atom
               write(51,'(3(f10.3,a),i3,i4)')(xt(k,ij),',',k=1,3),
     *              iel0(in)
            end if
c     end if
         end do
      end do
      if(n.gt.0) then
         xc(1)=xc(1)/n
         xc(2)=xc(2)/n
         xc(3)=xc(3)/n
      end if
      k=0
      do i=1,n-1
         do j=i+1,n
            k=k+1
            call vsubr(xd(1,i),xd(1,j),sx,3)
            d(k)=vabs(sx,3)
         end do
      end do
      call qsort(d,st,ip,k)

      nd=1
      do i=2,k
         if(abs(d(i)-d(nd)).gt.0.0001) then
            nd=nd+1
            d(nd)=d(i)
         end if
      end do
      ie=min(nd,10)
      write(6,'(a,10f10.5)') 'nearest distances=',(d(i),i=1,ie)
      write(6,'(a,3f10.5)') 'deviation of center =', xc(1),xc(2),xc(3)
      if(jmod.le.2.or.jmod.eq.5) then
         write(51,'(a,10f10.5)') 'nearest distances=',(d(i),i=1,ie)
         write(51,'(a,3f10.5)') 'deviation of center =',
     *        xc(1),xc(2),xc(3)
      end if
      return
      end
c
      subroutine wrt2(ib,je1,j,je2,k,ne,nelmx,elmx,d,od)
c     ib element pair number specified by je1 and je2
c     je1, je2 : element pair joined by a bond
c     j, k     : j-th and k-th atoms for elements specified by je1 and je2
      integer nelmx(*)
      real  elmx(3,*)   ! xt
      integer od(2)
      integer no(2)
      integer gethkltoj
      include "cluster.inc"
      character(2) symbol
      common /csymb/ symbol(nemax)
      character(3) strj,strk
      integer getbcol,getibwdt
      save nn,ns
      data nn/0/,ns/0/
      call getjmod(jmod)
      no(1)=0
      nn=nn+1
      do i=1,je1-1
         no(1)=no(1)+nelmx(i)
      end do
      no(1)=no(1)+j
      no(2)=0
      do i=1,je2-1
         no(2)=no(2)+nelmx(i)
      end do
      no(2)=no(2)+k
c      write(6,'(1h ,3i4,7f10.4)') nn,no,
c      write(6,'(1h ,3i4,7f10.4)') nn-ns,no,
      write(6,'(1h ,3i4,7f10.4)') nn-ns,od,
     *     (elmx(l,gethkltoj(je1,j)),l=1,3),
     *     (elmx(l,gethkltoj(je2,k)),l=1,3),d
c      write(52,'(1h ,3i4,7f10.4)') nn-ns,no,
      if(jmod.le.2.or.jmod.eq.5) then
         write(52,'(1h ,3i4,7f10.4)') nn-ns,od,
     *        (elmx(l,gethkltoj(je1,j)),l=1,3),
     *        (elmx(l,gethkltoj(je2,k)),l=1,3),d
      else
         call getdminmax(dmin,dmax)
         call getstrnn(strj,j)
         call getstrnn(strk,k)
         l1=istrln(symbol(je1))
         l2=istrln(symbol(je2))
         icol=getbcol(ib)
         ibwdt=getibwdt(ib)
         bwdt=getbwdt(ibwdt)*getamgn()
         call icol2rgb(icol,red,green,blue)
         if(jmod.eq.3) then
            if(icol.le.10) then ! B&W bonds
               write(51,'(a,1x,2(2a,1x),4f10.3)') 'bonds',
     *              symbol(je1)(1:l1),strj,symbol(je2)(1:l2),strk,
     *              dmin,dmax,bwdt,1.0
            else                ! color bonds
               write(51,'(a,1x,2(2a,1x),6f10.3)') 'bonds',
     *              symbol(je1)(1:l1),strj,symbol(je2)(1:l2),strk,
     *              dmin,dmax,bwdt,red,green,blue
            end if
         else if(jmod.eq.4) then
            write(51,'(i4,a,i4)') gethkltoj(je1,j),',',gethkltoj(je2,k)
         end if
      end if
      ns=nn
      return
      end

      real function getbwdt(i)
      if(i.le.1) then
         getbwdt=0.01
      else
         getbwdt=0.05*i
      end if
      return
      end

      subroutine cross(xb1,xb2,x1,r1,x2,r2,icase,t1,t2,iii)
      dimension x1(3),x2(3),sx1(3),sx2(3),sx3(3),sx(3),xc1(2),xc2(2)
      data t3/0./,t4/0./
c*******************************************************
c*          blind part of atom1 due to atom2     *
c*******************************************************
c     xb1: start angle of the circle of atom1
c     xb2: end angle of the circle of atom1
c     x1: position of atom1
c     x2: position of atom2
c     r1: radius of atom1
c     r2: radius of atom2
c     t1: start angle of blind part
c     t2: end angle of blind part
c     t3: another start angle of blind part if any
c     t4: another end angle of blind part if any
c     icase=0: no blind part
c     icase=1: completely blind
c     icase=2: start point shaded
c     icase=3: end point shaded
c     icase=4: intermediate part shaded
c     iii=0: t1-t2 is shaded, =1 0-t2, t3-1 are shaded
c
      icase=0
      iii=-1
      t1=0
      t2=0
      do ix=1,3
         sx(ix)=x1(ix)-x2(ix)
      end do
      vabss2=vabs(sx,2)
      if(sx(3).gt.0.or.vabss2.gt.r1+r2) then
c          no shading case
c          icase=0, iii=-1
           return
      end if
      call gipcca(x1,r1,x2,r2,xc1,xc2,n)
      if(n.le.1) then
           if(r2.gt.r1.and.vabss2.lt.min(r1,r2)) then
c               completely shaded
                icase=1
                return
           else
c               no shading case
                return
           end if
      end if
c
      do ix=1,2
         sx1(ix)=xc1(ix)-x1(ix)
         sx2(ix)=xc2(ix)-x1(ix)
         sx3(ix)=xc1(ix)-x2(ix)
      end do
      if(sx1(1)*sx3(2)-sx1(2)*sx3(1).le.0) then
c          xc1: start, xc2: end
           call atanf(sx1,t1)
           call atanf(sx2,t2)
      else
c          xc1: end, xc2: start
           call atanf(sx1,t2)
           call atanf(sx2,t1)
      end if
c        t1-t2 is shaded
      if(t1.le.t2) then
           iii=0
      else
c        t1-t2, t3-t4=t1 are shaded
           iii=1
           t3=t1
           t4=1
           t1=0
      end if
c 13   continue
c*****blind conditions**********************************
c     no blind cases
 31   icase=0
      if(t2.lt.xb1.or.t1.gt.xb2) go to 30
c     completely blind
      if(t1.le.xb1.and.t2.ge.xb2) then
            icase=1
            return
c     start point shaded
      else if(t1.le.xb1.and.t2.gt.xb1) then
            icase=2
            return
c     end point shaded
      else if(t1.lt.xb2.and.t2.ge.xb2) then
            icase=3
            return
c     intermediate part shaded
      else if(t1.gt.xb1.and.t2.lt.xb2) then
           icase=4
           return
      end if
 30   if(iii.eq.0) return
      t1=t3
      t2=t4
      iii=0
      go to 31
      end

      subroutine sciss(hb,d,s,nb,iscis,ie)
      include "cluster.inc"
      dimension hb(3,*),d(nemax,*),s(*),x(3)
c*****scissoring conditions*****************************************
c     if x is out of range then iscis=1 else iscis=0
c*******************************************************************

c      call cpyvec(s,x,3)
      call vcpyr(s,x,3)
      call xxx(x)
      do i=1,nb
         dx=hb(1,i)*x(1)+hb(2,i)*x(2)+hb(3,i)*x(3)
c        write(6,*) 'x=',x,' hb=',(hb(j,i),j=1,3),'dx=',dx
         if(nb.ge.0) then
            if(dx.gt.d(i,1)) go to 20
         else
            if(dx.gt.d(i,ie)) go to 20
         end if
      end do
      iscis=0
      return
 20   iscis=1
      return
      end

      subroutine bond(xb1,xb2,r,elmx,nelmx,ne,nwdt,ncol)
      dimension xb1(*),xb2(*),r(*),elmx(3,*),nelmx(*)
      dimension xs1(3),xs2(3),xc(3),n1(3)
      real n1
      integer gethkltoj
      data eps/0.0001/
c********************************************************************
c      plot a bond excluding blind parts
c********************************************************************
c
c     xb1: start coordinates of a bond in plotter system
c     xb2: end coordinates of a bond in plotter system
c     r(i,j): radius of j-th atom in i-th element
c     elmx(i,j,k) i-th coordinate of k-th atom in j-th element
c     nelmx(i): number of atoms in i-th element
c     ne: number of elements
c     nwdt: bond width
c     ncol: bond color
c*****search atoms on bond in projection plane
c     nn: number of atoms shding bond
      icount=0
 30   continue
      icount=icount+1
      if(icount.gt.10) then
         return
      end if
      xxmin=amin1(xb1(1),xb2(1))
      xymin=amin1(xb1(2),xb2(2))
      xzmin=amin1(xb1(3),xb2(3))
      xxmax=amax1(xb1(1),xb2(1))
      xymax=amax1(xb1(2),xb2(2))
      nn=0
      icase=0
      do ie=1,ne
         n=nelmx(ie)
         do jd=1,n
            j=n+1-jd
            iej=gethkltoj(ie,j)
            do ix=1,3
               xc(ix)=elmx(ix,iej)
            end do
            ien=gethkltoj(ie,n)
            if(xc(1).lt.xxmin-r(ien)) go to 40
            if(xc(2).lt.xymin-r(ien)) go to 40
            if(xc(3).lt.xzmin-r(ien)) go to 40
            if(xc(1).gt.xxmax+r(ien)) go to 40
            if(xc(2).gt.xymax+r(ien)) go to 40
            call shade(xb1,xb2,xc,r(iej),ics,n1,t1,t2)
            if(ics.eq.1) return
            if(ics.ne.0) then
               nn=nn+1
               if(nn.eq.1.or.(nn.gt.1.and.t1.lt.xmin)) then
                  xmin=t1
                  icase=ics
                  do ix=1,3
                     xs1(ix)=xb1(ix)+t1*n1(ix)
                     xs2(ix)=xb1(ix)+t2*n1(ix)
                  end do
               end if
            end if
 40         continue
         end do
      end do

c*****plot a bond*************************************************
      if(icase.eq.2) then
         if(nn.gt.1) go to 34
c     start point shaded
         call newpen(nwdt)
         call setcol(ncol)
         call plot(xs2(1),xs2(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      else if(icase.eq.3) then
c     end point shaded
         call newpen(nwdt)
         call setcol(ncol)
         call plot(xb1(1),xb1(2),3)
         call plot(xs1(1),xs1(2),2)
         return
      else if(icase.eq.4) then
c     intermediate part shaded
         call newpen(nwdt)
         call setcol(ncol)
         call plot(xb1(1),xb1(2),3)
         call plot(xs1(1),xs1(2),2)
         if(nn.gt.1) go to 34
         call newpen(nwdt)
         call setcol(ncol)
         call plot(xs2(1),xs2(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      else if(icase.eq.0) then
c     no blind case
         call newpen(nwdt)
         call setcol(ncol)
         call plot(xb1(1),xb1(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      else
         return
      end if
 34   continue
      do ix=1,3
         xb1(ix)=xs2(ix)+eps*n1(ix)
      end do
      go to 30
      end

      subroutine shade(x1,x2,xc,r,icase,n1,t1,t2)
      dimension x1(3),x2(3),xc(3)
      dimension n1(3),n2(3),y1(3),y2(3),y3(3),y4(3),y5(3)
      real l1,l2,m1,n1,n2,n1y2,n1y3,n2y2
      data eps/0.0001/
c*******************************************************
c                 blind parts of a bond
c*******************************************************
c     x1: start point vector (x,y,z in the plotter system)
c     x2: end point vector (x,y,z in the plotter system)
c     xc: circle center (x,y,z in the plotter system)
c     r : radius of circle in the plotter system
c
c
c     y1=x2-x1
c     y2=xc-x1
c     y3=xc-x2
c     vabs(x,n): absolute value of n-dimensional vector x
c     vinpr(x,y,n): inner product of n-dimensional vectors, x,y
      do ix=1,3
         y1(ix)=x2(ix)-x1(ix)
         y2(ix)=xc(ix)-x1(ix)
         y3(ix)=xc(ix)-x2(ix)
      end do
c     n1:unit vector for y1 in projection plane
      absy1=vabs(y1,2)
      if(absy1.gt.eps) then
         do ix=1,2
            n1(ix)=y1(ix)/absy1
         end do
      else
         do ix=1,2
            n1(ix)=0
         end do
      end if
c     unit vector for y1 in plotter system
      absy2=vabs(y1,3)
      do ix=1,3
         n2(ix)=y1(ix)/absy2
      end do
c     n1.y2 and n1.y3 on plojection plane
      n1y2=vinpr(n1,y2,2)
      n1y3=vinpr(n1,y3,2)
c     n2.y2 in plotter system
      n2y2=vinpr(n2,y2,3)
c     normal from atom to bond
      do ix=1,3
         y4(ix)=n2y2*n2(ix)-y2(ix)
      end do
      do  ix=1,2
         y5(ix)=n1y2*n1(ix)-y2(ix)
      end do
c*****conditions for shade**********************************
      absy43=vabs(y4,3)**2
      absy52=vabs(y5,2)**2
      r2=r**2
c*****no blind cases****************************************
      icase=0
c     the bond passes at the side of the circle
      if(r2.le.absy52) return
c     the bond passes on the circle
      if(y4(3).gt.eps.and.absy43.gt.r2) return
      l1=sqrt(r2-absy52)
      if(absy43.lt.r2) m1=sqrt(r2-absy43)
c     the bond does not reach the circle
      if(-l1.ge.n1y2.or.n1y3.ge.l1) return
c*****four blind cases**************************************
c     x1i,x1o start and end points of shade in plotter system
      l2=-l1
      if(absy43.gt.r2) go to 20
      if((n2y2-m1)*n2(3).gt.y2(3)-eps) l2=-m1*vabs(n2,2)
      if((n2y2+m1)*n2(3).gt.y2(3)-eps) l1=m1*vabs(n2,2)
 20   t1=n1y2+l2
      t2=n1y2+l1
c     case 1: completely blind
      if(t1.lt.0.0.and.t2.gt.absy1) icase=1
      if(icase.eq.1) return
c     case 2: start point shaded
      if(t1.lt.0.0.and.t2.gt.0.0) icase=2
c     case 3: end point shaded
      if(t1.lt.absy1.and.t2.gt.absy1) icase=3
c     case 4: intermediate part shaded
      if(t1.gt.0.0.and.t2.lt.absy1) icase=4
      return
      end

      subroutine getarc(x1,r1,i1,n1,arc,narc,r,elmx,nelmx,ne)
      dimension x1(*),x2(3),r(*),elmx(3,*),nelmx(*),arc(2,*)
      include "cluster.inc"
      integer acol,bwdt,bcol,ccol,dcol
      common /ccolor/ acol(nemax),bwdt(nemax),bcol(nemax),ccol,dcol,
     *                jmod,ldev
      integer gethkltoj
      data eps/0.0001/
c******************************************************************
c     calculate blind parts of an atom at x1
c******************************************************************
c     x1: atom position
c     r1: radius of the atom
c     i1,n1 specify the kind and lacation of the atom
c        i1: i1-th element
c        n1: n1-th atom of i1-th element
c     arc: start and end angles of arc (a part of the atom)
c     narc: number of arcs in the atom
c     r(i,j):   atom radius of j-th atom in i-th element
c     elmx(i,j,k) i-th coordinate of k-th atom in j-th element
c     nelmx(i): number of atoms in i-th element
c     ne: number of elements
      xb1=0
      xb2=1
      narc=0
c      xb1, xb2: initial and final angle of a part of circle
 30   nn=0
      icase=0
      do ie=1,ne
         n=nelmx(ie)
         do jd=1,n
            j=n+1-jd
            do ix=1,3
               iej=gethkltoj(ie,j)
               x2(ix)=elmx(ix,iej)
            end do
            iej=gethkltoj(ie,j)
            r2=r(iej)
            if(ie.ne.i1.or.j.ne.n1) then
c     calculate shaded part of atom (x2,r2)
               call cross(xb1,xb2,x1,r1,x2,r2,ics,t1,t2,iii)
               if(ics.eq.1) then
c     complitely shaded
                  return
               else if(ics.eq.0) then
c     no shading
                  go to 40
               end if
               if(iii.eq.0) nn=nn+1
               if(iii.eq.1) nn=nn+2
c     nn: number of shaded parts in atom (x2,r2)
               if(nn.eq.1+iii.or.(nn.gt.1.and.t1.lt.xmin)) then
                  xmin=t1
                  icase=ics
                  xs1=t1
                  xs2=t2
c     start and end angles of blind part
               end if
            end if
 40         continue
         end do
      end do
c******************put arc****************************
      if(icase.eq.2) then
           if(nn.gt.1) go to 34
c          start point shaded
           call putarc(xs2,xb2,arc,narc)
           return
      else if(icase.eq.3) then
c          end point shaded
           call putarc(xb1,xs1,arc,narc)
           return
      else if(icase.eq.4) then
c          intermediate part shaded
           call putarc(xb1,xs1,arc,narc)
           if(nn.gt.1) go to 34
           call putarc(xs2,xb2,arc,narc)
           return
      else if(icase.eq.0) then
c          nonshading case
           call putarc(xb1,xb2,arc,narc)
           return
      end if
 34   continue
c     take new initial angle for calculation of shade by other atom
      do ix=1,3
         xb1=xs2+eps
      end do
      go to 30
      end

      subroutine putarc(x1,x2,arc,narc)
      real arc(2,*)
      narc=narc+1
      arc(1,narc)=x1
      arc(2,narc)=x2
      return
      end

      subroutine gipcca(x1,r1,x2,r2,xc1,xc2,n)
      dimension x1(3),x2(3),xc1(2),xc2(2),xc(2),yc(2)
c*****************************************************************
c           cross points in two circles
c*****************************************************************
c     x1: center of circle1  (x,y,z in plotter system)
c     r1: radius of circle1
c     x2: center of circle2  (x,y,z in plotter system)
c     r2: radius of circle2
c     xc1: cross point 1
c     xc2: cross point 2
c     n:   number of cross points
c         gipcc1: subroutine in grace 4
      call gipcc1(x1(1),x1(2),r1,x2(1),x2(2),r2,xc,yc,n,ill)
      xc1(1)=xc(1)
      xc1(2)=yc(1)
      xc2(1)=xc(2)
      xc2(2)=yc(2)
      return
      end

      subroutine bond2(xb1,xb2,r,elmx,nelmx,ne,bwdt,bcol)
      dimension xb1(*),xb2(*),r(*),elmx(3,*),nelmx(*)
      dimension xs1(3),xs2(3),xc(3),n1(3)
      integer bwdt,bcol
      real n1
      integer gethkltoj
      data eps/0.0001/
c********************************************************************
c      plot a bond excluding blind parts
c********************************************************************
c
c     xb1: start coordinates of a bond in plotter system
c     xb2: end coordinates of a bond in plotter system
c     r(i,j): radius of j-th atom in i-th element
c     elmx(i,j,k) i-th coordinate of k-th atom in j-th element
c     nelmx(i): number of atoms in i-th element
c     ne: number of elements
c*****search atoms on bond in projection plane
c     nn: number of atoms shding bond
 30   continue
      xxmin=amin1(xb1(1),xb2(1))
      xymin=amin1(xb1(2),xb2(2))
      xzmin=amin1(xb1(3),xb2(3))
      xxmax=amax1(xb1(1),xb2(1))
      xymax=amax1(xb1(2),xb2(2))
      nn=0
      icase=0
      do ie=1,ne
         n=nelmx(ie)
         do jd=1,n
            j=n+1-jd
            iej=gethkltoj(ie,j)
            do ix=1,3
               xc(ix)=elmx(ix,iej)
            end do
            ien=gethkltoj(ie,n)
            if(xc(1).lt.xxmin-r(ien)) go to 40
            if(xc(2).lt.xymin-r(ien)) go to 40
            if(xc(3).lt.xzmin-r(ien)) go to 40
            if(xc(1).gt.xxmax+r(ien)) go to 40
            if(xc(2).gt.xymax+r(ien)) go to 40
            call shade(xb1,xb2,xc,r(iej),ics,n1,t1,t2)
            if(ics.eq.1) return
            if(ics.eq.0) go to 40
            nn=nn+1
            if(nn.eq.1) go to 44
            if(nn.gt.1.and.t1.lt.xmin) go to 44
            go to 40
 44         xmin=t1
            icase=ics
            do ix=1,3
               xs1(ix)=xb1(ix)+t1*n1(ix)
               xs2(ix)=xb1(ix)+t2*n1(ix)
            end do
 40         continue
         end do
      end do
c*****plot a bond*************************************************
      if(icase.eq.2) then
         if(nn.gt.1) go to 34
c     start point shaded
         call newpen(bwdt)
         call plot(xs2(1),xs2(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      else if(icase.eq.3) then
c     end point shaded
         call newpen(bwdt)
         call plot(xb1(1),xb1(2),3)
         call plot(xs1(1),xs1(2),2)
         return
      else if(icase.eq.4) then
c     intermediate part shaded
         call newpen(bwdt)
         call plot(xb1(1),xb1(2),3)
         call plot(xs1(1),xs1(2),2)
         if(nn.gt.1) go to 34
         call newpen(bwdt)
         call plot(xs2(1),xs2(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      else if(icase.eq.0) then
c     no blind case
         call newpen(bwdt)
         call plot(xb1(1),xb1(2),3)
         call plot(xb2(1),xb2(2),2)
         return
      end if
 34   continue
      do ix=1,3
         xb1(ix)=xs2(ix)+eps*n1(ix)
      end do
      go to 30
      end
