c
c  get denxyz.map file from binary .xyz file
c
      character*80 flnm
      parameter (ntmax=1000*1000)
      real den(0:ntmax-1)

      write(6,'(a,$)') 'number of divisions along x y z axes='
      read(5,*) ix,iy,iz
      if(nt.gt.ntmax) then
         write(6,*) 'ix=',ix,' iy=',iy,' iz=',iz
         write(6,*) 'ix*iy*iz > ntmax', 'ntmax=',ntmax
         stop
      end if
      write(6,*) 'ix,iy,iz=',ix,iy,iz

      write(6,'(a,$)') 'file name of .xyz file='
      read(5,*) flnm
      nt=ix*iy*iz
      open(3,file=flnm,status='OLD',form='unformatted')
      read(3) (den(j),j=0,nt-1)
      close(3)

      open(7,file='denxyz.map',status='UNKNOWN')
      do i=0,iz-1
         k0=i*ix*iy
         write(7,*) (den(k+k0),k=0,ix*iy-1)
      end do
      close(7)
      stop
      end
