      subroutine setqxqy(iax,iqx,iqy)
      integer iax(*)
      common /cqxqy/ iqxd(0:12),iqyd(0:12)
      include 'drwmap.inc'
      integer getjbc
      parameter (tau=1.618034)
      data (iqxd(i),i=0,12) /1,1,1,2,1,2,3,4,5,0,4,5,4/
      data (iqyd(i),i=0,12) /2,2,3,3,4,5,6,5,6,0,5,6,6/
      data pi /3.1415926536/
      call getsys(isys)
      iqx=iax(1)
      iqy=iax(2)
c     fact=getfact(isys)
      fact=1
      write(6,*) 'iqx,iqy=',iqx,iqy
      fx=getleng(iqx)*fact
      fy=getleng(iqy)*fact
      call xscale(xmin,xmax,xdiv,fx)
      call xscale(ymin,ymax,ydiv,fy)
      return
      end

      subroutine setqxqyqz(iax,iqx,iqy,iqz)
      integer iax(*)
      common /cqxqy/ iqxd(0:12),iqyd(0:12)
      include 'drwmap.inc'
      integer getjbc
      iqx=iax(1)
      iqy=iax(2)
      iqz=iax(3)
      write(6,*) 'iqx,iqy,iqz=',iqx,iqy,iqz
      call getac(al,cl)
      call getsys(isys)
c     fact=getfact(isys)
      fact=1
      fx=getleng(iqx)*fact
      fy=getleng(iqy)*fact
      fz=getleng(iqz)*fact
      call xscale(xmin,xmax,xdiv,fx)
      call xscale(ymin,ymax,ydiv,fy)
      call xscale(zmin,zmax,zdiv,fz)
      return
      end
      
      function getleng(i)  ! get length of i-th axis
      common /cjbc/ jbc,xs(6),iax(6),ipers
      common /ctr/ itr(6,6)
      real x(6),q(6)
      do j=1,6
         x(j)=itr(i,j)
      end do
      call getqe0(x,q)
      getleng=vabs(q,3)
      return
      end

      function getleng0(i)  ! get length of i-th axis
      common /cjbc/ jbc,xs(6),iax(6),ipers
      common /ctr/ itr(6,6)
      real x(6),q(6)
      do j=1,6
         x(j)=itr(i,j)
      end do
      call getqe00(x,q)
      getleng0=vabs(q,3)
      return
      end

      subroutine xscale(xmin,xmax,xdiv,scl)
      xmin=xmin*scl
      xmax=xmax*scl
      xdiv=xdiv*scl
      return
      end

      subroutine readst1234()  ! read s and t matrices
      real s1(3,3),s2(3,3),s3(3,3),s4(3,3)
      real t1(3,3),t2(3,3),t3(3,3),t4(3,3)
      common /otrfm/ si(6,6),sr(6,6),ti(6,6),tr(6,6)
c     orthogonal transformation matrix s1, s2, s3, s4
      integer getjbc
      call freadrv('s1=',9,s1,1)
      call freadrv('s2=',9,s2,1)
      call freadrv('s3=',9,s3,1)
      call freadrv('s4=',9,s4,1)
      call trnsp3(s1)
      call trnsp3(s2)
      call trnsp3(s3)
      call trnsp3(s4)
      call buildst(s1,s2,s3,s4,sr,si)
      write(6,*) 'transformation matrix for q system'
      call wtmtrxrf('sr',sr,6,'(6f10.5)')
      call wtmtrxrf('si',si,6,'(6f10.5)')
      if(getjbc().eq.-1) then
         return
      end if
      call freadrv('t1=',9,t1,1)
      call freadrv('t2=',9,t2,1)
      call freadrv('t3=',9,t3,1)
      call freadrv('t4=',9,t4,1)
      call trnsp3(t1)
      call trnsp3(t2)
      call trnsp3(t3)
      call trnsp3(t4)
      call buildst(t1,t2,t3,t4,tr,ti)
      call wtmtrxrf('tr',tr,6,'(6f10.5)')
      call wtmtrxrf('ti',ti,6,'(6f10.5)')
      return
      end

      subroutine buildst(s1,s2,s3,s4,sr,si)
      real s1(3,3),s2(3,3),s3(3,3),s4(3,3),sr(6,6),si(6,6)
      real b(6),piv(6)
      integer ipv(6),ind(2*6)
      do i=1,3
         do j=1,3
            si(i,j)=s1(i,j)
            sr(i,j)=s1(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i+3,j+3)=s2(i,j)
            sr(i+3,j+3)=s2(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i,j+3)=s3(i,j)
            sr(i,j+3)=s3(i,j)
         end do
      end do
      do i=1,3
         do j=1,3
            si(i+3,j)=s4(i,j)
            sr(i+3,j)=s4(i,j)
         end do
      end do
      call matinv(si,6,6,b,0,det,ipv,ind,piv)
      return
      end

      subroutine setd()
      common /cgethk/ d0(6,6),d1(3,3) ! for crystal
      common /cisys/ isys
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real y(3,3)  ! wave vectors
      save icount
      real*4 sr,ct,c1,c2,c3,c4,s1,s2,s3,s4,su,cu
      data icount /0/
      isub=1
      call gety(y,isub)
      call unitmtrxr(d0,6)      ! unit matrix
      call zeromtrxr(d1,3)       ! deformation matrix for non standard embedding
      icount=icount+1
      if(icount.eq.1) then
c     for standard setting for modulated structure
         do i=1,3
            do j=1,3
               d0(i,3+j)=d0(i,3+j)+d1(i,j)
            end do
         end do
         do i=1,3
            do j=1,3
               d0(3+i,j)=d0(3+i,j)+y(i,j)
            end do
         end do
      end if
      call mcpy(d0,fq)
      call setdr()
      call wtmtrxrf('dr',dr,6,'(6f8.4)')
      call wtmtrxrf('dq',dq,6,'(6f8.4)')
      return
      end

      subroutine setdr()
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      real piv(6),b(6),det
      integer ipv(6),ind(6,2)
      common /cgetd/ det
      call mcpy(dq,dr)
      call matinv(dr,6,6,b,0,det,ipv,ind,piv)
c     write(6,*) 'det in setdr',det
      return
      end

      subroutine getdet(det0)
      common /cgetd/ det
      det0=det
      return
      end

      subroutine getqi00(h,q)
      integer h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+h(j)*dq(j,i)
         end do
      end do
      return
      end

      subroutine getqi0(h,q)
      integer h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      call getqi00(h,q)
      call rltscale(q)
      return
      end

      subroutine getqi(h,q)
      integer h(*)
      real q(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getqi00(h,qd)
c     phason distortion in reciprocal space
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+qd(j)*di(j,i)
         end do
      end do
      call rltscale(q)
      return
      end

      subroutine getqe00(x,q)
      real x(*),q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+dr(i,j)*x(j)
         end do
      end do
      return
      end

      subroutine getqe0(x,q)
      real x(*),q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getqe00(x,q)
      call ltscale(q)
      return
      end

      subroutine rltscale(q)
      real q(*)
      call getltcs(as,bs,cs,cosas,cosbs,coscs)
      q(1)=q(1)*as
      q(2)=q(2)*bs
      q(3)=q(3)*cs
      return
      end

      subroutine ltscale(q)
      real q(*)
      call getsys(isys)
      call getltc(a,b,c,cosa,cosb,cosc)
      q(1)=q(1)*a
      q(2)=q(2)*b
      q(3)=q(3)*c
      return
      end

      subroutine deform(qd,q)
      real q(*),qd(*)
      return
      end

      subroutine getqe(x,q)
      real x(*),q(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getqe00(x,qd)
      call deform(qd,q)
      call ltscale(q)
      return
      end

      subroutine getxe(q,x)
      real q(*),x(*)
      real qd(6)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call vcpyr(q,qd,6)
      call rltscale(qd)
      call getxe00(qd,x)
      return
      end

      subroutine getxe00(q,x)
      real q(*),x(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         x(i)=0.
         do j=1,6
            x(i)=x(i)+dq(i,j)*q(j)
         end do
      end do
      return
      end

      subroutine setac(a,c)
      real dr,dq
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      if(isys.le.2) then
         al=a
         cl=a
      else
         al=a
         cl=c
      end if
      return
      end

      subroutine seteps(eps1d,eps2d,eps3d,eps4d)
      real dr,dq
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      eps1=eps1d
      eps2=eps2d
      eps3=eps3d
      eps4=eps4d
      return
      end

      subroutine getqir(h,q)
      real h(*)
      real q(*)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call getsys(isys)
      do i=1,6
         q(i)=0.
         do j=1,6
            q(i)=q(i)+h(j)*dq(j,i)
         end do
      end do
      call rltscale(q)
      return
      end

      subroutine setumtrx(isetting)  ! set 6x3 u matrix
      common /cu1u2/ u1(3,3),u2(3,3)
      common /cuvmtrx/ u(6,3), v(6,3)
      call setu1mtrx(isetting)
      call setu2mtrx()
      do i=1,3
         do j=1,3
            u(i,j)=u1(i,j)
            u(i+3,j)=u2(i,j)
         end do
      end do
      return
      end

      subroutine  setu1mtrx(isetting)
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      common /kwave/ y(3,3,3),vc(3)
      common /cu1u2/ u1(3,3),u2(3,3)
c     calculate
c      integer getisys
c      isys=getisys()
      call getsys(isys)
      sqrtd=sqrt(1.0-cosas**2-cosbs**2-coscs**2+
     *        2.0*cosas*cosbs*coscs)
      if(isetting.eq.3) then
         u1(1,1)=as
         u1(1,2)=0.0
         u1(1,3)=0.0
         u1(2,1)=bs*coscs
         u1(2,2)=bs*sincs
         u1(2,3)=0.0
         u1(3,1)=cs*cosbs
         u1(3,2)=cs*(cosas-cosbs*coscs)/sincs
         u1(3,3)=cs*sqrtd/sincs
      else if(isetting.eq.2) then
         u1(1,1)=as*sqrtd/sinas
         u1(1,2)=as*coscs
         u1(1,3)=as*(cosbs-coscs*cosas)/sinas
         u1(2,1)=0
         u1(2,2)=bs
         u1(2,3)=0
         u1(3,1)=0
         u1(3,2)=cs*cosas
         u1(3,3)=cs*sinas
      else if(iseitting.eq.1) then
         u1(1,1)=as*sinbs
         u1(1,2)=0
         u1(1,3)=as*cosbs
         u1(2,1)=bs*(coscs-cosas*cosbs)/sinbs
         u1(2,2)=bs*sqrtd/sinbs
         u1(2,3)=bs*cosas
         u1(3,1)=0
         u1(3,2)=0
         u1(3,3)=cs
      end if
      return
      end

      subroutine  setu2mtrx()
      common /kwave/ y(3,3,3),vc(3)
      common /cu1u2/ u1(3,3),u2(3,3)
      do i=1,3
         do j=1,3
            u2(i,j)=0
            do k=1,3
               u2(i,j)=u2(i,j)+y(k,i,1)*u1(k,j)
            end do
         end do
      end do
      return
      end

      subroutine readlc()
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      call freadr('a=',1,a,1)
      call freadr('b=',1,b,0)
      call freadr('c=',1,c,0)
      call freadr('cosa=',1,cosa,0)
      call freadr('cosb=',1,cosb,0)
      call freadr('cosc=',1,cosc,0)
      sina=sqrt(1.0-cosa**2)
      sinb=sqrt(1.0-cosb**2)
      sinc=sqrt(1.0-cosc**2)
      return
      end

      subroutine calltcs1() ! calculate lattice const in reciprocal space
      common /ltccnt1/ a,b,c,cosa,cosb,cosc,sina,sinb,sinc
      common /ltccnt2/ as,bs,cs,cosas,cosbs,coscs,sinas,sinbs,sincs
      real gabs(3,3),bd(3),piv(3)
      integer ip(3),indx(6)
      gabs(1,1)=a*a
      gabs(2,2)=b*b
      gabs(3,3)=c*c
      gabs(1,2)=a*b*cosc
      gabs(1,3)=a*c*cosb
      gabs(2,3)=b*c*cosa
      gabs(2,1)=gabs(1,2)
      gabs(3,1)=gabs(1,3)
      gabs(3,2)=gabs(2,3)
      call matinv(gabs,3,3,bd,0,det,ip,indx,piv) !  matrix inversion of gabs
      as=sqrt(gabs(1,1))
      bs=sqrt(gabs(2,2))
      cs=sqrt(gabs(3,3))
      cosas=gabs(2,3)/bs/cs
      cosbs=gabs(3,1)/cs/as
      coscs=gabs(1,2)/as/bs
      sinas=sqrt(1.0-cosas**2)
      sinbs=sqrt(1.0-cosbs**2)
      sincs=sqrt(1.0-coscs**2)
      return
      end

      subroutine rdkvctr(ndm)
      common /kwave/ y(3,3,3),vc(3)
      call freadi('ndm=',1,ndm,1)
      do i=1,ndm
         call freadrv('k=',3,y(1,i,1),1)
      end do
      return
      end

      subroutine readVmtrx()
      common /cuvmtrx/ u(6,3), v(6,3)
      call freadi('iseging=',1,iseting,1)
      call freadrv('v=',18,v,0)
      return
      end

      subroutine setdqmtrx()
      common /cuvmtrx/ u(6,3), v(6,3)
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,3
            dq(i,j)=u(i,j)
            dq(i,j+3)=v(i,j)
         end do
      end do
      return
      end

      subroutine reads1234()  ! read s1,s2,s3,s4 matrices for crystals
      real s1(3,3),s2(3,3),s3(3,3),s4(3,3)
      common /otrfm/ si(6,6),sr(6,6),ti(6,6),tr(6,6)
c     orthogonal transformation matrix s1, s2, s3, s4
      integer getjbc
      call freadrv('s1=',9,s1,1)
      call freadrv('s2=',9,s2,1)
      call freadrv('s3=',9,s3,1)
      call freadrv('s4=',9,s4,1)
      call trnsp3(s1)
      call trnsp3(s2)
      call trnsp3(s3)
      call trnsp3(s4)
      call buildst(s1,s2,s3,s4,sr,si)
      write(6,*) 'transformation matrix for q system'
      call wtmtrxrf('sr',sr,6,'(6f10.5)')
      call wtmtrxrf('si',si,6,'(6f10.5)')
      return
      end
