c
c     r-factor calculations for every 100 strongest reflections
c                          (filter)
c
      parameter (nhkl=6000)
      integer h(6,nhkl)
      real fo(nhkl),fc(nhkl),sig(nhkl),phas(nhkl)
      real q(6)
      real qe(nhkl)  ! for sort
      integer st(2*nhkl),ip(nhkl) ! for sort
      integer hr(6)
      real sm(100),dm(100),swm(100),dwm(100)
      real ss(100),ds(100),sws(100),dws(100)
      integer nm(100),ns(100)
      character(80) frmt
      integer evenodd
      frmt='(6i4,2f11.3,f11.4,f11.4)'
      call zerov(sm,100)
      call zerov(dm,100)
      call zerov(swm,100)
      call zerov(dwm,100)
      call zerov(ss,100)
      call zerov(ds,100)
      call zerov(sws,100)
      call zerov(dws,100)
      call zerovi(nm,100)
      call zerovi(ns,100)
      isys=1
      call setidm(6)
      call setsys(isys)
      call setd()
      n=0
 100  continue
      read(5,*,end=200) hr,for,fcr,phr
      n=n+1
      call vcpyi(hr,h(1,n),6)
      fo(n)=for
      fc(n)=fcr
      phas(n)=phr
      sig(n)=1.
      go to 100
 200  continue
      nh=n
      write(6,*) 'nh=',nh
      do i=1,nh
         qe(i)=fo(i)
      end do
      call qsortd(qe,st,ip,nh)
      do i=1,nh
         nr=i/100+1             ! slice number
         n=ip(i)                ! old index
c        write(6,'(6i4,2f11.3)') (h(j,n),j=1,6),fo(n),fc(n)
c        write(6,*) 'ip(i)=',ip(i),' nr=',nr
         if(evenodd(h(1,n)).eq.0) then ! main reflection
            nm(nr)=nm(nr)+1
            sm(nr)=sm(nr)+fo(n)
            dm(nr)=dm(nr)+abs(fo(n)-fc(n))
            swm(nr)=swm(nr)+fo(n)**2/sig(n)**2
            dwm(nr)=dwm(nr)+(fo(n)-fc(n))**2/sig(n)**2
         else
            ns(nr)=ns(nr)+1
            ss(nr)=ss(nr)+fo(n)
            ds(nr)=ds(nr)+abs(fo(n)-fc(n))
            sws(nr)=sws(nr)+fo(n)**2/sig(n)**2
            dws(nr)=dws(nr)+(fo(n)-fc(n))**2/sig(n)**2
         end if
      end do
      write(6,*) 'r-factor by each 100 strongest reflections'
      do ir=1,(nh-1)/100+1
c         write(6,'(a,2(2f10.2,i4))') 'swm,dwm,nm,sws,dws,ns',
c     *        swm(ir),dwm(ir),nm(ir),sws(ir),dws(ir),ns(ir)
         write(6,'(4(a,f10.5))')
     *        ' rwm=',sqrt(dwm(ir)/swm(ir)),
     *        ' rws=',sqrt(dws(ir)/sws(ir)),
     *        ' rm =',dm(ir)/sm(ir),
     *        ' rs =',ds(ir)/ss(ir)
      end do
      write(6,*) 'rfactors for strongest n*100 reflections '
      do ir=1,(nh-1)/100+1
         sms=0
         sss=0
         dms=0
         dss=0
         swms=0
         swss=0
         dwms=0
         dwss=0
         do jr=1,ir
            sms=sms+sm(jr)
            dms=dms+dm(jr)
            sss=sss+ss(jr)
            dss=dss+ds(jr)
            swms=swms+swm(jr)
            dwms=dwms+dwm(jr)
            swss=swss+sws(jr)
            dwss=dwss+dws(jr)
         end do
         write(6,'(4(a,f10.5))')
     *        ' rwms=',sqrt(dwms/swms),
     *        ' rwss=',sqrt(dwss/swss),
     *        ' rms =',dms/sms,
     *        ' rss =',dss/sss
      end do
      stop
      end

      integer function evenodd(hkl)
      integer hkl(6)
      evenodd=mod(hkl(1),2)
      return
      end
     
      subroutine quit(str)
      character(*) str
      write(6,*) str
      stop
      end

      subroutine getbrv(brv)
      character brv
      return
      end

      subroutine setidm(idmd)
      common /cidm/ idm
      idm=idmd
      return
      end

      integer function getidm()
      common /cidm/ idm
      getidm=idm
      return
      end

