c
c           only for decagonal phase
c      coordinate transformation from the superstructure to the normal phase
c
      real xd(6),yd(6)
 100  continue
      write(6,'(a,$)') 'xs='
      read(5,*) xd
      call tr6to5e(xd,yd)
      call celltr(yd,-1)
      call tr5to6e(yd,xd)
      write(6,'(a,6f10.5)') 'x0=',xd
      go to 100
      stop
      end

      subroutine celltr(x,mode)
      real x(*)
      real xd(6),trm1(6,6),trm2(6,6)
      save trm1,trm2
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,

     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      if(mode.eq.1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm1(i,j)*x(j)/5.
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else if(mode.eq.-1) then
         do i=1,6
            xd(i)=0
            do j=1,6
               xd(i)=xd(i)+trm2(i,j)*x(j)
            end do
         end do
         do i=1,6
            x(i)=xd(i)
         end do
      else
         call quit('invalid mode in celltr')
      end if
      return
      end

      subroutine quit(str)
      character*(*) str
      write(6,*) str
      call exit()
      end
      
      subroutine tr5to6e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1,0,0,0,-1,0,
     *         0,1,0,0,-1,0,
     *         0,0,1,0,-1,0,
     *         0,0,0,1,-1,0,
     *         0,0,0,0, 0,1,
     *         0,0,0,0, 0,0/
      do 12 j=1,6
         fi(j)=0.
         do 13 k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)
 13      continue
 12   continue
      return
      end

      subroutine tr6to5e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 1, 0,
     *        -1, 4,-1,-1, 1, 0,
     *        -1,-1, 4,-1, 1, 0,
     *        -1,-1,-1, 4, 1, 0,
     *        -1,-1,-1,-1, 1, 0,
     *         0, 0, 0, 0, 0, 1/
      do 12 j=1,6
         fi(j)=0.
         if(j.le.4) then
             do 13 k=1,5
             fi(j)=fi(j)+sd(j,k)*ei(k)/5
 13          continue
         else if (j.eq.5) then
             fi(5)=ei(6)
             fi(6)=0
         end if
 12   continue
      return
      end
