c
c             plot10 graphic subroutine library for sun3
c
c          graphic subroutine library for apple laserwriter
c                        and tektronix rasterizer
c            for tektronix 4510a rasterizer dev should be 3
c                  and 1 or 4  for apple laserwriter
c             postscript commands are  created in 'temp:ps'
c
c        circle and ellipse are not included in calcomp
c        but are efficient to draw circles and ellipses
c        by apple laserwriter.  to fill a circle or ellipse
c        or poligon written by line with gray
c        call fillarea with ncol>0 before circle or
c        ellipse and use 1-10 for ncol (1-9 gray 10 black)
c        line color and text color are set by linecolor
c        for tektronix, newpen changes line and text color while
c        it changes line-width for lasewriter
c
      subroutine initt(icps)
      common /iterm/trmfac
      data trmfac/4096./
      r=780./1023.
      call plots(0.,0.,1)
      call dwindo(0.,trmfac,0.,trmfac*r)
      call twindo(0.,1.,0.,r)
      return
      end

      subroutine finitt(xdummy,ydummy)
      call plote(' ')
      return
      end

      subroutine vwindo(x1,x2,y1,y2)
      call window(x1,y1,x1+x2,y1+y2)
      return
      end

      subroutine dwindo(x1,x2,y1,y2)
      call window(x1,y1,x2,y2)
      return
      end

      subroutine swindo(xmin,xmax,ymin,ymax)
      integer xmin,xmax,ymin,ymax
      common /iterm/trmfac
      x1=xmin/trmfac
      x2=xmax/trmfac
      y1=ymin/trmfac
      y2=ymax/trmfac
      call viewpt(x1,y1,x1+x2,y1+y2)
      return
      end

      subroutine twindo(xmin,xmax,ymin,ymax)
      real xmin,xmax,ymin,ymax
      common /iterm/trmfac
      x1=xmin/trmfac
      x2=xmax/trmfac
      y1=ymin/trmfac
      y2=ymax/trmfac
      call viewpt(x1,y1,x2,y2)
      return
      end

      subroutine movea(x,y)
      call plot(x,y,3)
      return
      end

      subroutine drawa(x,y)
      call plot(x,y,2)
      return
      end

      subroutine dasha(x,y,il)
      real x,y
      integer il
      if(il.eq.0) then
         call lntyp(0)
      else if(il.eq.1) then
         call lntyp(20)
      else if(il.eq.2) then
         call lntyp(30)
      else if(il.eq.3) then
         call lntyp(10)
      else
         write(6,*) 'undefined line type used in dasha'
         stop
      end if
      call drawa(x,y)
      return
      end

      subroutine term(iterm,iscal)
      common /iterm/trmfac
      trmfac=iscal
      return
      end

      subroutine rscale(facfig)
      call factor(facfig)
      return
      end

      subroutine erase
      return
      end

