      subroutine resetja(jaslct,na)  ! set 2 for jaslct if p0=0
      integer jaslct(*)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      do n=1,na
         if(p0(n).eq.0.and.jaslct(n).ne.0) then
            jaslct(n)=2
         end if
      end do
      return
      end

      integer function getnth(n)
      include 'impr8.inc'
      include 'qcstrc.inc'
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *     mej(3,nemax,namax)
      getnth=nth(n)
      return
      end

      function getramin0(i)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getramin0=ramin0(i)
      return
      end

      function getramax0(i)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getramax0=ramax0(i)
      return
      end

      function getp0(i)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      getp0=p0(i)
      return
      end

      subroutine gets1s20(i,s10,s20)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      s10=s0(1,i)
      s20=s0(2,i)
      return
      end

      subroutine rdap(na)
      call rdap1(na)
      return
      end

      subroutine rdap1(na)
      include 'impr8.inc'
      include 'qcstrc.inc'
      common /cwflag/ iwflag(6)
      character(6) atom
      common /cltc/ atom(namax)
      real x0,u01,u02,u03,v0,be0,bi0
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real ramin00,ramax00
      common /copd1/ ramin00(namax),ramax00(namax)
      real ej0
      common /copd2/ ej0(6,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real fj
      common /cstfc5d/ fj(6,nemax,namax)
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      real q(6),xd(7),yd(6)
      real q1(6),q2(6),q3(6)
      real xjd(6)
      integer getisys,getjsimod,getapprx
      data eps /0.00001/

      isys=getisys()
      call getinp(inpu)
      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(6,301) na
         write(6,'(2a)')
     *      'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *      '       s1      s2'
      end if

      if(isys.ne.5) then
         nd=6
      else
         nd=7
      end if

c      jsimod=getjsimod()
c      write(6,*) 'jsimod=',jsimod

      do i=1,na
         read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *        be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),s0(2,i)
         if(ish(i).ne.0.and.nej(i).gt.nemax) call quit('ne > nemax')
         call freadrv('x=',6,x0(1,i),1)
         call freadrv('xe1=',nd,xe1d,1)
         call freadr('u1=',1,u01(i),0)
         call freadrv('xe2=',nd,xe2d,1)
         call freadr('u2=',1,u02(i),0)
         call freadrv('xe3=',nd,xe3d,1)
         call freadr('u3=',1,u03(i),0)
         call freadrv('xi=',nd,xid,1)
         call freadr('v=',1,v0(i),0)

         if(ish(i).eq.-1.or.ish(i).eq.0) then
            do j=1,nej(i)
               call freadrv('ej=',nd,fj(1,j,i),1)
            end do
         else if(ish(i).gt.0) then
            nej(i)=nej0(ish(i))
            do j=1,nej(i)
               call vcpyr(ej0(1,j,ish(i)),fj(1,j,i),nd)
            end do
         end if

         if(ish(i).ge.0) then
            if(ish(i).eq.0) then
               call freadi('nth=',1,nth(i),1)
               isyd(i)=1
               if(nth(i).gt.nemax) call quit('nth > nemax')
               do j=1,nth(i)
                  if(isys.le.2) then
                     call freadiv(' ',3,mej(1,j,i),0)
                  else
                     call freadiv(' ',2,mej(1,j,i),0)
                  end if
               end do
            else
               call freadi('isyd=',1,isyd(i),1)
               nth(i)=nth0(ish(i))
               if(nth(i).eq.0) then
                  write(6,*) 'i,isyd(i)=',i,isyd(i)
                  call quit('nth(i)=0 in rdap')
               end if
               do j=1,nth(i)
                  if(isys.le.2) then
                     call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),3)
                  else
                     call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),2)
                  end if
               end do
            end if
         end if
         if(iwflag(3).eq.1) then
            write(6,302) ik,atom(i),ien(i),ish(i),nej(i),
     *           be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),
     *           s0(2,i)
            write(6,303) 'x =', (x0(j,i),j=1,6)
            
            if(isys.ne.5) then
               write(6,306) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
               write(6,306) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
               write(6,306) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
               write(6,306) 'xi =', (xid(j),j=1,nd),'v= ',v0(i)
            else
               write(6,303) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
               write(6,303) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
               write(6,303) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
               write(6,303) 'xi= ', (xid(j),j=1,nd),'v= ',v0(i)
            end if
            if(ish(i).ge.0) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,nd)
               end do
               if(isys.le.2) then
                  write(6,304) ('(',(mej(k,j,i),k=1,3),j=1,nth(i))
               else
                  write(6,305) ('(',(mej(k,j,i),k=1,2),j=1,nth(i))
               end if
               write(6,*) 'isyd=',isyd(i)
            else if(ish(i).eq.-1) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,nd)
               end do
            end if
         end if

c     ve and vi components
         call trhtole(xe1d)     ! tr6to5d etc
         call trhtole(xe2d)
         call trhtole(xe3d)
         call trhtole(xid)          
         call prjext1(xe1d,xe1(1,i))  ! projection onto external space
         call prjext1(xe2d,xe2(1,i))
         call prjext1(xe3d,xe3(1,i))
*************
         call prjint(xid,xi(1,i)) ! projection onto internal space
c        call vcpyr(xid,xi(1,i),6) ! 6D vector
*************
c     call wtvctrrf('xi ',xi(1,i),6,'(6f10.5)')
c     call wtvctrr('xe1d',xe1d,6)
c     call wtvctrr('xe2d',xe2d,6)
c     call wtvctrr('xe3d',xe3d,6)
c     call wtvctrr('xe1',xe1(1,i),6)
c     call wtvctrr('xe2',xe2(1,i),6)
         
         do j=1,nej(i)
            call trhtole(fj(1,j,i))
c           call getqe(fj(1,j,i),ej(1,j,i))  ! undistorted
            call getqed(fj(1,j,i),ej(1,j,i)) ! distorted
         end do
c     scaling for drawing
c         call rescale(ramin0(i),ramax0(i),v0(i))
      end do
      if(iwflag(3).eq.1) then
         write(6,300)
      end if
 300  format(' ')
 301  format(' ','na=',i3)
 302  format(' ',i4,2x,a,2x,3i2,2x,7f8.5)
 303  format(' ',a,7f8.5,2x,a,f8.5)
 306  format(' ',a,6f8.5,2x,a,f8.5)
 304  format(' ','(e1,e2,e3)=',8(a,i2,',',i2,',',i2,')')/
     *     (' ',11x,8(a,i2,',',i2,',',i2,')')))
 305  format(' ','(e1,e2)=',10(a,i2,',',i2,')')/
     *              (' ',8x,10(a,i2,',',i2,')')))
      return
      end

      subroutine getfj123(n,ith,fj1,fj2,fj3)
      real fj1(6),fj2(6),fj3(6)
      include 'qcstrc.inc'
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real fj
      common /cstfc5d/ fj(6,nemax,namax)
      j1=mej(1,ith,n)
      j2=mej(2,ith,n)
      j3=mej(3,ith,n)
      call vcpyr(fj(1,j1,n),fj1,6)
      call vcpyr(fj(1,j2,n),fj2,6)
      call vcpyr(fj(1,j3,n),fj3,6)
      return
      end

      subroutine rdap0(na)
      include 'impr8.inc'
      character(6) atom
      include 'qcstrc.inc'
      common /cwflag/ iwflag(6)
      common /cltc/ atom(namax)
      real x0,u01,u02,u03,v0,be0,bi0
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      real p0,s0,ra,rb
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real ramin00,ramax00
      common /copd1/ ramin00(namax),ramax00(namax)
      real ej0
      common /copd2/ ej0(6,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)

      real q(6),xd(6),yd(6)
      real fj
      common /cstfc5d/ fj(6,nemax,namax)
      real xe1d(6),xe2d(6),xe3d(6),xid(6)
      call getsys(isys)
      call getinp(inpu)

      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(6,301) na
         write(6,'(2a)')
     *      'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *      '       s1      s2'
      end if
      do i=1,na
         read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *        be0(i),bi0(i),ra(i),rb(i),p0(i),s0(1,i),s0(2,i)
         if(nej(i).gt.nemax) call quit('ne > nemax')
         call freadrv('x=',6,x0(1,i),1)
         call freadrv('xe1=',6,xe1(1,i),1)
         call freadr('u1=',1,u01(i),0)
         call freadrv('xe2=',6,xe2(1,i),1)
         call freadr('u2=',1,u02(i),0)
         call freadrv('xe3=',6,xe3(1,i),1)
         call freadr('u3=',1,u03(i),0)
         call freadrv('xi=',6,xi(1,i),1)
         call freadr('v=',1,v0(i),0)
         if(ish(i).eq.-1.or.ish(i).eq.0) then
            do j=1,nej(i)
               call freadrv('ej=',6,fj(1,j,i),1)
            end do
         else if(ish(i).gt.0) then
            nej(i)=nej0(ish(i))
            do j=1,nej(i)
               call vcpyr(ej0(1,j,ish(i)),fj(1,j,i),6)
            end do
         end if
         if(iwflag(3).eq.1) then
            write(6,302) ik,atom(i),ien(i),ish(i),nej(i),
     *           be0(i),bi0(i),ra(i),rb(i),p0(i),s0(1,i),s0(2,i)
            write(6,303) 'x =', (x0(j,i),j=1,6)
            write(6,303) 'xe1=', (xe1d(j),j=1,6),'u1=',u01(i)
            write(6,303) 'xe2=', (xe2d(j),j=1,6),'u2=',u02(i)
            write(6,303) 'xe3=', (xe3d(j),j=1,6),'u3=',u03(i)
            write(6,303) 'xi= ', (xid(j),j=1,6),'v= ',v0(i)
            if(ish(i).ge.0) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,6)
               end do
               if(ish(i).eq.0) then
                  call freadi('nth=',1,nth(i),1)
                  isyd(i)=1
                  if(nth(i).gt.nemax) call quit('nth > nemax')
                  do j=1,nth(i)
                     if(isys.le.2) then
                        call freadiv(' ',3,mej(1,j,i),0)
                     else
                        call freadiv(' ',2,mej(1,j,i),0)
                     end if
                  end do
               else
                  call freadi('isyd=',1,isyd(i),1)
                  nth(i)=nth0(ish(i))
                  do j=1,nth(i)
                     if(isys.le.2) then
                        call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),3)
                     else
                        call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),2)
                     end if
                  end do
               end if
               if(isys.le.2) then
                  write(6,304) ('(',(mej(k,j,i),k=1,3),j=1,nth(i))
               else
                  write(6,305) ('(',(mej(k,j,i),k=1,2),j=1,nth(i))
               end if
               if(ish(i).gt.0) then
                  write(6,*) 'isyd=',isyd(i)
               end if
            else if(ish(i).eq.-1) then
               do j=1,nej(i)
                  write(6,303) 'ej=', (fj(k,j,i),k=1,6)
               end do
            end if
         end if

c     ve and vi components
         call trhtole(xe1d)     ! tr6to5d etc if possible
         call trhtole(xe2d)
         call trhtole(xe3d)
         call trhtole(xid)          
         call vcpyr(xid,xi(1,i),6)  ! xi0 : 6D coordinate
         call prjext1(xe1d,xe1(1,i)) ! projection onto external space 
         call prjext1(xe2d,xe2(1,i)) ! and normalize
         call prjext1(xe3d,xe3(1,i))
         iapprx=getapprx()         
         if(iapprx.eq.1) then
            call prjint0(xid,xi(1,i)) ! projection onto internal space
         else
            call prjint(xid,xi(1,i)) ! projection onto internal space
         end if

c         do j=1,6
c            xe0t(j,i)=u01(i)*xe1d(j)+u02(i)*xe2d(j)+u03(i)*xe3d(j)
c         end do

c         call wtvctrr('xe1',xe1(1,i),6)
c         call wtvctrr('xe2',xe2(1,i),6)
c         call wtvctrr('xe3',xe3(1,i),6)
c         call wtvctrr('xi ',xi(1,i),6)
c         call getqe(xe1(1,i),qe1)
c         call getqe(xe2(1,i),qe2)
c         call getqe(xe3(1,i),qe3)
c         call getqe(xi(1,i),qi)
c         call wtvctrr('qe1',qe1,6)
c         call wtvctrr('qe2',qe2,6)
c         call wtvctrr('qe3',qe3,6)
c         call wtvctrr('qi',qi,6)
         do j=1,nej(i)
            call trhtole(fj(1,j,i)) ! high dim to low dim if possible
            call getqe(fj(1,j,i),ej(1,j,i)) ! undistorted
         end do
      end do
      if(iwflag(3).eq.1) then
         write(6,300)
      end if
 300  format(' ')
 301  format('na=',i3)
 302  format(i4,2x,a,2x,3i2,2x,7f8.5)
 303  format(a,6f8.5,2x,a,f8.5)
 304  format('(e1,e2,e3)=',8(a,i2,',',i2,',',i2,')')/
     *     (11x,8(a,i2,',',i2,',',i2,')')))
 305  format('(e1,e2)=',10(a,i2,',',i2,')')/
     *     (8x,10(a,i2,',',i2,')')))
      return
      end

      subroutine xtoxs(na)
      include 'impr8.inc'
      include 'qcstrc.inc'
      real x0,u01,u02,u03,v0,be0,bi0
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      real p0,s0,ramin0,ramax0
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real xd(6)

      call getsys(isys)
      if(isys.le.2) then
         do i=1,na
            call celltr(x0(1,i),1)
            call celltr(xe1(1,i),1)
            call celltr(xe2(1,i),1)
            call celltr(xe3(1,i),1)
            call celltr(xi(1,i),1)
            ramin0(i)=ramin0(i)/2
            ramax0(i)=ramax0(i)/2
c            write(6,'(a,6f10.5,4(a,f10.5))')
c     *           'x0=',(x0(j,i),j=1,6),' u01=',u01(i),
c     *           ' v0=',v0(i),' ra=',ramin0(i),' rb=',ramax0(i)
         end do
      else if(isys.eq.3) then
         do i=1,na
            call celltr(x0(1,i),1)
            call celltr(xe1(1,i),1)
            call celltr(xe2(1,i),1)
            call celltr(xe3(1,i),1)
            call celltr(xi(1,i),1)
            do j=1,nej(i)
c               call qtox0(ej(1,j,i),xd)
               call getxe(ej(1,j,i),xd)
               call celltr(xd,1)
               call getqe(xd,ej(1,j,i))
            end do
c            write(6,*) 'x0=',(x0(j,i),j=1,6)
c            write(6,*) 'ej=',(ej(j,1,i),j=1,6)
         end do
      end if
      return
      end

      subroutine rtors(brv)
      include 'impr8.inc'
      character brv
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real rc(6,6),rd(6,6),trm1(6,6),trm2(6,6),td(6)
      save trm1,trm2
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
      do ns=1,nsymo
         call mtmplri(trm1,r(1,1,ns),rc,6)
         call sclmtrx(rc,0.2,6)
         call mtmplmnor(trm1,t(1,ns),td,6,6,1)
         call sclvctr(td,0.2,6)
         call mtmplr(rc,trm2,rd,6)
c         do i=1,6
c            do j=1,6
c               rc(i,j)=0
c               do k=1,6
c                  rc(i,j)=rc(i,j)+trm1(i,k)*r(k,j,ns)/5
c               end do
c            end do
c         end do
c         do i=1,6
c            td(i)=0
c            do j=1,6
c               td(i)=td(i)+trm1(i,j)*t(j,ns)/5
c            end do
c         end do
c         do i=1,6
c            do j=1,6
c               rd(i,j)=0
c               do k=1,6
c                  rd(i,j)=rd(i,j)+rc(i,k)*trm2(k,j)
c               end do
c            end do
c         end do
         do i=1,6
            do j=1,6
c               r(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
               r(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
            end do
c            t(i,ns)=mod(td(i),1.)
            t(i,ns)=mod(td(i),1.)
         end do
      end do
      call wtsmop(r,t,nsymo,3,3)
      return
      end

      subroutine getx0(i,x)
      real x(*)
      include 'qcstrc.inc'
      real x0,u01,u02,u03,v0,be0,bi0
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      call vcpyr(x0(1,i),x,6)
      return
      end

      function getv0(i)
      include 'qcstrc.inc'
      real x0,u01,u02,u03,v0,be0,bi0
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax)
      getv0=v0(i)
      return
      end

      subroutine getxi(n,xid)
      real xid(*)
      include 'qcstrc.inc'
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(xi(1,n),xid,6)
      return
      end

      integer function getish(i)
      include 'qcstrc.inc'
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getish=ish(i)
      return
      end

      integer function getisyd(i)
      include 'qcstrc.inc'
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getisyd=isyd(i)
      return
      end

      integer function getien(i)
      include 'qcstrc.inc'
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getien=ien(i)
      return
      end
