c
c       check of matinv
c       
c      parameter (nmx=3)
      parameter (nmx=2)
      real a(nmx,nmx),b(nmx),piv(nmx)
      real c(nmx,nmx),d(nmx,nmx),e(nmx,nmx*2),f(nmx),g(nmx)
      integer ipv(nmx),indx(nmx*2)
c      data a /3., 2., 1.,2.,3.,5.,1.,7.,9./
c      data b /1.,2.,3./
      data a /0.,1.,1.,0./
      data b /1.,2./
      n=nmx
      call mcpy(a,c,n)
      call vcpyr(b,f,n)
      call matinvt(c,n,n,f,1,det,ipv,indx,piv)
c      call matinv(c,n,n,f,1,det,ipv,indx,piv)
c      do i=1,n
c         do j=1,n
c            c(i,j)=a(i,j)
c         end do
c      end do
c      do i=1,n
c         do j=1,n
c            d(i,j)=0
c            if(i.eq.j) d(i,j)=1
c         end do
c      end do
c      do i=1,n
c         do j=1,n*2
c            if(j.le.n) then
c               e(i,j)=c(i,j)
c            else
c               e(i,j)=d(i,j-n)
c            end if
c         end do
c      end do
c      call simeq(n,n*2,e,det)
c      do i=1,n
c         do j=1,n
c            c(i,j)=e(i,j+n)
c         end do
c      end do

      call mtmplr(a,c,d,n)
      do i=1,n
         write(6,'(3f10.6)') (a(i,j),j=1,n)
      end do

      do i=1,n
         write(6,'(3f10.6)') (d(i,j),j=1,n)
      end do

      do i=1,n
         g(i)=0
         do j=1,n
            g(i)=g(i)+a(i,j)*f(j)
         end do
      end do

      write(6,'(3f10.6)') (b(i),i=1,n)
      write(6,'(3f10.6)') (g(i),i=1,n)
      stop
      end

      subroutine matinv0(a,nm,n,b,m,determ,ipivot,index,pivot)
c
c    n*n matrix a is replaced by its inverse matrix a**-1
c    if m is nonzero vector b is replaced by a**-1*b
c
      dimension a(nm,nm),b(nm),ipivot(nm),index(nm,2),pivot(nm)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do 20 j=1,n
  20  ipivot(j)=0
      do 555 i=1,n
      amax=0.0
      do 105 j=1,n
      if(ipivot(j).eq.1) go to 105
      do 100 k=1,n
      if(ipivot(k)-1) 80,100,740
  80  if(abs(amax).ge.abs(a(j,k))) go to 100
      irow=j
      icolum=k
      amax=a(j,k)
 100  continue
 105  continue
      ipivot(icolum)=ipivot(icolum)+1
      if(irow.eq.icolum) go to 260
      determ=-determ
      do 200 l=1,n
      swap=a(irow,l)
      a(irow,l)=a(icolum,l)
 200  a(icolum,l)=swap
      if(m.eq.0) go to 260
      swap=b(irow)
      b(irow)=b(icolum)
      b(icolum)=swap
 260  index(i,1)=irow
      index(i,2)=icolum
      pivot(i)=a(icolum,icolum)
      determ=determ*pivot(i)
      a(icolum,icolum)=1.0
      do 350 l=1,n
 350  a(icolum,l)=a(icolum,l)/pivot(i)
      if(m.eq.0) go to 380
      b(icolum)=b(icolum)/pivot(i)
 380  do 550 l1=1,n
      if(l1.eq.icolum) go to 550
      t=a(l1,icolum)
      a(l1,icolum)=0.0
      do 450 l=1,n
 450  a(l1,l)=a(l1,l)-a(icolum,l)*t
      if(m.eq.0) go to 550
      b(l1)=b(l1)-b(icolum)*t
 550  continue
 555  continue
      do 710 i=1,n
      l=n+1-i
      if(index(l,1).eq.index(l,2)) go to 710
      jrow=index(l,1)
      jcolum=index(l,2)
      do 700  k=1,n
      swap=a(k,jrow)
      a(k,jrow)=a(k,jcolum)
 700  a(k,jcolum)=swap
 710  continue
 740  continue
      return
      end
      
      subroutine matinvt(a,nm,n,b,m,determ,ipivot,index,pivot)
c     *********    test version   *******
c     
c     n*n matrix a is replaced by its inverse matrix a**-1
c     if m is nonzero vector b is replaced by a**-1*b
c     
      real a(nm,nm),b(nm),pivot(nm)
      integer ipivot(nm),index(nm,2)
      equivalence (irow,jrow),(icolum,jcolum),(amax,t,swap)
      determ=1.0
      do j=1,n
         ipivot(j)=0
      end do
      do 555 i=1,n
         amax=0.0
         do 105 j=1,n
c           if(ipivot(j).eq.1) go to 105
            if(ipivot(j).ne.1) then
               do 100 k=1,n
c                 if(ipivot(k)-1) 80,100,740
                  if(ipivot(k).gt.1) then
                     return
                  else if(ipivot(k).lt.1) then
c     80             if(abs(amax).ge.abs(a(j,k))) go to 100
                     if(abs(amax).lt.abs(a(j,k))) then
                        irow=j
                        icolum=k
                        amax=a(j,k)
                     end if
                  end if
 100           continue
            end if
 105     continue
         ipivot(icolum)=ipivot(icolum)+1
c        if(irow.eq.icolum) go to 260
         if(irow.ne.icolum) then
            determ=-determ
            do l=1,n
               swap=a(irow,l)
               a(irow,l)=a(icolum,l)
               a(icolum,l)=swap
            end do
c           if(m.eq.0) go to 260
            if(m.ne.0)  then
               swap=b(irow)
               b(irow)=b(icolum)
               b(icolum)=swap
            end if
         end if
 260     continue
         index(i,1)=irow
         index(i,2)=icolum
         pivot(i)=a(icolum,icolum)
         determ=determ*pivot(i)
         a(icolum,icolum)=1.0
         do l=1,n
            a(icolum,l)=a(icolum,l)/pivot(i)
         end do
c        if(m.eq.0) go to 380
         if(m.ne.0) then
            b(icolum)=b(icolum)/pivot(i)
         end if
 380     continue
         do 550 l1=1,n
c           if(l1.eq.icolum) go to 550
            if(l1.ne.icolum) then
               t=a(l1,icolum)
               a(l1,icolum)=0.0
               do l=1,n
                  a(l1,l)=a(l1,l)-a(icolum,l)*t
               end do
c              if(m.eq.0) go to 550
               if(m.ne.0) then
                  b(l1)=b(l1)-b(icolum)*t
               end if
            end if
 550     continue
 555  continue
      do 710 i=1,n
         l=n+1-i
c        if(index(l,1).eq.index(l,2)) go to 710
         if(index(l,1).ne.index(l,2)) then
            jrow=index(l,1)
            jcolum=index(l,2)
            do 700  k=1,n
               swap=a(k,jrow)
               a(k,jrow)=a(k,jcolum)
               a(k,jcolum)=swap
 700        continue
         end if
 710  continue
      
 740  continue
      return
      end
      
      subroutine mcpy(from,to,n)
      real from(n,*),to(n,*)
      do 100 i=1,n
      do 100 j=1,n
         to(i,j)=from(i,j)
 100  continue
         return
         end

      subroutine mtmplr(a,b,c,n)
      real a(n,*),b(n,*),c(n,*)
      do 100 i=1,n
      do 100 j=1,n
           c(i,j)=0.
           do 200 k=1,n
                c(i,j)=c(i,j)+a(i,k)*b(k,j)
 200       continue
 100  continue
      return
      end

      subroutine simeq1(m,n,a,d)
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n)
      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 110 j=1,m
         do 40 k=j,m
            if(a(k,j).ne.0) go to 50
 40      continue
         go to 20
 50      if(k.eq.j) go to 70
         do 60 l=j,n
            ax=a(j,l)
            a(j,l)=a(k,l)
            a(k,l)=ax
 60      continue
         d=-d
 70      ax=a(j,j)
         d=ax*d
         a(j,j)=1
         do 80 k=j+1,n
            a(j,k)=a(j,k)/ax
 80      continue
         do 100 k=1,m
            if(j.eq.k) go to 100
            ax=a(k,j)
            a(k,j)=0
            do 90 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 90         continue
 100     continue
 110     continue
         return
         end

      subroutine simeq2(m,n,a,d)
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n)
      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 100 j=1,m
         km=j
         am=abs(a(j,j))
         do 40 k=j+1,m
            ax=abs(a(k,j))
            if(ax.gt.am) then
               km=k
               am=ax
            end if
 40      continue
         if(am.eq.0) go to 20
         if(km.eq.j) go to 60
         do 50 k=j,n
             ax=a(j,k)
            a(j,k)=a(km,k)
            a(km,k)=ax
 50      continue
         d=-d
 60      ax=a(j,j)
         d=ax*d
         a(j,j)=1
         do 70 k=j+1,n
            a(j,k)=a(j,k)/ax
 70      continue
         do 90 k=1,m
            if(j.eq.k) go to 90
            ax=a(k,j)
            a(k,j)=0
            do 80 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 80         continue
 90      continue
 100  continue
      return
      end

      subroutine simeq3(m,n,a,d)
c
c     a(m,n) 1<=m<=n  a(m,m) matrix a(m,m+1) solution
c     d determinant
c     
      real a(m,n)
      if(m.gt.n) go to 20
      if(m.ge.2) go to 30
c     m<=1
      if(m.lt.1) go to 20
c     m=1
      d=a(1,1)
      if(d.eq.0) return
      do 10 j=1,n
         a(1,j)=a(1,j)/d
 10   continue
      return
c     m>n m<1, or d=0
 20   d=0
      return
c     2<=m<=n
 30   d=1
      do 130 j=1,m
         km=j
         lm=j
         am=abs(a(j,j))
         do 50 k=j+1,m
            do 40 l=j+1,m
               ax=abs(a(k,l))
               if(ax.gt.am) then
                  km=k
                  lm=l
                  am=ax
               end if
 40         continue
 50      continue
         if(am.eq.0) go to 20
         if(km.eq.j) go to 70
         do 60 k=j,n
            ax=a(j,k)
            a(j,k)=a(km,k)
            a(km,k)=ax
 60      continue
         d=-d
 70      if(lm.eq.j) go to 90
         do 80 k=1,m
            ax=a(k,j)
            a(k,j)=a(k,lm)
            a(k,lm)=ax
 80      continue
         d=-d
 90      ax=a(j,j)
         d=ax*d
         a(j,j)=lm
         do 100 k=j+1,n
            a(j,k)=a(j,k)/ax
 100     continue
         do 120 k=1,m
            if(j.eq.k) go to 120
            ax=a(k,j)
            a(k,j)=0
            do 110 l=j+1,n
               a(k,l)=a(k,l)-a(j,l)*ax
 110         continue
 120      continue
 130  continue
      do 160 j=m,1,-1
         k=a(j,j)
         if(k.eq.j) go to 150
         do 140 l=m+1,n
            ax=a(j,l)
            a(j,l)=a(k,l)
            a(k,l)=ax
 140     continue
 150     continue
 160  continue
      return
      end
      
      subroutine matinv2(a,nm,n,b,m,determ,ipivot,index,pivot)
      parameter (nmax=10)
      real a(nm,nm),b(*),pivot(*)
      integer ipivot(*),index(*)
      real ab(10*20)
      if(nm.gt.10) then
         write(6,*) 'nm>10 in new matinv'
      end if
c
      if(m.eq.1) then   ! solve linear equation
         ij=0
         do j=1,n
            do i=1,n
               ij=ij+1
               ab(ij)=a(i,j)
            end do
         end do

         do i=1,n
            ij=ij+1
            ab(ij)=b(i)
         end do

         n1=n+1
c         call simeq1(n,n1,ab,det)
c         call simeq2(n,n1,ab,det)
         call simeq3(n,n1,ab,det)
         if(det.eq.0) write(6,*) 'matrix is singuler'

         ij=n*n
         do i=1,n
            ij=ij+1
            b(i)=ab(ij)
         end do
      end if

c     calculate inversion matrix of a
      ij=0
      do j=1,n
         do i=1,n
            ij=ij+1
            ab(ij)=a(i,j)
         end do
      end do

      do j=1,n
         do i=1,n
            ij=ij+1
            ab(ij)=0
            if(i.eq.j) ab(ij)=1
         end do
      end do

      n1=n+n
c      call simeq1(n,n1,ab,det)
c      call simeq2(n,n1,ab,det)
c      call simeq3(n,n1,ab,det)
      if(det.eq.0) write(6,*) 'matrix is singuler'

      ij=n*n
      do j=1,n
         do i=1,n
            ij=ij+1
            a(i,j)=ab(ij)
         end do
      end do
      return
      end
            
      subroutine vcpyr(x,y,n)
      real x(*),y(*)
      do 10 i=1,n
      y(i)=x(i)
 10   continue
      return
      end


