      subroutine rtors()
      character brv
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real rc(6,6),rd(6,6),td(6)
      real trm1(6,6),trm2(6,6),trm3(6,6),trm4(6,6)
      save trm1,trm2,trm3,trm4
c        for decagonal
      data trm1 /2, 2,-3, 2,0,0,
     *          -1, 4,-1,-1,0,0,
     *           1, 1, 1, 1,0,0,
     *          -2, 3,-2, 3,0,0,
     *           0, 0, 0, 0,5,0,
     *           0, 0, 0, 0,0,5/
      data trm2 /1, 0, 1,-1,0,0,
     *           0, 1, 1, 0,0,0,
     *          -1, 0, 2, 0,0,0,
     *           0,-1, 1, 1,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
c        for dodecagonal
      data trm3 /0, 1, 0,-1,0,0,
     *           2, 0, 1, 0,0,0,
     *           0, 1, 0, 2,0,0,
     *          -1, 0, 1, 0,0,0,
     *           0, 0, 0, 0,3,0,
     *           0, 0, 0, 0,0,3/
      data trm4 /0, 1, 0,-1,0,0,
     *           2, 0, 1, 0,0,0,
     *           0, 1, 0, 2,0,0,
     *          -1, 0, 1, 0,0,0,
     *           0, 0, 0, 0,1,0,
     *           0, 0, 0, 0,0,1/
c      data trm3 /0, 2, 0,-1,0,0,
c     *           1, 0, 1, 0,0,0,
c     *           0, 1, 0, 1,0,0,
c     *          -1, 0, 2, 0,0,0,
c     *           0, 0, 0, 0,3,0,
c     *           0, 0, 0, 0,0,3/
c      data trm4 /0, 2, 0,-1,0,0,
c     *           1, 0, 1, 0,0,0,
c     *           0, 1, 0, 1,0,0,
c     *          -1, 0, 2, 0,0,0,
c     *           0, 0, 0, 0,1,0,
c     *           0, 0, 0, 0,0,1/
      call getsys(isys)
      call getbrv(brv)
      if(brv.ne.'s'.or.isys.le.2.or.isys.eq.4) then
         return
      end if

      call getsys(isys)
      if(isys.eq.3) then
         do ns=1,nsymo
            do i=1,6
               do j=1,6
                  rc(i,j)=0
                  do k=1,6
                     rc(i,j)=rc(i,j)+trm1(i,k)*r(k,j,ns)/5
                  end do
               end do
            end do
            do i=1,6
               td(i)=0
               do j=1,6
                  td(i)=td(i)+trm1(i,j)*t(j,ns)/5
               end do
            end do
            do i=1,6
               do j=1,6
                  rd(i,j)=0
                  do k=1,6
                     rd(i,j)=rd(i,j)+rc(i,k)*trm2(k,j)
                  end do
               end do
            end do
            do i=1,6
               do j=1,6
                  r(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
               end do
               t(i,ns)=mod(td(i),1.)
            end do
         end do
      else if(isys.eq.5) then
         do ns=1,nsymo
            do i=1,6
               do j=1,6
                  rc(i,j)=0
                  do k=1,6
                     rc(i,j)=rc(i,j)+trm3(i,k)*r(k,j,ns)/3
                  end do
               end do
            end do
            do i=1,6
               td(i)=0
               do j=1,6
                  td(i)=td(i)+trm3(i,j)*t(j,ns)/3
               end do
            end do
            do i=1,6
               do j=1,6
                  rd(i,j)=0
                  do k=1,6
                     rd(i,j)=rd(i,j)+rc(i,k)*trm4(k,j)
                  end do
               end do
            end do
            do i=1,6
               do j=1,6
                  r(i,j,ns)=rd(i,j)+sign(0.001,rd(i,j))
               end do
               t(i,ns)=mod(td(i),1.)
            end do
         end do
      end if
      call wtsmop(r,t,nsymo,3,3)
      return
      end

      subroutine invsymo()
      integer rr(6,6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      write(6,*) 'reciprocal operator for each atom'
      do i=1,nsymo
         do j=1,nsymo
            call mtmul(r(1,1,i),r(1,1,j),rr)
            if(identm(rr).eq.1) then
               isymo(i)=j
               go to 200
            end if
         end do
 200  continue
      end do
      do i=1,icent
         do j=1,nsymo
            isymo(j+nsymo)=isymo(j)+nsymo
         end do
      end do
      write(6,'(a,20i4/(9x,20i4))')
     *     'isymo=',(isymo(j),j=1,nsymo*(1+icent))
      return
      end

      function identm(rr)
      integer rr(6,6)
c      if rr is identity matrix identm=1 else 0
      identm=0
      do i=1,6
         do j=1,6
            if(i.eq.j) then
               if(rr(i,i).ne.1) return
            else
               if(rr(i,j).ne.0) return
            end if
         end do
      end do
      identm=1
      return
      end

      integer function getnsymo()
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      getnsymo=nsymo
      return
      end

      integer function geticent()
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      geticent=icent
      return
      end

      subroutine rdsymo(na,brv)
      common /cwflag/ iwflag(6)
      character brv
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype
      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character(30) coord
      character cltd(6)
      data cltd/'p','i','f','s','c','g'/      
c     initialization
      call getinp(inpu)
      call getout(iout)
      iwflag(3)=1
      ige=1
c     
c     read(5,100) nsymo,icent,brv
      call freadis('nsymo=',1,nsymo,1)
      call freadis('icent=',1,icent,0)
      call freadcs('brv=',1,brv,0)
      call setbrv(brv)

      nde=3       ! temporary
      idm=nde+3   ! temporary
      icom=0
c     
      write(iout,210) nsymo,icent,brv
      do i=1,6
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do

      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if

c      read(inpu,*) 'symmetry operator'
      call freadrs('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call symdecode(coord,r,t,k)
      end do

      if(iwflag(3).eq.1) then
c     if(icent.eq.1) then
         if(icent.eq.1.or.icent.eq.-1) then
            write(iout,2022)
         else
            write(iout,2021)
         end if
         if(ige.eq.1) then
            write(iout,201) 'generating elements'
         end if
         write(iout,*)
      end if
      
      nn=nde+1
      if(iwflag(3).eq.1) then
         call wtsymo(r,t,nsymo,idm)
      end if
      
      if(ige.eq.1) then
         call ordr(r,imps,nsymo,idm)
         do i=1,nsymo
            do j=1,idm
               tg(j,i)=t(j,i)
               do k=1,idm
                  rg(j,k,i)=r(j,k,i)
               end do
            end do
         end do
         impt=1
         do i=1,6
            t(i,1)=0.0
            do j=1,6
               r(i,j,1)=0.0
               r(i,i,1)=1.0
            end do
         end do
         do ns=1,nsymo
            imp=imps(ns)
c     modified to include the pure translation
            if(imp.eq.1) then
               if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *              .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *              imp=2
            end if
            do i=2,imp
               do j=1,impt
                  mp1=j+(i-2)*impt
                  mp2=j+(i-1)*impt
                  call mpso(rg,tg,ns,r,t,mp1,mp2,idm)
               end do
            end do
            impt=impt*imp
         end do
         nsymo=impt
         if(iwflag(3).eq.1) then
            write(iout,207)
            write(iout,*)
            call wtsymo(r,t,nsymo,idm)
         end if
      end if
      call getsys(isys)
      if(isys.le.2) then
         nde=3
      else
         nde=2
      end if
      idm=nde+3
      write(6,*) 'idm=',idm
      call setidm(idm)
      call setndm(nde)
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if

      return
 201  format(' ',a)
 2021 format(' ','symmetry operation',10x,'noncentrosymmetric')
 2022 format(' ','symmetry operation',10x,'centrosymmetric')
 207  format(' ','symmetry operators generated by generating elements')
 210  format(' ','nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 231  format(' ','extinction rules for general reflections'/' ',
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine sitesy(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)   ! save
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent        ! include antisymmetric inversion -1
            istep=icent         ! include antisymmetric inversion -1
         end if
      end if

      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do  ic=0,icent
         do  ic=0,icentd,istep
            do ns=1,nsymo
c              call getrx(x(1,i),rx,r,t,ns,ic)
               call getrx1(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120  ! rx=rxs
               end do
c     symmetry operator generating equivalent positions
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     site symmetry operator
               if(rcomp(rx,x(1,i)).eq.1) then  ! r=rx
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
c                 write(6,*) 'atom=',i,' ns=',irs(nsym,i)
c                  call wtvctrrf('x =',x(1,i),6,'(6f10.5)')
c                  call wtvctrrf('rx=',rx,6,'(6f10.5)')
c                  call wtsymo(r(1,1,ns),t(1,ns),1,6)
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
c     if(icent.eq.1) then
         if(icent.eq.1.or.(icent.eq.-1.and.x(6,i).eq.0.)) then
c     compress symmetry element > nsymo
            n=0
            do j=1,isk(0,i)
               if(isk(j,i).gt.nsymo) go to 201
               n=n+1
            end do
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,i): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(i)=float(isk(0,i))/(float(n)*2)
            isk(0,i)=n
         end if
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         write(6,'(a,i4,a,f10.5)') 'atom',i,'  ',mpl(i)
      end do
      return
      end

      subroutine sitesy1(na,mpl,x,isk,irs) 
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /cdim/ idm,nde
      real rx(6)
      real rxs(6,120)
      integer rcomp
      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent
            istep=icent
         end if
      end if
      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
c     do 130 ic=0,icent
         do ic=0,icentd,istep
            do ns=1,nsymo
c              call getrx(x(1,i),rx,r,t,ns,ic)
               call getrx1(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      return
      end

      subroutine getnsyic(nsy,ic)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      nsy=nsymo
      ic=icent
      return
      end

      subroutine gettr(tr)
      real tr(6,*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      do i=1,nsymo
         call vcpyr(t(1,i),tr(1,i),6)
      end do
      return
      end

      subroutine gettrns(ns,tr)
      real tr(*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call vcpyr(t(1,ns),tr,6)
      return
      end

      subroutine gethr0(h,hr,ns,icnt)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer h(*),hr(*)
      ns0=ns
      icnt0=icnt
      if(ns.le.0) then
         write(6,*) 'ns in gethr0=',ns
         call quit('strange symmetry operator number')
      else if(ns.gt.nsymo.and.icnt.eq.1) then
         write(6,*) 'ns,icnt in gethr0=',ns,icnt
         call quit('strange symmetry operator number')
      else if(ns.gt.nsymo.and.icnt.eq.0) then
         icnt0=1
         ns0=ns-nsymo
      end if

      do i=1,6
         hr(i)=0.
         do j=1,6
            hr(i)=hr(i)+h(j)*r(j,i,ns0)
         end do
         if(icnt0.eq.1) then
            hr(i)=-hr(i)
*************************************
         else if(icnt0.eq.-1) then
            hr(i)=-hr(i)
*************************************
         end if
      end do
      return
      end

      subroutine gethr(h,hr,r,ns,icnt)
      integer h(*),hr(*),r(6,6,*)
      do i=1,6
         hr(i)=0.
         do j=1,6
            hr(i)=hr(i)+h(j)*r(j,i,ns)
         end do
         if(icnt.eq.1) then
            hr(i)=-hr(i)
*************************************
         else if(icnt.eq.-1) then
            hr(i)=-hr(i)
*************************************
         end if
      end do
      return
      end

      subroutine getrx(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      call getsys(isys)
      if(isys.le.2) then
         call getrx00(x,rx,r,t,ns,ic)
      else
         call getrx01(x,rx,r,t,ns,ic)
      end if
      return
      end

      subroutine getrx1(x,rx,ns,ic)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real x(*),rx(*)
      call getsys(isys)
      if(isys.le.2) then
         call getrx10(x,rx,ns,ic)
      else
         call getrx11(x,rx,ns,ic)
      end if
      return
      end

      subroutine getrx00(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      do i=1,6
         rx(i)=0.
         do j=1,6
            rx(i)=rx(i)+r(i,j,ns)*x(j)
         end do
         rx(i)=rx(i)+t(i,ns)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      return
      end

      subroutine getrx01(x,rx,r,t,ns,ic)
      real x(*),rx(*),t(6,*)
      integer r(6,6,*)
      do i=1,6
         rx(i)=0.
         do j=1,6
            rx(i)=rx(i)+r(i,j,ns)*x(j)
         end do
         if(i.le.5) then
            rx(i)=rx(i)+t(i,ns)
            if(ic.eq.1.or.ic.eq.-1) then
               rx(i)=-rx(i)
            end if
         else if(i.eq.6) then
            if(ic.eq.-1) then
               rx(i)=-rx(i)
            end if
         end if
      end do
      return
      end

      subroutine getrx10(x,rx,ns,ic)
      real x(*),rx(*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call mtmplirmno(r(1,1,ns),x,rx,6,6,1)
      do i=1,6
c         rx(i)=0.
c         do j=1,6
c            rx(i)=rx(i)+r(i,j,ns)*x(j)
c         end do
         rx(i)=rx(i)+t(i,ns)
         if(ic.eq.1) then
            rx(i)=-rx(i)
         end if
      end do
      return
      end

      subroutine getrx11(x,rx,ns,ic)
      real x(*),rx(*)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call mtmplirmno(r(1,1,ns),x,rx,6,6,1)
      do i=1,6
c         rx(i)=0.
c         do j=1,6
c            rx(i)=rx(i)+r(i,j,ns)*x(j)
c         end do
         if(i.le.5) then
            rx(i)=rx(i)+t(i,ns)
            if(ic.eq.1.or.ic.eq.-1) then
               rx(i)=-rx(i)
            end if
         else if(i.eq.6) then
            if(ic.eq.-1) then
               rx(i)=-rx(i)
            end if
         end if
      end do
      return
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.0001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            do k=1,idm
               r(j,k)=re(j,k,i)
               b(j,k)=r(j,k)
            end do
         end do
         do j=1,13
c     check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
               end do
            end do
            imps(i)=j
            go to 10
c     a=r
 15         continue
            do k=1,idm
               do l=1,idm
                  a(k,l)=r(k,l)
               end do
            end do
c       r=a*b   ==> r=r*re
            do k=1,idm
               do l=1,idm
                  r(k,l)=0
                  do m=1,idm
                     r(k,l)=r(k,l)+a(k,m)*b(m,l)
                  end do
               end do
            end do
         end do
 10      continue
      end do
      do i=1,nsymo
      if(imps(i).ge.13) then
           ierror=1
           go to 21
      else
           ierror=0
      end if
      end do
 21   continue
      if(ierror.eq.1) then
           write(iout,'('' error in symmetry operator ?'',a,24i3)')
     *      '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(r,t,nsymo,idm)
      integer r(6,6,*)
      real t(6,*)
      character(3) wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.0001/
      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(r,t,nsymo,idm-3,3)
      write(iout,*)
      call getwtt(t,wtt,nsymo,idm)
      return
      end

      subroutine getwtt(t,wtt,nsymo,idm)
      real t(6,*)
      character(3) wtt(6,*)
      real rt(8)
      character(3) wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=t(j,i)
            td=mod(td,1.)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do i=1,idm
         t2(i,m3)=0.0
         do j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
         end do
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do j=1,idm
            r2(i,j,m3)=0.0
            do k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
            end do
         end do
      end do
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      dimension r1(6,6,*)
      dimension r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      character xyz(6)
c        for (d2+d1) dimensional case
      character(50) z1(60),bl
      character(3) ntr(7)
      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/
      call getinp(inpu)
      call getout(iout)
      eps=0.00001
c     call wtvctrr('rtr=',rtr,7)
      d3=d1+d2
      do ii=1,nsymo
c        write(6,*) 'ii=',ii
         cp=1
         do i=1,d3
            t(i)=t1(i,ii)
            do j=1,d3
               r(i,j)=r1(i,j,ii)
            end do
         end do
         do i=1,d3
            t(i)=mod(t(i),1.)
            if(t(i).lt.-eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,60
            z1(ii)=bl
         end do
c        call wtvctrrf('t=',t,6,'(6f10.5)')
         do i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
            end do
         end do
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *     ii=1,nsymo)
      return
      end

      subroutine symdecode(coord,r,t,n)
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/
      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
c     
      do j=1,6
         t(j,n)=0
         do k=1,6
            r(j,k,n)=0
         end do
c     
c     rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c     
c     translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine trhtole(yd)
      real yd(*)
      real xd(7)
      call getsys(isys)
      if(isys.le.2) then
         return
      else if(isys.eq.3) then
         call vcpyr(yd,xd,6)
         call tr6to5e(xd,yd)
      else if(isys.eq.4) then
         return
      else if(isys.eq.5) then
         call vcpyr(yd,xd,7)
         call tr7to5e(xd,yd)
      end if
      return
      end
      
      subroutine tr6to5e(ei,fi)
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 0, 0,
     *        -1, 4,-1,-1, 0, 0,
     *        -1,-1, 4,-1, 0, 0,
     *        -1,-1,-1, 4, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 5, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
             fi(j)=fi(j)+sd(j,k)*ei(k)/5
          end do
      end do
      return
      end

      subroutine tr6to5i(ei,fi)
      integer fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1, 0, 0, 0, 0, 0,
     *         0, 1, 0, 0, 0, 0,
     *         0, 0, 1, 0, 0, 0,
     *         0, 0, 0, 1, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
            fi(j)=fi(j)+sd(j,k)*ei(k)
         end do
      end do
      return
      end

      subroutine tr7to5e(ei,fi)
c       for dodecagonal      
      real fi(*),ei(*)
      integer sd(7,7)
      data sd / 0, 1, 0, 0, 0,-1, 0,
     *          1, 0, 1, 0, 0, 0, 0,
     *          0, 1, 0, 1, 0, 0, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/
c      data sd/ 2, 0, 1, 0,-1, 0, 0,
c     *         0, 2, 0, 1, 0,-1, 0,
c     *         1, 0, 2, 0, 1, 0, 0,
c     *         0, 1, 0, 2, 0, 1, 0,
c     *         1, 0,-1, 0, 1, 0, 0,
c     *         0, 1, 0,-1, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 0, 1/
c      do 12 j=1,7
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
            do k=1,6
               fi(j)=fi(j)+sd(k,j)*ei(k)
c     fi(j)=fi(j)+sd(k,j)*ei(k)/3
            end do
         else if (j.eq.5) then
            fi(5)=ei(7)
            fi(6)=0
         end if
      end do
      return
      end

      subroutine tr7to5i(ei,fi)
c       for dodecagonal      
      integer fi(*),ei(*)
      integer sd(7,7)
c      data sd / 0, 1, 0, 0, 0,-1, 0,
c     *          1, 0, 1, 0, 0, 0, 0,
c     *          0, 1, 0, 1, 0, 0, 0,
c     *          0, 0, 1, 0, 1, 0, 0,
c     *          1, 0,-1, 0, 1, 0, 0,
c     *          0, 1, 0,-1, 0, 1, 0,
c     *          0, 0, 0, 0, 0, 0, 1/
      data sd / 1, 0, 0, 0,-1, 0, 0,
     *          0, 1, 0, 0, 0,-1, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          0, 0, 0, 1, 0, 1, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/     
c      do 12 j=1,7
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
         do k=1,6
            fi(j)=fi(j)+sd(k,j)*ei(k)
         end do
         else if (j.eq.5) then
             fi(5)=ei(7)
             fi(6)=0
         end if
      end do
      return
      end

      integer function multpl(h,hs)
      integer h(*),hs(6,*)
      integer hr(6)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      mul=0
      do ns=1,nsymo
         do j=0,1
            call gethr(h,hr,r,ns,j)
            do k=1,mul
               if(icomp(hr,hs(1,k)).eq.1) then
                  go to 100
               end if
            end do
            mul=mul+1
            do k=1,6
               hs(k,mul)=hr(k)
            end do
 100        continue
         end do
      end do
      multpl=mul
      return
      end

      subroutine setbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv0=brv
      return
      end

      subroutine getbrv(brv)
      character brv0,brv
      common /cbrv/ brv0
      brv=brv0
      return
      end

      integer function getidm()
      common /cdim/ idm,nde
      getidm=idm
      return
      end

      integer function getndm()
      common /cdim/ idm,nde
      getndm=nde
      return
      end

      integer function getnde()
      common /cdim/ idm,nde
      getnde=nde
      return
      end

      subroutine setidm(idmd)
      common /cdim/ idm,nde
      idm=idmd
      return
      end

      subroutine setndm(ndmd)
      common /cdim/ idm,nde
      nde=ndmd
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end

      integer function icomp(h,hr)
      integer h(*),hr(*)
      icomp=0
      do i=1,6
         if(h(i).ne.hr(i)) return
      end do
      icomp=1
      return
      end

      subroutine gcoset0(iaslct,j) ! coset number for all R
c     j-th OD  ****** different from gcoset1
c     iaslct(k,j) 1 for k-th symmetry operator is included in the site symmetry
c     
      integer iaslct(120,*)

      include 'qcdiff.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      real t0(6)
      data t0 /0.,0.,0.,0.,0.,0./

c     calculate coset for pseudo-sitesymmetry
c     generate all the symmetry operation including inversion (rd)
      call zerovi(icost,120)
      n=0
      do icnt=0,icent
         do ns=1,nsymo
            n=n+1
            call micpy(r(1,1,ns),rd(1,1,n))
            if(icnt.eq.1) then
               call invr(rd(1,1,n))
            end if
         end do
      end do

c     select symmetry operations of occupation domain (rsub)
      ne=nsymo*(1+icent)
      n=0
      do ns=1,ne
         if(iaslct(ns,j).eq.1) then
            n=n+1
            call micpy(rd(1,1,ns),rsub(1,1,n))
         end if
      end do
      nsub=n          ! order of subgroup
      ncst(j)=ne/nsub    ! number of cosets
c     write(6,*) 'rsub created, nsub, ncst', nsub, ncst
c     generate cosets
      nc=0
      do ns=1,ne
         if(icost(ns).eq.0) then
            nc=nc+1
            cosrep(nc,j)=ns   ! coset representativ of the nc-th coset
            call getcos(nc,ns,nsub,coset(1,j))
         end if
      end do
      write(6,*) 'p.o.d. ',j,' number of cosets=',nc
      write(6,'(a,20i4/(7x,20i4))') 'cosrep=',(cosrep(k,j),k=1,ncst(j))
      write(6,'(a,20i4/(7x,20i4))') 'coset =',(coset(k,j),k=1,ne)
      return
      end 

      subroutine gcoset1(iaslct,j) ! coset number for all R
c     j-th atom   ***** different from gcoset0
c     iaslct(k,j) 1 for k-th symmetry operator is included in the site symmetry
c     
      integer iaslct(120,*)

      include 'qcdiff.inc'
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      real t0(6)
      data t0 /0.,0.,0.,0.,0.,0./

c     calculate coset for real-sitesymmetry
c     generate all the symmetry operation including inversion (rd)
      call zerovi(icost,120)
      n=0
      do icnt=0,icent
         do ns=1,nsymo
            n=n+1
            call micpy(r(1,1,ns),rd(1,1,n))
            if(icnt.eq.1) then
               call invr(rd(1,1,n))
            end if
         end do
      end do

c     select site symmetry operations of occupation domain (rsub)
      ne=nsymo*(1+icent)
      n=0
      do ns=1,ne
         if(iaslct(ns,j).eq.1) then
            n=n+1
            call micpy(rd(1,1,ns),rsub(1,1,n))
         end if
      end do

      nsub=n                    ! order of subgroup
      ncst(j)=ne/nsub           ! number of cosets
c     write(6,*) 'rsub created, nsub, ncst', nsub, ncst
c     generate cosets
      nc=0
      do ns=1,ne
         if(icost(ns).eq.0) then
            nc=nc+1
            cosrep(nc,j)=ns   ! coset representativ of the nc-th coset
            call getcos(nc,ns,nsub,coset(1,j))
         end if
      end do
      write(6,*) 'p.o.d. ',j,' number of cosets=',nc
      write(6,'(a,20i4/(7x,20i4))') 'cosrep=',(cosrep(k,j),k=1,ncst(j))
      write(6,'(a,20i4/(7x,20i4))') 'coset =',(coset(k,j),k=1,ne)
      return
      end 

      subroutine getcos(nc,ns,nsub,coset)
c     get coset elements of the nc-th coset with the
c     coset representative ns
      integer coset(*)
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      integer rx(6,6)
      real t0(6)
      data t0/0.,0.,0.,0.,0.,0./
      do i=1,nsub
c        call mtmul(rd(1,1,ns),rsub(1,1,i),rx)
c        call getson(nsd,rx)   ! rd(ns)*rsub = rd(nsd)
c         call mtmul(rsub(1,1,i),rd(1,1,ns),rx)
c         call getson(nsd,rx)   ! rsub*rd(ns) = rd(nsd)
         call mtmul(rd(1,1,ns),rsub(1,1,i),rx)
         call getson(nsd,rx)   ! rd(ns)*rsub = rd(nsd)
         icost(nsd)=nc
         coset(nsd)=nc
      end do
      return
      end

      subroutine getson(ns,rx)
c     get symmetry operation number (ns) from matrix rd
      integer rx(6,6)
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      real t0(6)
      data t0 /0., 0., 0., 0., 0., 0./
      do ns=1,nsymo*(1+icent)
         do i=1,6
            do j=1,6
               if(rx(i,j).ne.rd(i,j,ns)) go to 100
            end do
         end do
c        rx is equal to ns-th symmetry operator
         return    ! return ns
 100     continue
      end do
      call quit('error in getson')
      return
      end

      subroutine getprmmtrx()   ! get permutation matrix
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
c     real xi(6,namax)
      integer coset,cosrep
      common /ccoset/ coset(120,namax),ncst(namax),cosrep(120,namax)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer rd,rsub
      common /cgetson/ rd(6,6,120),rsub(6,6,120),icost(120)
      integer prmtbl
      common /cprmtbl/ prmtbl(120,namax)
      integer rx(6,6)
      integer getish,getisyd
      write(6,'(2a)') 'permutation matrix for each atom given ',
     *     'by predefined o.d. and isyd'
      do n=1,na
         ishn=getish(n)
c         if(ishn.le.0.or.ishn.gt.ne) then
c            write(6,*) 'atom No, ne, ish in getprm=',n, ne, ishn
c            call quit('ish > ne or ish <= 0  invalid ish')
c         end if
         isd=getisyd(n)         ! isyd in .atm file
         if(ishn.gt.0) then
            nd=ishn             ! OD number
*********************************** A. Yamamoto Apr. 24, 2003
c           do i=1,ncst(nd)
c              icr=cosrep(i,nd) ! coset representative No.
***********************************
            do i=1,ncst(n)     ! number of cosets
               icr=cosrep(i,n) ! coset representative No.
               if(icr.gt.120.or.icr.le.0.or.isd.gt.120.or.isd.le.0) then
                  write(6,'(2a,5i5)')
     *                 'atom No., OD NO., coset rep NO.,',
     *                 ' icr, isyd in getprm=',
     *                 n,ishn,i,icr,isd
                  call quit('icr or isd > 120 or <=0')
               end if
               call mtmul(rd(1,1,icr),rd(1,1,isd),rx)
               call getson(nsd,rx) ! get sym. op. number for rx
***********************************************************
c               prmtbl(i,n)=coset(nsd,nd)
***********************************************************
               prmtbl(i,n)=coset(nsd,n)
            end do
            write(6,'(a,i3,1x,20i4/(9x,20i4))') 'atom=',n,
***********************************************************
c     *           (prmtbl(i,n),i=1,ncst(nd))
***********************************************************
     *           (prmtbl(i,n),i=1,ncst(n))
         end if
      end do
      return
      end

      subroutine invr(r)
      integer r(6,6)
      do i=1,6
         do j=1,6
            r(i,j)=-r(i,j)
         end do
      end do
      return
      end

      integer function rcomp(x,rx)
c     return 1 if x=rx else 0
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      integer getidm
      data eps/0.00001/
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      call getsys(isys)
      idm=getidm()
c      if(isys.le.2) then
c         idm=6
c      else
c         idm=5
c      end if
      rcomp=0
      do j=1,ntrc
         do i=1,idm
            xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
            xx=mod(xx,1.)
            if(xx.gt.1.-eps) then
               xx=abs(xx-1.)
            else if(xx.lt.-1.+eps) then
               xx=abs(xx+1.)
            end if
            if(xx.gt.eps) go to 110
         end do
         rcomp=1
         return
 110     continue
      end do
      return
      end

      subroutine resetirs(iaslct)
c     replace site symmetry operator with fictitious one for ish > 0
c     which is given by iaslct
      integer iaslct(120,*)  ! flags for site symmetry operators
      include 'qcdiff.inc'
      real mpl
      common /toqcd2/ na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      integer r
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getish
      write(6,*) 'site symmetry operator used'
      do n=1,na
c         write(6,*) 'atom=',n
c         write(6,'(60i1)') (iaslct(j,n),j=1,120)
         if(getish(n).gt.0) then
            irs0=0
            do i=1,nsymo*(1+icent)
               if(iaslct(i,n).eq.1) then
                  irs0=irs0+1      ! count site symmetry operators
                  irs(irs0,n)=i    ! site symmetry number
               end if
            end do
            irs(0,n)=irs0    
         end if
         write(6,'(a,i3,2x,20i4/(10x,20i4))')
     *        'atom=',n,(irs(j,n),j=1,irs(0,n))
      end do
      return
      end
