c     parameter (nhklt=10*10*10)	
      include 'nhklt.inc'
      parameter (nts=nhklt*nhklt)


c     for 1D array for structure factor or electron density
      real br(0:nts-1),bi(0:nts-1)
      common /abcdri/ br,bi   

c     logical (1bite) array for choosing independent part
      logical isold(0:nts-1)

c     for independent reflections
      parameter (nts0=nts/4)   ! number of independent points
      real br0(0:nts0),bi0(0:nts0)    ! independent structure factors
      real xr0(0:nts0)         ! density at independent grids points
      integer hkl0(0:nts0)     ! 1D index for independent reflections
      integer ix0(0:nts0)      ! 1D index for independent grid points
      integer ntf0             ! number of independent reflections
      integer ntx0             ! number of independent grid points
      common /abcdri0/ br0,bi0,xr0,hkl0,ix0,ntf0,ntx0
c     for saving old values
      real br0_old(0:nts0),bi0_old(0:nts0) ! independent structure factors
      real xr0_old(0:nts0)     ! density at independent grids points
      common /abcdri0_old/ br0_old,bi0_old,xr0_old

c     for observed reflections
      real ar0(0:nts0),ai0(0:nts0),sgm0(0:nts0)
      integer hklo1d(0:nts0)   ! 1D index for observed reflections
      common /cfobs/ hklo1d,ar0,ai0,sgm0

c     for save xr0
      real xrs0(0:nts0)         ! density at independent grids points
      common /cxr0save/ xrs0
