c
c      compare fft by NIST and fftm by FUJITU
c
c     (1) flnm : filename of xyz file
c     (2) idm ng
c         idm : space dimension
c         ng  : number of divisions along each axis ng(1)-ng(idm)
c
      parameter (nts=1000*1000)
      real cr(0:nts-1),ci(0:nts-1)
      integer ng(6)
      integer mm(7)
      integer getnt
      character*20 flnm
      call setinp(5)
      call setout(6)
      call freadc('flnm=',1,flnm,1)
      call freadi('idm=',1,idm,1)
      call freadi('ng=',idm,ng,0)
      write(6,*) 'flnm,idm,ng=',flnm,idm,(ng(j),j=1,idm)
      if(idm.gt.6.or.idm.lt.1) then
         write(6,*) 'idm should be 1-6'
         call exit(0)
      end if
      call calmm(mm,ng,idm)  ! set mm, hmax, idm
      nt=getnt()
      if(nt.gt.nts) then
         write(6,*) 'nt > nts'
         call exit(0)
      end if
      call openfileu(3,flnm,'UNKNOWN') ! for unformatted file      
      read(unit=3) (cr(i),i=0,nt-1)
      call zerovr(ci,nt)
      close(unit=3)
      write(6,*) (cr(j),j=0,10)
      write(6,*) (ci(j),j=0,10)
      isn=-1
      m=idm
      call cft1(cr,ci,ng,m,isn,icon)
      write(6,*) 'fourier transform'
      write(6,*) (cr(j),j=0,10)
      write(6,*) (ci(j),j=0,10)
      isn=1
      call cft1(cr,ci,ng,m,isn,icon)
      write(6,*) 'inverse fourier transform'
      write(6,*) (cr(j),j=0,10)
      write(6,*) (ci(j),j=0,10)
      stop
      end

      subroutine getsys(isysd)
      isysd=0
      return
      end            

      integer function icomp(h,hr)
      integer h(*),hr(*)
      icomp=0
      do i=1,6
         if(h(i).ne.hr(i)) return
      end do
      icomp=1
      return
      end
