      subroutine geta(a1,a2)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
c     common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      a1=al
      a2=am
      return
      end

      subroutine getc(c)
      real al,am,cl,eps1,eps2,eps3,eps4
      common /cgetq/ dr(6,6),dq(6,6),de(6,6),di(6,6),
     *          al,am,cl,eps1,eps2,eps3,eps4,eps5,eps6
c     common /cgetq2/ al,am,cl,eps1,eps2,eps3,eps4
      c=cl
      return
      end

      subroutine setjsimod(jsimod0)
      common /copd4/ jsimod
      jsimod=jsimod0
      return
      end

      integer function getjsimod()
      common /copd4/ jsimod
      getjsimod=jsimod
      return
      end

      subroutine chkcolsym(npod)
c     check whether color symmetry operators are included in the site
c     symmetry operators used or not, since the present version
c     does not allow color symmetry operators for them
      include 'polygn.inc'
      common /cislct0/ iaslct0(120,namax)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      call getsys(isys)
      if(isys.ne.3) then ! if not decagonal return
         return
      end if
c     for decagonal system only
      do i=1,npod
         do j=1,nsymo*(icent+1)
            call rednsic(j,ns,ic)
            if(iaslct0(j,i).eq.1) then
               if(ic.eq.0.and.r(6,6,ns).eq.-1) then
                  write(6,*) 'symmetry operator no.',j,' in od no.',i
                  call quit('is a color symmetry inhibited')
               end if
            end if
         end do
      end do
      return
      end

      subroutine rtorsxi()   ! transformation of ej in 6D representation
      include 'polygn.inc'
      real ej0
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real xd(6),xf(6)
      do j=1,nej0(i)
c         call trto5e(ej0(1,j,i),xd)
c         call getxe0(ej0(1,j,i),xd)  ! back to 
c         call celltr(xd,1)
         call celltr(ej0(1,j,i),1)
         call tr5to6e(xd,xf)
         write(6,'(a,6f10.6)') 'ej=',(xf(k),k=1,6)
         call getqe0(xd,ej0(1,j,i))
      end do
      return
      end

      subroutine rdpod(npod)
      include 'polygn.inc'
      common /cwflag/ iwflag(6)
      real ramin00,ramax00
      common /copd1/ ramin00(namax),ramax00(namax)
      real ej0
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      common /cislct0/ iaslct0(120,namax)
      common /ctype/ ityp(-2:namax)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      common /copd4/ jsimod
      real ejd(7)

      character*40 str
      character brv
c     real fj(6,nemax)
      integer getapprx

      call getsys(isys)
      call getinp(inpu)
      call getout(iout)
      call getbrv(brv)
c     write(6,*) 'brv in rdpod=',brv
      iapprx=getapprx()

      iwflag(3)=1
      do i=1,npod
         read(inpu,*) nn, nej0(i), ityp(i), str
         iln=istrln(str)
         do j=1,nej0(i)
            call freadrv('ej=',6,ej0(1,j,i),1)
            if(iwflag(3).eq.1.and.j.eq.1) then
               write(6,'(3i4,3a)') nn,nej0(i),ityp(i),
     *              ' ''',str(1:iln),''''
            end if
            call vcpyr(ej0(1,j,i),ejd,7)
            if(brv.eq.'s') then
c     call celltr6(ej0(1,j,i),1)
               call celltr6(ejd,1)
            end if
c     write(6,303) 'ej=', (ej0(k,j,i),k=1,6)
            write(6,303) 'ej=', (ejd(k),k=1,6)
         end do
         call freadi('nth=',1,nth0(i),1)
c         write(6,*) 'nth=',nth0(i),' isys=',isys
         if(nth0(i).gt.nemax) call quit('nth > nemax')
         do j=1,nth0(i)
            if(isys.le.2) then
               call freadiv(' ',3,mej0(1,j,i),0)
            else
               call freadiv(' ',2,mej0(1,j,i),0)
            end if
         end do
         if(isys.le.2) then
            write(6,'(a,40i3)') 'nth=',nth0(i),
     *           ((mej0(k,j,i),k=1,3),j=1,nth0(i))
         else
            write(6,'(a,40i3)') 'nth=',nth0(i),
     *           ((mej0(k,j,i),k=1,2),j=1,nth0(i))
         end if
         read(inpu,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
         write(iout,'(60i1)') (iaslct0(j,i),j=1,nsymo*(icent+1))
      end do
 300  format(1h )
 301  format(1h ,'na=',i3)
 302  format(1h ,3i2,2x,a)
 303  format(1h ,a,6f10.5,2x,a,f10.5)
      return
      end

      subroutine getni(na,ni)
      include 'polygn.inc'
      real ni(0:6,4,nemax,*)
      real p0,s0,ra,rb
      common /cstfc2/ p0(namax),s0(2,namax),ra(namax),rb(namax)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent

      real td(6)
      real e0(3)

      data e0/0.0,0.0,0.0/
      data eps/0.00001/, td/6*0./
c      unit vector along ej and
c      normal to the boundary plane defined by ej(*,i), ej(*,i+1)
      do 90 i=1,na
         do 91 j=1,nth(i)
            j1=mej(1,j,i)
            j2=mej(2,j,i)
            j3=mej(3,j,i)
            if(j1.gt.nej(i)) then
               call quit('j1 > ne')
            else if (j2.gt.nej(i)) then
               call quit('j2 > ne')
            else if (j3.gt.nej(i)) then
               call quit('j3 > ne')
            end if
            if(j.gt.nemax) then
               call quit('nth > nemax')
            end if

            do k=0,6
               ni(k,1,j,i)=0
               ni(k,2,j,i)=0
               ni(k,3,j,i)=0
               ni(k,4,j,i)=0
            end do
            
c     get normal to 4-planes of a tetrahedron
            call ni3(ej(4,j1,i),ej(4,j2,i),ej(4,j3,i),e0,
     *           ni(4,1,j,i),ni(4,2,j,i),ni(4,3,j,i),ni(4,4,j,i))
                            ! get outward plane normal for a tetrahedton
            ni(0,4,j,i)=vinp(ni(4,4,j,i),ej(4,j1,i),3) ! distance to tri.
            
            if(p0(i).lt.0) then
               do k=4,6
                  do l=1,4
                     ni(k,l,j,i)=-ni(k,l,j,i)
                  end do
               end do
            end if
 91      continue
 90   continue
      return
      end

      subroutine setnpod(npo)
      common /copd3/ npod
      npod=npo
      return
      end

      subroutine getnpod(npodd)
      common /copd3/ npod
      npodd=npod
      return
      end

      subroutine vivoli(na,mpl,isk,irs)
c     volume of each occupation domain
      integer isk(0:120,*), irs(0:120,*)
      real mpl(*)
      include 'polygn.inc'
      real xe1,xe2,xe3,xi
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real ej
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)

c      common /cpnf1/ ne,atp(3),atp0(3),iel(3,nemax)
      common /cpnf1/ atp(3),atp0(3),iel(3,nemax),ne

c     common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      real p,s,ramin,ramax
      common /cstfc2/ p(namax),s(2,namax),ramin(namax),ramax(namax)

      real vn(namax)
      real vi(nemax,namax)
      real e1e2(6), po(3)
      real vinp
      real vabs,absh,absn1
      character brv
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer hr(6)
c      data pi2/6.28318/, eps/0.001/, ras/1.4325/
      data pi2/6.28318/, eps/0.001/, ras/1./
      data hr/0,0,0,0,0,0/

      pi4=2*pi2
      call getbrv(brv)
      call getsys(isys)
****************
c      atp(1)=0
c      atp(2)=0
c      atp(3)=0
      call geta(al,am)
c      write(6,*) 'partial occupation probabilities'
c      write(6,*) '         p(1)  p(2)  p(3)'
      do 100 n=1,na
c     ****** vi: volume of rhombohedron with edge vecotrs e1,e2,e3
         if(ish(n).ge.0) then
c           tetrahedron
            vn(n)=0
            do  101 j=1,nth(n)
               k1=mej(1,j,n)
               k2=mej(2,j,n)
               k3=mej(3,j,n)
               e1e2(4)=ej(5,k1,n)*ej(6,k2,n)-ej(6,k1,n)*ej(5,k2,n)
               e1e2(5)=ej(6,k1,n)*ej(4,k2,n)-ej(4,k1,n)*ej(6,k2,n)
               e1e2(6)=ej(4,k1,n)*ej(5,k2,n)-ej(5,k1,n)*ej(4,k2,n)
               vi(j,n)=abs(vinp(e1e2(4),ej(4,k3,n),3))
               vn(n)=vn(n)+
     *              vi(j,n)*mpl(n)*isk(0,n)*irs(0,n)*
     *              (ramax(n)**3-ramin(n)**3)/6
 101        continue
         else if(ish(n).eq.-1) then
c           ellipsoid
            r1=vabs(ej(4,1,n),3)
            r2=vabs(ej(4,2,n),3)
            r3=vabs(ej(4,3,n),3)
            vn(n)=pi4*r1*r2*r3*mpl(n)*isk(0,n)*
     *           (ramax(n)**3-ramin(n)**3)*am**3/3
         else if(ish(n).eq.-2) then
c           sphare
            v=pi4*ras**3*am**3/3
            vn(n)=v*mpl(n)*isk(0,n)*(ramax(n)**3-ramin(n)**3)*am**3
         else 
            call quit('invalid ish')
         end if

**************************
         vn(n)=vn(n)/am**3    ! independent of am
c         if(ish(n).ge.0.and.(brv.eq.'f'.or.brv.eq.'s')) then
c            vn(n)=vn(n)*8
c         end if
**************************

 100  continue
      if(icent.eq.1) then
c     if(abs(icent).eq.1) then
         do 80 n=1,na
            vn(n)=vn(n)*2
 80      continue
c         atp(1)=atp(1)*2
c         atp(2)=atp(2)*2
c         atp(3)=atp(3)*2
      else
         do 81 n=1,na
            vn(n)=vn(n)
 81      continue
c         atp(1)=atp(1)
c         atp(2)=atp(2)
c         atp(3)=atp(3)
      end if
      vt=0
      do 82 n=1,na
         vt=vt+vn(n)*p(n)
 82   continue
      if(brv.eq.'p') then
         fact=1
      else if(isys.le.2.and.(brv.eq.'f'.or.brv.eq.'s')) then
         fact=32
      else if(brv.eq.'i') then
         fact=2
      else if(brv.eq.'g') then
         fact=1
      else
         call quit('invalid brv in vivoli')
      end if
      write(6,*) 'volume of the occupation domain',vt,'(a**3)'
      write(6,'(4(a,i3,f12.6))') (' atom',n,vn(n)*p(n),n=1,na)
      call getdet(det)

      write(6,'(a,f12.6,a,a,f12.6,a)')
     *     '  point density=', vt*abs(det)*fact, '(a**-3)',
     *     ' = ',vt*abs(det)*fact/al**3,'(A**-3)'
      return
      end

      subroutine getfjd1(fj1) ! vector under linear phason
      real fj1(*)
      real xd1(6)
      call vcpyr(fj1,xd1,6)
      call getqed(xd1,fj1)   ! cartesian coordinates under l. phason
      return
      end

      subroutine getfjd3(fj1,fj2,fj3) ! vector under linear phason
      real fj1(*),fj2(*),fj3(*)
      call getfjd1(fj1)
      call getfjd1(fj2)
      call getfjd1(fj3)
      return
      end

      subroutine ni3(e1,e2,e3,e0,n1,n2,n3,n4)
      real e1(*),e2(*),e3(*),e0(*)
      real n1(*),n2(*),n3(*),n4(*)
      real d

c     get normal to the plane
      call getni3(e1,e2,e0,e3,n1,d)  ! normal to e1,e2,e0 plane from e3
      call getni3(e2,e3,e0,e1,n2,d)
      call getni3(e3,e1,e0,e2,n3,d)
      call getni3(e1,e2,e3,e0,n4,d)
      return
      end 


