      subroutine drwrhmo(npln)
      include 'impr8.inc'
      include 'drw.inc'

      common /ctmin/ nsz(memax)
      integer nszd(memax),nsze(memax)

      real*8 eps0
      common /ceps0/ eps0
      common /ctst/ itst, nmax, iout

      integer ipr(memax)
      integer st(memax*2)

c     initialize
      do id=1,npln
         ipr(id)=0
         tmin(id)=zmin(id)
      end do
      call qsort(tmin,st,nsz,npln)
      is=1
      nerr=0

c     take an average if several points are within a specified small range
      call averg(npln)
c     remove common edge in a plan
      call rmvedg(npln)
c       Newell-Newell-Snacha algolithm for drawing polygon      

 312  continue
      i=nsz(is)
      do 310 jd=is+1,npln
         j=nsz(jd)
         
         if(zmax(i).lt.zmin(j)-eps0*2) then
c           i-th plane does not hide j-th plane
            go to 310
         end if
         
         if(ibbox(i,j).eq.0) then
c           bounding boxes do not overlap
c           therefore i-th plane does not hide j-th plane
            go to 310
         end if

c          idepth(i,j,iw) gives
c          0 if i-th plane is on j-th plane
c          1 if i-th plane is behind j-th plane
c          2 if i-th plane is before j-th plane
c         -1 else
         
         iw=0
c        idpth1=idepth(i,j,iw)
         idpth1=idepth0(i,j,iw)
         if(idpth1.eq.1.or.idpth1.eq.0) then
c           i behind j
            go to 310   ! i does not hide j
         end if

c        idpth2=idepth(j,i,iw)
         idpth2=idepth0(j,i,iw)
         if(idpth2.eq.2) then
c           j before i 
            go to 310   ! i does not hide j
         end if
         
c        idpth=-1
c        function ispps(i,j) gives
c         1 if i hides j
c         0 else

         if(isppso(i,j).eq.0) then
            go to 310  ! i does not cross j
         end if         

c     i-th triangle hides j-th one
c     
         if(ipr(j).eq.0) then 
c           interchange i and j (interchange P and Q)
            nsz(is)=j
            nsz(jd)=i
c           set mark
            ipr(j)=1 
            go to 312
         end if
         
c     ipr(j)=1  previously interchanged
c     i-th plane partly hides j-th plane
c     divide i and j-th triangle into two or three parts

         jdivide=idivide(i,j,is,npln,0) ! divide i-th triangle if possible
         if(jdivide.eq.0) go to 310     ! i not divided
c        reset mark
         do id=is,npln
            ipr(nsz(id))=0
         end do 
         go to 312 
 310  continue
c     draw i-th triangle
      if(itst.eq.0) then  
        call trangl0(i)    
      else
c        call tranglt(i)    
        call trangl0(i)    
      end if              
      is=is+1
      
c     reset mark
      do id=is,npln
         ipr(nsz(id))=0
      end do 
      
      if(is.le.npln) then
         go to 312
      end if
      return
      end
