      subroutine setprjop0()    ! no phason
      real prjoext0,prjoint0
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      real prjoext2(6,6),prjoint2(6,6) ! for check
      call prjopext0(prjoext0)
      call prjopint0(prjoint0)
      call wtrmtrx6('prjoext0',prjoext0)
      call wtrmtrx6('prjoint0',prjoint0)
      ! p^2 should be equal to p for projection operator
c      call mtmplr6(prjoext0,prjoext0,prjoext2)
c      call mtmplr6(prjoint0,prjoint0,prjoint2)
c      call wtrmtrx6('prjoext2',prjoext2)
c      call wtrmtrx6('prjoint2',prjoint2)
      return
      end

      subroutine setprjop()    ! under phason
      real prjoext,prjoint
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      real prjoext2(6,6),prjoint2(6,6) ! for check
      call prjopext(prjoext)
      call prjopint(prjoint)
      call wtrmtrx6('prjoext',prjoext)
      call wtrmtrx6('prjoint',prjoint)
      ! p^2 should be equal to p for projection operator
c      call mtmplr6(prjoext,prjoext,prjoext2)
c      call mtmplr6(prjoint,prjoint,prjoint2)
c      call wtrmtrx6('prjoext2',prjoext2)
c      call wtrmtrx6('prjoint2',prjoint2)
      return
      end

      subroutine prjext(x,xe)   ! under phason
      real x(*),xe(*)
      real prjoext,prjoint
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplmnor(prjoext,x,xe,6,6,1)
      return
      end

      subroutine prjint(x,xi)   ! under phason
      real x(*),xi(*)
      real prjoext,prjoint
      common /cprjop/ prjoext(6,6),prjoint(6,6)
      call mtmplmnor(prjoint,x,xi,6,6,1)
      return
      end

      subroutine prjext0(x,xe)  ! no phason
      real x(*),xe(*)
      real prjoext0,prjoint0
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoext0,x,xe,6,6,1)
      return
      end

      subroutine prjext1(x,xe)  ! projection onto ext space and normalize
      real x(*),xe(*)
      real q(6)
      real prjoext0,prjoint0
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoext0,x,xe,6,6,1)
      call getqe(xe,q)
      call norml(q,6)    ! normalize
      call getxe(q,xe)   ! q to x
      return
      end

      subroutine prjint0(x,xi)  ! no phason
      real x(*),xi(*)
      real prjoext0,prjoint0
      common /cprjop0/ prjoext0(6,6),prjoint0(6,6)
      call mtmplmnor(prjoint0,x,xi,6,6,1)
      return
      end

      subroutine prjopext0(pext)  ! projection operator
      real pext(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3
               pext(i,j)=pext(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint0(pint)  ! projection operator
      real pint(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6
               pint(i,j)=pint(i,j)+dq(i,k)*dr(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopext(pext)  ! projection operator
      real pext(6,6)
      real drd(6,6),dqd(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pext(i,j)=0
            do k=1,3       ! important
               pext(i,j)=pext(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end

      subroutine prjopint(pint)  ! projection operator
      real pint(6,6)
      real drd(6,6),dqd(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      call mtmplr6(de,dr,drd)
      call mtmplr6(dq,di,dqd)
      do i=1,6
         do j=1,6
            pint(i,j)=0
            do k=4,6     ! important
               pint(i,j)=pint(i,j)+dqd(i,k)*drd(k,j)
            end do
         end do
      end do
      return
      end

      subroutine getprji(prji)  ! projection operator in internal space 
      real prji(3,3)
      real drd(6,6),dqd(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,3
         do j=1,3
            prji(i,j)=dr(i+3,j+3)
         end do
      end do
      return
      end

      subroutine getprje(prje)  ! projection operator in external space 
      real prje(3,3)
      real drd(6,6),dqd(6,6)
      real dr,dq,de,di
      common /cgetq1/ dr(6,6),dq(6,6),de(6,6),di(6,6)
      do i=1,3
         do j=1,3
            prje(i,j)=dr(i,j)
         end do
      end do
      return
      end
