      subroutine  getnsymo(nsymod,icentd)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      nsymod=nsymo
      icentd=icent
      return
      end

      subroutine rdsymo(na,brv)
      include 'impr8.inc'
      common /cwflag/ iwflag(6)
      character brv
      character(80) dummy
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /extcr/ nextnc,icef(7,60)
      common /cdim/ idm,nde
      common /cskip/ iskip,ltype

      integer imps(60),rg(6,6,5)
      real tg(6,5)
      character(30) coord
      character cltd(5)

      data cltd/'p','i','f','s','c'/      

c     initialization
      call getinp(inpu)
      call getout(iout)
c     iwflag(3)=1
      ige=1
c
c      read(inpu,100) nsymo,icent,brv
       call freadi('nsymo=',1,nsymo,1)
       call freadi('icent=',1,icent,0)
       call freadc('brv=',1,brv,0)
      nde=3
      icom=0
c
      write(iout,210) nsymo,icent,brv
      do i=1,5
         if(brv.eq.cltd(i)) then
            ltype=i
         end if
      end do
      if(ltype.eq.0) then
c          call quit('ltype incorrect')
         write(6,*) '******ltype=0*****'
      end if
      idm=nde+3
c      read(inpu,*) 'symmetry operator'
      call freadc('symmetry operator',0,dummy,1)
      do k=1,nsymo
         read(inpu,'(a)') coord
         call decode(coord,rr,tt,k)
      end do
      if(iwflag(3).eq.1) then
c     if(icent.eq.1) then
           if(icent.eq.1.or.icent.eq.-1) then
                 write(iout,2022)
           else
                 write(iout,2021)
           end if
           if(ige.eq.1) then
                write(iout,201) 'generating elements'
           end if
           write(iout,'(1h )')
      end if
      nn=nde+1
      if(iwflag(3).eq.1) then
          call wtsymo(rr,tt,nsymo,idm)
      end if
      if(ige.eq.1) then
           call ordr(rr,imps,nsymo,idm)
           do i=1,nsymo
              do j=1,idm
                 tg(j,i)=tt(j,i)
                 do k=1,idm
                    rg(j,k,i)=rr(j,k,i)
                 end do
              end do
           end do
           impt=1
           do i=1,6
              tt(i,1)=0.0
              do j=1,6
                 rr(i,j,1)=0.0
                 rr(i,i,1)=1.0
              end do
           end do
           do ns=1,nsymo
           imp=imps(ns)
c          modified to include the pure translation
           if(imp.eq.1) then
             if(tg(1,ns).ne.0.or.tg(2,ns).ne.0.or.tg(3,ns).ne.0
     *      .or.tg(4,ns).ne.0.or.tg(5,ns).ne.0.or.tg(6,ns).ne.0)
     *       imp=2
           end if
           do i=2,imp
              do j=1,impt
                 mp1=j+(i-2)*impt
                 mp2=j+(i-1)*impt
                 call mpso(rg,tg,ns,rr,tt,mp1,mp2,idm)
              end do
           end do
           impt=impt*imp
        end do
        nsymo=impt
        if(iwflag(3).eq.1) then
           write(iout,207)
           write(iout,'(1h )')
           call wtsymo(rr,tt,nsymo,idm)
        end if
      end if
      if(nextnc.eq.0) return
      if(iwflag(3).eq.1) then
           write(iout,231)
      end if
c      do 90 i=1,nextnc
c      read(inpu,100) (icef(j,i),j=1,6),nmod(i)
c      call freadi('mi=',idm+1,icef(1,i),1)
c      if(iwflag(3).eq.1) then
c           write(iout,230) (icef(j,i),j=1,6),nmod(i)
c           write(iout,230) (icef(j,i),j=1,idm+1)
c      end if
c 90   continue
      return
 201  format(a)
 2021 format('symmetry operation',10x,'noncentrosymmetric')
 2022 format('symmetry operation',10x,'centrosymmetric')
 207  format('symmetry operators generated by generating elements')
 210  format('nsymo=',i3,2x,'icent=',i2,2x,'brv=',a)
 231  format('extinction rules for general reflections'/
     *          'm1,m2,..,m6,m of m1*h1+m2*h2+...+m6*h6=m*n')
      end

      subroutine ordr(re,imps,nsymo,idm)
      integer re(6,6,*),imps(*)
      integer r(6,6),a(6,6),b(6,6)
      data eps/0.001/
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            do k=1,idm
               r(j,k)=re(j,k,i)
               b(j,k)=r(j,k)
            end do
         end do
         do 12 j=1,13
c     check whether r is identity operator or not
            do k=1,idm
               if(r(k,k).ne.1) go to 15
               do l=1,idm
                  if(k.ne.l.and.r(k,l).ne.0) go to 15
               end do
            end do
            imps(i)=j
            go to 10
c     a=r
 15         continue
            do k=1,idm
               do l=1,idm
                  a(k,l)=r(k,l)
               end do
            end do
c     r=a*b   ==> r=r*re
            do k=1,idm
               do l=1,idm
                  r(k,l)=0
                  do m=1,idm
                     r(k,l)=r(k,l)+a(k,m)*b(m,l)
                  end do
               end do
            end do
 12      continue
 10      continue
      end do
      do i=1,nsymo
         if(imps(i).ge.13) then
            ierror=1
            go to 21
         else
            ierror=0
         end if
      end do
 21   continue
      if(ierror.eq.1) then
         write(iout,'(''error in symmetry operator ?'',a,24i3)')
     *        '  order: ',(imps(i),i=1,nsymo)
      end if
      return
      end

      subroutine wtsymo(rr,tt,nsymo,idm)
      include 'impr8.inc'
      integer rr(6,6,*)
      real tt(6,*)
      common /cwflag/ iwflag(6)
      character(3) wtt(6,60)
      integer wd(3),w
      data wd/6,5,4/,eps/0.001/

      call getinp(inpu)
      call getout(iout)
      w=wd(idm-3)
      ll=(nsymo-1)/w+1
      le=nsymo-(ll-1)*w
      call wtsmop(rr,tt,nsymo,idm-3,3)
      write(iout,'(1h )')
      call getwtt(tt,wtt,nsymo,idm)
c      do 31 ii=1,ll
c      lbgn=(ii-1)*w+1
c      if(ii.ne.ll) lend=lbgn+w-1
c      if(ii.eq.ll) lend=lbgn+le-1
c      do 31 i=1,idm
c      if(idm.eq.4) write(iout,204) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.5) write(iout,205) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(idm.eq.6) write(iout,206) ((rr(i,j,k),j=1,idm),wtt(i,k),
c     *                 k=lbgn,lend)
c      if(i.eq.idm) write(iout,'(1h )')
c 31   continue
      return
      end

      subroutine getwtt(tt,wtt,nsymo,idm)
      include 'impr8.inc'
      real tt(6,*)
      character(3) wtt(6,*)
      real rt(8)
      character(3) wt(8)
      data rt/0.,0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data wt/'0','1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data eps/0.00001/
      
      call getinp(inpu)
      call getout(iout)
      do i=1,nsymo
         do j=1,idm
            td=tt(j,i)
            one=1.d0
            td=mod(td,one)
            if(td.lt.-eps) then
               td=td+1
            else if(td.gt.1-eps) then
               td=td-1
            end if
            do k=1,8
               if(abs(td-rt(k)).lt.eps) then
                  wtt(j,i)=wt(k)
                  go to 110
               end if
            end do
 110        continue
         end do
      end do
      return
      end

      subroutine mpso(r1,t1,m1,r2,t2,m2,m3,idm)
      include 'impr8.inc'
      integer r1(6,6,*),r2(6,6,*)
      real t1(6,*),t2(6,*)
      do i=1,idm
         t2(i,m3)=0.0
         do j=1,idm
            t2(i,m3)=t2(i,m3)+r1(i,j,m1)*t2(j,m2)
         end do
         t2(i,m3)=t2(i,m3)+t1(i,m1)
         do j=1,idm
            r2(i,j,m3)=0.0
            do k=1,idm
               r2(i,j,m3)=r2(i,j,m3)+r1(i,k,m1)*r2(k,j,m2)
            end do
         end do
      end do
      return
      end

      subroutine sitesy(na,mpl,x,isk,irs) 
      include 'impr8.inc'
      real mpl(*),x(6,*)
      integer isk(0:120,*),irs(0:120,*)

      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      common /cdim/ idm,nde

      real rx(6)
      real rxs(6,120)
      integer rcomp

      call getsys(isys)
      if(isys.le.2) then
         icentd=icent
         istep=1
      else
         if(icent.eq.0) then
            icentd=icent
            istep=1
         else
            icentd=icent   ! include antisymmetric inversion -1
            istep=icent    ! include antisymmetric inversion -1
         end if
      end if

      do i=1,na
         nsym=0
         nrx=1
         isk(nrx,i)=1
         call savex(x(1,i),rxs(1,nrx))
         do ic=0,icentd,istep
            do ns=1,nsymo
               call getrx(x(1,i),rx,ns,ic)
               do irx=1,nrx
                  if(rcomp(rx,rxs(1,irx)).eq.1) go to 120
               end do
c     site symmetry operator
               nrx=nrx+1
               call savex(rx,rxs(1,nrx))
               if(ic.eq.0) then
                  isk(nrx,i)=ns
               else
                  isk(nrx,i)=ns+nsymo
               end if
 120           continue
c     symmetry operator generating equivalent positions
               if(rcomp(rx,x(1,i)).eq.1) then
                  nsym=nsym+1
                  if(ic.eq.0) then
                     irs(nsym,i)=ns
                  else
                     irs(nsym,i)=ns+nsymo
                  end if
               end if
            end do
         end do
         isk(0,i)=nrx
         irs(0,i)=nsym
         mpl(i)=1

         if(icent.eq.1.or.(icent.eq.-1.and.x(6,i).eq.0.)) then
c           compress symmetry element > nsymo
            n=0
            do j=1,isk(0,i)
               if(isk(j,i).gt.nsymo) go to 201
               n=n+1
            end do
 201        continue
c     n: number of equivalent positions generated by given operators
c     isk(0,i): number of equivalent positions generated by given
c     symmetry operators and inversion
            mpl(i)=float(isk(0,i))/(float(n)*2)
            isk(0,i)=n
         end if
      end do
      write(6,*) 'site symmetry group'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(irs(j,i),j=1,irs(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(irs(j,i),j=1,irs(0,i))
      end do
      write(6,*) 'equivalent position'
      do i=1,na
         write(6,'(a,i3,20i4/(8x,20i4))')
     *        'atom=',i,(isk(j,i),j=1,isk(0,i))
c     write(6,'(a,i3/(20i4))') 'atom=',i,(isk(j,i),j=1,isk(0,i))
      end do
      write(6,*) 'multiplicity'
      do i=1,na
         write(6,'(a,i4,f10.5)') 'atom',i,mpl(i)
      end do
      return
      end

      subroutine getrx(x,rx,ns,ic)   ! symmetry operation
      real x(*),rx(*)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
      integer getisys
      isys=getisys()
      call mtmplmnoir(r(1,1,ns),x,rx,6,6,1)
      if(isys.le.2) then
         call vadd(rx,t(1,ns),rx,6)
         if(ic.eq.1) then
            call vnegater(rx,6)
         end if
      else
         call vadd(rx,t(1,ns),rx,5)
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)            
         end if
      end if
      return
      end

      subroutine getrx1(x,rx,tt,ns,ic)  ! extra translation tt after symm. op.
      real x(6),rx(6),tt(6)
      integer r
      real x0(6),rx0(6)
      integer getisys
      isys=getisys()
*******************************
c     call rmvdst(x,x0)   ! remove distortion is necessary ?
      call vcpyr(x,x0,6)        ! no distortion
*******************************
c     write(6,'(a,2i3,6f10.5)') 'ns,ic,tt',ns,ic,tt
      call getrx(x0,rx0,ns,ic)
      if(isys.le.2) then
         call vadd(rx0,tt,rx0,6)  ! additional translation 
      else
         call vadd(rx0,tt,rx0,5)  ! additional translation
      end if
*******************************
c      call adddst(rx0,rx)    ! restore distortion
      call vcpyr(rx0,rx,6)          ! no distortion
*******************************
      return
      end

      subroutine getrx0(x,rx,ns,ic)  ! just rotate 6D vector
      include 'impr8.inc'
      real x(*),rx(*)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call getsys(isys)
      call mtmplmnoir(rr,x,rx,6,6,1)
      if(isys.le.2) then
         if(ic.eq.1) then
            call vnegater(rx,6)         
         end if
      else
         call vadd(rx,tt,rx,5)
         if(ic.eq.1.or.ic.eq.-1) then
            call vnegater(rx,5)
         end if
         if(ic.eq.-1) then
            rx(6)=-rx(6)
         end if
      end if
      return
      end

      subroutine gethr(h,hr,r,ns,icnt)
      integer h(*),hr(*)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      call mtmplmnoi(h,rr,hr,1,6,6)
      if(icnt.eq.1.or.icnt.eq.-1) then
         call vnegatei(hr,6)
      end if
      return
      end

      integer function rcomp(x,rx)
      include 'impr8.inc'
      real x(*),rx(*)
      common /cskip/ iskip,ltype
      real trc(6,32)
      real xx,eps
      data eps/0.00001/

c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      call gettrc(ltype,trc,ntrc)
      call getsys(isys)
      if(isys.le.2) then
         idm=6
      else
         idm=5
      end if
      rcomp=0
      do j=1,ntrc
         do i=1,idm
            xx=abs(x(i)-rx(i)-trc(i,j))+eps/2
            one=1.d0
            xx=mod(xx,one)
            if(xx.gt.1.-eps) then
               oned=-1.d0
               xx=abs(xx-oned)
            end if
            if(xx.gt.eps) go to 110
         end do
         rcomp=1
         return
 110     continue
      end do
      return
      end

      subroutine gettrc(ltype,trc0,ntrc0)
      include 'impr8.inc'
      real trc0(6,*)
      integer ntrc(5)
      real trc1(6,1),trc2(6,2),trc3(6,32),trc4(6,1),trc5(6,2)
c      data ntrc/1,2,32,1,2/
      data ntrc/1,2,32,32,2/
      data (trc1(i,1),i=1,6) /6*0.0/
      data ((trc2(i,j),i=1,6),j=1,2) /6*0.0,6*0.5/
      data ((trc3(i,j),i=1,6),j=1,32) /
     *   0.0,0.0,0.0,0.0,0.0,0.0,  0.5,0.5,0.0,0.0,0.0,0.0,
     *   0.5,0.0,0.5,0.0,0.0,0.0,  0.5,0.0,0.0,0.5,0.0,0.0,
     *   0.5,0.0,0.0,0.0,0.5,0.0,  0.5,0.0,0.0,0.0,0.0,0.5,
     *   0.0,0.5,0.5,0.0,0.0,0.0,  0.0,0.5,0.0,0.5,0.0,0.0,
     *   0.0,0.5,0.0,0.0,0.5,0.0,  0.0,0.5,0.0,0.0,0.0,0.5,
     *   0.0,0.0,0.5,0.5,0.0,0.0,  0.0,0.0,0.5,0.0,0.5,0.0,
     *   0.0,0.0,0.5,0.0,0.0,0.5,  0.0,0.0,0.0,0.5,0.5,0.0,
     *   0.0,0.0,0.0,0.5,0.0,0.5,  0.0,0.0,0.0,0.0,0.5,0.5,
     *   0.0,0.0,0.5,0.5,0.5,0.5,  0.0,0.5,0.0,0.5,0.5,0.5,
     *   0.0,0.5,0.5,0.0,0.5,0.5,  0.0,0.5,0.5,0.5,0.0,0.5,
     *   0.0,0.5,0.5,0.5,0.5,0.0,  0.5,0.0,0.0,0.5,0.5,0.5,
     *   0.5,0.0,0.5,0.0,0.5,0.5,  0.5,0.0,0.5,0.5,0.0,0.5,
     *   0.5,0.0,0.5,0.5,0.5,0.0,  0.5,0.5,0.0,0.0,0.5,0.5,
     *   0.5,0.5,0.0,0.5,0.0,0.5,  0.5,0.5,0.0,0.5,0.5,0.0,
     *   0.5,0.5,0.5,0.0,0.0,0.5,  0.5,0.5,0.5,0.0,0.5,0.0,
     *   0.5,0.5,0.5,0.5,0.0,0.0,  0.5,0.5,0.5,0.5,0.5,0.5/
      data (trc4(i,1),i=1,6) /6*0.0/
      data ((trc5(i,j),i=1,6),j=1,2) /6*0.0,0.,0.,0.,0.,0.5,0./
      data eps/0.00001/
      call getsys(isys)
c     ltype=1,2,3,4,5 mean p,i,f,s,c in icosahedral lattice
      if(ltype.eq.0.or.ltype.eq.1) then
         ntrc0=1
         ltyped=1
         do j=1,ntrc0
            call vcpyr(trc1(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.2) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc2(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.3) then
         ntrc0=ntrc(ltype)
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc3(1,j),trc0(1,j),6)
         end do
      else if(ltype.eq.4) then
         if(isys.le.2) then
            ntrc0=32
            ltyped=3
            do j=1,ntrc0
               call vcpyr(trc3(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.3) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.4) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         else if(isys.eq.5) then
            ntrc0=1
            ltyped=1
            do j=1,ntrc0
               call vcpyr(trc1(1,j),trc0(1,j),6)
            end do
         end if
      else if(ltype.eq.5) then
         ntrc0=2
         ltyped=ltype
         do j=1,ntrc0
            call vcpyr(trc5(1,j),trc0(1,j),6)
         end do
      end if
      return
      end

      subroutine wtsmop(r1,t1,nsymo,d1,d2)
c*******************************************************************
c         representation of symmetry operators in the i.t. format
c*******************************************************************
      implicit integer (a-z)
      integer r1(6,6,*)
      integer r(6,6),lenc(60),ip(16)
      real t1(6,*),t(6),eps,cnt2(27,6),rtr(7)
      real one
      character xyz(6)
c        for (d2+d1) dimensional case
      character(31) z1(60),bl
      character(3) ntr(7)

      data xyz/'x','y','z','t','u','v'/
      data ntr/'1/2','1/3','2/3','1/4','3/4','1/6','5/6'/
      data rtr/0.5,0.333333,0.666666,0.25,0.75,0.166666,0.833333/
      data bl/'                            '/

      call getinp(inpu)
      call getout(iout)
      eps=0.00001
      d3=d1+d2
c******** write symmetry operators *******
      do ii=1,nsymo
         cp=1
         do i=1,d3
            t(i)=t1(i,ii)
            do j=1,d3
               r(i,j)=r1(i,j,ii)
            end do
         end do
         do i=1,d3
            one=1.d0
            t(i)=mod(t(i),one)
            if(t(i).lt.eps) then
               t(i)=t(i)+1
            else if(t(i).gt.1.0-eps) then
               t(i)=t(i)-1
            end if
         end do
         do i=1,22
            z1(ii)=bl
         end do
         do i=1,d3
            do j=1,7
               if(abs(t(i)-rtr(j)).le.eps) then
                  z1(ii)(cp:cp+2)=ntr(j)
                  cp=cp+3
                  go to 132
               end if
            end do
 132        continue
            do j=1,d3
               if(j.le.d2) then
                  k=j
               else if(j.gt.d2) then
                  k=j+(3-d2)
               end if
               if(r(i,j).eq.1) then
                  if(cp.eq.1) then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else if(z1(ii)(cp-1:cp-1).eq.',') then
                     z1(ii)(cp:cp)=xyz(k)
                     cp=cp+1
                  else
                     z1(ii)(cp:cp+1)='+'//xyz(k)
                     cp=cp+2
                  end if
               else if(r(i,j).eq.-1) then
                  z1(ii)(cp:cp+1)='-'//xyz(k)
                  cp=cp+2
               end if
               if(j.eq.d3.and.i.ne.d3) then
                  z1(ii)(cp:cp)=','
                  cp=cp+1
               else if(j.eq.d3.and.i.eq.d3) then
                  z1(ii)(cp:cp)=';'
                  cp=cp+1
               end if
            end do
         end do
         lenc(ii)=istrln(z1(ii))
      end do
      write(iout,'(6(i3,1x,a,1x))') (ii,z1(ii)(1:lenc(ii)),
     *                                                 ii=1,nsymo)
      return
      end

      subroutine decode(coord,r,t,n)
      include 'impr8.inc'
c     symmetry operation in I.T into matrix representation
      character coord*30
      integer r(6,6,*)
      real t(6,*)
      common /cdim/ idm,nde
      character sym(6)*20,xyz(6)
      data xyz/'x','y','z','t','u','v'/

      call getinp(inpu)
      call getout(iout)
c     position of ',' 
      i=1
      do k=1,idm-1
         m=index(coord(i:30),',')
         if(m.eq.0) call quit(' incorrect symmetry operation')
         sym(k)=coord(i:i+m-2)
         i=i+m
      end do
      sym(idm)=coord(i:30)
c
c     do 30 j=1,idm
      do j=1,6
         t(j,n)=0
c        do k=1,idm
         do k=1,6
            r(j,k,n)=0
         end do
c
c        rotation matrix
         do k=1,idm
            i=index(sym(j),xyz(k))
            if(i.gt.0) then
               if(i.eq.1) then
                  r(j,k,n)=1
               else
                  if(sym(j)(i-1:i-1).eq.'+') then
                     r(j,k,n)=1
                  else
                     r(j,k,n)=-1
                  endif
               endif
            endif
         end do
c
c        translation vector
         i=index(sym(j),'/')
         if(i.gt.0) then
            read(sym(j)(i-1:i-1),'(i1)') n1
            read(sym(j)(i+1:i+1),'(i1)') n2
            t(j,n)=float(n1)/float(n2)
            if(i.ne.2.and.sym(j)(i-2:i-2).eq.'-') t(j,n)=-t(j,n)
         endif
      end do
      end

      subroutine trhtole(yd)
      real yd(*)
      real xd(7)
      integer getisys
      isys=getisys()
      if(isys.le.2) then
         return
      else if(isys.eq.3) then
         call vcpyr(yd,xd,6)
         call tr6to5e(xd,yd)
      else if(isys.eq.4) then
         return
      else if(isys.eq.5) then
         call vcpyr(yd,xd,7)
         call tr7to5e(xd,yd)
      end if
      return
      end

      subroutine tr7to5e(ei,fi)
c       for dodecagonal      
      real fi(*),ei(*)
      integer sd(7,7)
      data sd / 0, 1, 0, 0, 0,-1, 0,
     *          1, 0, 1, 0, 0, 0, 0,
     *          0, 1, 0, 1, 0, 0, 0,
     *          0, 0, 1, 0, 1, 0, 0,
     *          1, 0,-1, 0, 1, 0, 0,
     *          0, 1, 0,-1, 0, 1, 0,
     *          0, 0, 0, 0, 0, 0, 1/
c      data sd/ 2, 0, 1, 0,-1, 0, 0,
c     *         0, 2, 0, 1, 0,-1, 0,
c     *         1, 0, 2, 0, 1, 0, 0,
c     *         0, 1, 0, 2, 0, 1, 0,
c     *         1, 0,-1, 0, 1, 0, 0,
c     *         0, 1, 0,-1, 0, 1, 0,
c     *         0, 0, 0, 0, 0, 0, 1/
c      do j=1,7
      do j=1,6
         fi(j)=0.
         if(j.le.4) then
            do k=1,6
               fi(j)=fi(j)+sd(k,j)*ei(k)
c     fi(j)=fi(j)+sd(k,j)*ei(k)/3
            end do
         else if (j.eq.5) then
            fi(5)=ei(7)
            fi(6)=0
         end if
      end do
      return
      end

 
      subroutine tr6to5e(ei,fi)
      include 'impr8.inc'
      real fi(*),ei(*)
      integer sd(6,6)
      data sd/ 4,-1,-1,-1, 0, 0,
     *        -1, 4,-1,-1, 0, 0,
     *        -1,-1, 4,-1, 0, 0,
     *        -1,-1,-1, 4, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 5, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
            fi(j)=fi(j)+sd(j,k)*ei(k)/5
         end do
      end do
      return
      end

      subroutine tr6to5i(ei,fi)
      integer fi(*),ei(*)
      integer sd(6,6)
      data sd/ 1, 0, 0, 0, 0, 0,
     *         0, 1, 0, 0, 0, 0,
     *         0, 0, 1, 0, 0, 0,
     *         0, 0, 0, 1, 0, 0,
     *        -1,-1,-1,-1, 0, 0,
     *         0, 0, 0, 0, 1, 0/
      do j=1,6
         fi(j)=0.
         do k=1,6
            fi(j)=fi(j)+sd(j,k)*ei(k)
         end do
      end do
      return
      end

      subroutine invisk(na,isk,iski)
      include 'impr8.inc'
      integer isk(0:120,*),iski(0:120,*)

      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent

      integer iord(60),rr(6,6)

      write(6,*) 'inverse operator for each atom'
      call ordr(r,iord,nsymo,6)
      do n=1,na
         iski(0,n)=isk(0,n)
         do i=1,isk(0,n)
            nsy=isk(i,n)
            if(iord(nsy).eq.1.or.iord(nsy).eq.2) then
               iski(i,n)=nsy
            else
               do j=1,nsymo
                  if(iord(nsy).eq.iord(j)) then
                     call mtmpli(r(1,1,nsy),r(1,1,j),rr,6)
                     if(identm(rr).eq.1) then
                        iski(i,n)=j
                        go to 200
                     end if
                  end if
               end do
               call quit('error in invisk')
            end if
 200        continue
         end do
         write(6,*) 'atom',n,'  ',(iski(j,n),j=1,isk(0,n))
      end do
      return
      end

      integer function mpltblv(i,j)
      common /cmpltbl/ mpltbl(120,120)
      mpltblv=mpltbl(i,j)
      return
      end

      subroutine setmpltbl()    ! set multiplication table for symm. op.
      common /cmpltbl/ mpltbl(120,120)
      integer rd(6,6)
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      do i=1,nsymo
         do j=1,nsymo
            call mtmpli(rr(1,1,i),rr(1,1,j),rd,6)
            mpltbl(i,j)=identm1(rd)
         end do
      end do
      if(icent.eq.1) then
         do i=1,nsymo
            do j=1,nsymo
               mpltbl(i,j+nsymo)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j)=mpltbl(i,j)+nsymo
               mpltbl(i+nsymo,j+nsymo)=mpltbl(i,j)
            end do
         end do
      end if
      write(6,*) 'multiplication table of symmetry operators'
      do i=1,nsymo
         write(6,'(60i3)')
     *        (mpltbl(i,j),j=1,nsymo)
      end do
      return
      end

      function identm1(rr)
      integer rr(6,6)
      integer r
      real t
      common /sym/ r(6,6,60),t(6,60),nsymo,icent
c     if rr is identity matrix identm=1 else 0
      identm1=0
      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(rr(i,j).ne.r(i,j,ns)) goto 10
            end do
         end do
         identm1=ns
         return
 10      continue
      end do

      do ns=1,nsymo
         do i=1,6
            do j=1,6
               if(-rr(i,j).ne.r(i,j,ns)) goto 20
            end do
         end do
         identm1=ns+nsymo
         return
 20      continue
      end do
      return
      end

      subroutine rednsic(nsd,ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(nsd.gt.nsymo) then
         ns=nsd-nsymo
         ic=1
      else
         ns=nsd
         ic=0
      end if
      return
      end

      integer function expnsic(ns,ic)
      integer getnsym
      nsymo=getnsym()
      if(ic.eq.0) then
         expnsic=ns
      else
         expnsic=ns+nsymo
      end if
      return
      end

      integer function getnsym()
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      getnsym=nsymo
      return
      end

      integer function geticnt()
      integer rr
      real tt
      common /sym/ rr(6,6,60),tt(6,60),nsymo,icent
      geticnt=icent
      return
      end

      integer function identm(rr)
      integer rr(6,6)
c      if rr is identity matrix identm=1 else 0
      identm=0
      do i=1,6
         do j=1,6
            if(i.eq.j) then
               if(rr(i,i).ne.1) return
            else
               if(rr(i,j).ne.0) return
            end if
         end do
      end do
      identm=1
      return
      end

      subroutine savex(rx,rxs)
      real rx(*),rxs(*)
      common /cdim/ idm,nde
      do i=1,idm
         rxs(i)=rx(i)
      end do
      return
      end
