      integer function getndata()
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      getndata=ndata
      return
      end

      integer function getjob()
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      getjob=job
      return
      end

      real function getdq()
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      getdq=dq
      return
      end

      integer function getnrange()
      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      getnrange=nrange
      return
      end

      real function getdelta()
      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      getdelta=delta
      return
      end

      integer function getnlc()
      common /ctodrw8/ ipt(0:38),nlc
      getnlc=nlc
      return
      end

      subroutine gethklm(i,hklmd)
      integer hklmd(6)
      include 'qcdiff.inc'
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl)
      call vcpyi(hklm(1,i),hklmd,6)
      return
      end

*********subroutine for xray and newtron powder diffraction*******
      subroutine drwpdf(nh,mm,delt,rwp,rwpt,s)
      real mm(*),delt(*)
      include 'qcdiff.inc'
      integer getnlc
      common /ctodrw9/ pb(0:12), dpb(0:12), zps(2)
      common /ctodrw0/ usrmn(nrmax),usrmx(nrmax)
      common /csimul/ dfdx(nxprm,nhkl),nxx
      complex fc
      real qk
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
     *   fo(nhkl),theta0(nhkl),ext(nhkl)
      common /cyo/ yo(nmax+2),qint(nmax+2)
      real syobs(0:3),sydef(0:3),wgref(0:3)
      real x(nmax+2), y(nmax+2), dx, dfdxx(nxprm)
      real def(nmax+2), b(nmax+2)
      integer getjob,getnrange,getndata

      data pi/3.141592/
c      write(6,*) 'pb(0),zps',pb(0),zps
c      write(6,*) 'usrmn(1),usrmx(1)',usrmn(1),usrmx(1)
      fact=pi/180

      call getwght(iwght)
      call intpn()
c     serch maximum structure factor used in pwint
      absfcm=0
      do n=1,nh
          absfc=abs(fc(n))
          if(absfc.gt.absfcm) absfcm=absfc
       end do
      job=getjob()

c     write(6,*) 'job in drwpdf=',job
      if(job.ne.1) then
         yomin=getyomin(syobs(0))
c        write(6,*) 'yomin,syobs(0)=',yomin,syobs(0)
      end if
      if(job.eq.0.and.pb(1).eq.0.0) then
          pb(1)=yomin/1000
      end if

 110  continue
      ymax=0.
      ycmax=0.
      sydef(0)=0
      syobs(1)=0
      sbg=0
      nbg=0
      dx=getdq()
      call setise(0,0)
      is=1
      ns=1
      nlc=getnlc()
      ntotal=0
      do nr=1,getnrange()
         do n=ns,getndata()
            call getxxn(xx,n,x(n),dx)
            if(xx.lt.usrmn(nr)) then
               go to 100
            else if(xx.gt.usrmx(nr)) then
               go to 150
            end if
            ntotal=ntotal+1
c     write(6,*) 'enter pwint'
            yc=pwint(nh,xx,dfdxx,is,bgd,absfcm)
c           write(6,*) 'yc=',yc
            y(n)=yc
            b(n)=bgd
c     nxx: number of refined parameters
c     wgref: weight for individual observation
c     yo(n): observed intensity
c     y (n): calculated intensity
c     b (n): calculated background
            if(job.eq.0.or.job.eq.2) then
               yd=yo(n)
            else
               yd=y(n)
            end if
            if(yd-bgd.gt.ymax) then
               ymax=yd-bgd
            end if
            if(yc-bgd.gt.ycmax) then
               ycmax=yc-bgd
            end if
            if(job.eq.0.and.pb(0).ne.0) then
               wgref(0)=1/yo(n)
               dfoc=yo(n)-y(n)
               sydef(0)=sydef(0)+wgref(0)*dfoc**2
               syobs(1)=syobs(1)+wgref(0)*(yo(n)-bgd)**2
               lk=0
               do j=1,nxx+nlc
                  dej=wgref(0)*dfdxx(j)/syobs(0)
                  delt(j)=delt(j)+dfoc*dej
                  do k=1,j
                     lk=lk+1
                     mm(lk)=mm(lk)+dej*dfdxx(k)
                  end do
               end do
            end if
 100        continue
         end do
 150     ns=n+1
      end do

      if(job.eq.0) then
         if(pb(0).eq.0) then
            pb(0)=ymax/ycmax*100    ! estimate scale factor
            go to 110
         else
            rwp=sqrt(sydef(0)/syobs(0))
            rwpt=sqrt(sydef(0)/syobs(1))
            re=sqrt((ntotal-nxx-nlc)/syobs(0))
            s=rwp/re
         end if
      end if

      if(job.eq.0.or.job.eq.2) then
         call pltyoc(x,yo,y,b,def,ymax,qk,nh)
      else if(job.eq.1) then
         call pltyoc(x,yo,y,b,def,ycmax,qk,nh)
      end if
      return
      end

      function getyomin(syobs0)
      include 'qcdiff.inc'
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      real lenx,leny
c      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      common /ctodrw0/ usrmn(nrmax),usrmx(nrmax)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      common /cyo/ yo(nmax+2),qint(nmax+2)
      integer getnrange

      dx=getdq()
      call getwght(iwght)
c      write(6,*) 'ndata,nrange,iwl,iwght',ndata,nrange,iwl,iwght
c      write(6,*) 'qmin,dx,iwl,iwght',ndata,nrange,iwl,iwght
c      write(6,*) 'usrmn,usrmx',usrmn,usrmx
      yomin=1.0e15
      syobs0=0
      do n=1,ndata
         if(iwl.le.9) then
            xx=qmin+dx*(n-1)
         else if(iwl.eq.10) then              
            if(job.eq.1) then
               xx=qmin+dx*(n-1)
            else if(job.eq.0.or.job.eq.2) then
               xx=qint(n)
            end if
         end if
c        write(6,*) yo(n),qint(n)
         do nr=1,getnrange()
            if(xx.ge.usrmn(nr).and.xx.le.usrmx(nr)) then
               if(iwght.eq.0) then
                  wgref0=1/yo(n)
               else if(iwght.eq.1) then
                  wgref0=1/yo(n)**2
               else if(iwght.eq.2) then
                  wgref0=1/yo(n)**3                     
               end if
               syobs0=syobs0+wgref0*yo(n)**2
               if(yo(n).ne.0.0.and.yo(n).lt.yomin) then
                  yomin=yo(n)
               end if
               go to 49
            end if
         end do
 49      continue
      end do
      getyomin=yomin
c     write(6,*) 'yomin=',yomin
      return
      end

      subroutine getxxn(xx,n,xn,dx)
      include 'qcdiff.inc'
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      common /cyo/ yo(nmax+2),qint(nmax+2)
      common /ctodrw6/ cp(0:2),pp(0:9),pg
      data pi/3.141592/

      fact=pi/180
      if(iwl.le.9) then
         if(ixax.eq.1) then
            xx=qmin+dx*(n-1)
            xn=xx
         else if(ixax.eq.0) then
            xx=qmin+dx*(n-1)
            if(abs(ilp).eq.1) then
               awavl=wavl(1)*2/3+wavl(2)/3
            else
               awavl=wavl(1)
            end if
            xn=sin(xx*fact/2)/awavl*4*pi
         end if
      else if(iwl.eq.10) then
         if(ixax.eq.1) then
            xx=qint(n)
            xn=xx
         else if(ixax.eq.0) then
            xx=qint(n)
            awavl=wavl(1)*cp(1)
            xn=sin(xx*fact/2)/awavl*4*pi
         end if
         if(job.eq.0.or.job.eq.2) then
            xx=qint(n)
            xn=xx
         else if(job.eq.1) then
            xx=qmin+dx*(n-1)
            xn=xx
         end if
      else if(iwl.eq.11) then
         if(ixax.eq.1) then
            xx=qint(n)
            xn=xx
         else
            call quit('invalie ixax')
         end if
         if(job.eq.0.or.job.eq.2) then
            xx=qint(n)
            xn=xx
         else if(job.eq.1) then
            xx=qmin+dx*(n-1)
            xn=xx
         end if
      end if
      return
      end

      subroutine rdyo(istep,nt)
      include 'qcdiff.inc'
      common /cyo/ yo(nmax+2),qint(nmax+2)
      rewind 2
      n=1

 100  continue
      read(2,'(2f12.6)',end=200) yo(n),qint(n)
      n=n+1
      do i=1,istep-1  ! skip several lines if istep > 1
         read(2,'(2f12.6)',end=200) yd,qd
      end do
      go to 100

 200  continue
      nt=n-1
      if(nt.le.1) call quit('yo not found')
      return
      end

c      subroutine pltyoc(x,yo,y,b,def,ymax,qk,hklm,nh,qks,nref)
c      real x(*),yo(*),y(*),b(*),def(*),qk(*),qks(*)
c      integer hklm(*)
      subroutine pltyoc(x,yo,y,b,def,ymax,qk,nh)
      real x(*),yo(*),y(*),b(*),def(*),qk(*)
      include 'qcdiff.inc'
      common /cqks/ qs(6,mhkl),qks(mhkl),fcs(mhkl),mks(mhkl),ihkl(mhkl),
     *   nref,iqs(mhkl),qs0(6,mhkl)
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      real lenx,leny
      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      common /cwxyz/ xw(nmax+2),yw(nmax+2),zw(nmax+2)
      real umn(nrmax),umx(nrmax)
      data pi/3.141592/

c      write(6,*) 'job,ldev=',job,ldev
c      stop

      call orient(2)
      call plots(0.0,0.0,ldev)
      call newpen(2)
c     call plot(0.,2.,-3)
      x1=0.
      y1=-4.
      x2=lenx
      y2=leny+1
      x0=0.07
      y0=0.25
      x3=x1/29.7+x0
      y3=y1/29.7+y0
      x4=x2/29.7+x0
      y4=y2/29.7+y0
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
      call scaledx(umn,umx,qmn,qmx,dlt)         
      write(6,*) 'umn,umx,qmn,qmx,dlt',umn(1),umx(1),qmn,qmx,dlt
c     normalization
      ns=1
      do nr=1,nrange
         n=0
         do i=ns,ndata
            if(x(i).lt.umn(nr)) then
               go to 110
            else if(x(i).gt.umx(nr)) then
               go to 120
            end if
            xwi=(x(i)-qmn)/(qmx-qmn)*(lenx*hscl)
            call scaledy(ywi,y(i),b(i),ymax,vscl,leny)
            n=n+1
            xw(n)=xwi
            yw(n)=ywi
c     write(6,*) 'y,b,ymax,leny,vscl',y(i),b(i),ymax,leng,vscl
            if(job.eq.0.or.job.eq.2) then
               call scaledy(zwi,yo(i),b(i),ymax,vscl,leny)
               zw(n)=zwi
               def(n)=zwi-ywi-2.5
            end if
 110        continue
         end do
 120     continue
c     ns=i+1
         ns=i
         nmx=n
c     plot observed intensity and difference
         xw(nmx+1)=0.
         zw(nmx+1)=0.
         xw(nmx+2)=1.0
         zw(nmx+2)=1.0
         if(job.eq.0.or.job.eq.2) then
c     plot normalized observed intensity
            call line(xw,zw,nmx,1,-1,3)
         end if
 160     continue
         nmx=n
c     plot calculated intensity and difference
         xw(nmx+1)=0.
         yw(nmx+1)=0.
         xw(nmx+2)=1.0
         yw(nmx+2)=1.0
         call line(xw,yw,nmx,1,0,0)
         if(job.eq.0) then
            def(nmx+1)=0.
            def(nmx+2)=1.0
            call line(xw,def,nmx,1,0,0)
         end if
      end do
c     vartical bar to show line with no phason strain
c     if(job.eq.0.or.job.eq.2) then
      call wtbar(qk,nh,wavl,qmn,qmx)
c     end if
c     call wtbar(qk,nh,wavl,qmn,qmx,0)
c     vartical bar to show line under phason strain
c     call wtbar(qks,nref,wavl,qmn,qmx,1)
c     write box and scale
      call wtbox(lenx,leny,qmn,qmx,dlt,job,wavl)
      call plote('end of plot')

      return
      end

c           call scaledx(umn,umx,qmn,qmx,dlt)         
      subroutine scaledx(umn,umx,qmn,qmx,dlt)
      real umn(*),umx(*)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      include 'qcdiff.inc'
      common /ctodrw0/ usrmn(nrmax),usrmx(nrmax)
      common /ctodrw6/ cp(0:2),pp(0:9),pg
      integer getnrange
      data pi/3.141592/
      fact=pi/180

      nrange=getnrange()
      delta=getdelta()
      qmind=max(qmin,usrmn(1))
      qmaxd=min(qmax,usrmx(nrange))
      if(iwl.le.9) then
         if(ixax.eq.1) then
            qmn=qmind
            qmx=qmaxd
            dlt=delta
            do i=1,nrange
               umn(i)=usrmn(i)
               umx(i)=usrmx(i)
            end do
         else if(ixax.eq.0) then
            if(abs(ilp).eq.1) then
               awavl=wavl(1)*2/3+wavl(2)/3
            else
               awavl=wavl(1)
            end if
            qmn=sin(qmind*fact/2)/awavl*4*pi
            qmx=sin(qmaxd*fact/2)/awavl*4*pi
            dlt=sin(delta*fact/2)/awavl*4*pi
            dlt=dlt-mod(dlt,0.1)
            do i=1,nrange
               umn(i)=sin(usrmn(i)*fact/2)/awavl*4*pi
               umx(i)=sin(usrmx(i)*fact/2)/awavl*4*pi
            end do
         end if
      else if(iwl.eq.10) then
         if(ixax.eq.1) then
            qmn=qmind
            qmx=qmaxd
            dlt=delta
            do i=1,nrange
               umn(i)=usrmn(i)
               umx(i)=usrmx(i)
            end do
         else if(ixax.eq.0) then
            awavl=wavl(1)*cp(1)
            qmn=sin(qmind*fact/2)/awavl*4*pi
            qmx=sin(qmaxd*fact/2)/awavl*4*pi
            dlt=sin(delta*fact/2)/awavl*4*pi
            dlt=dlt-mod(dlt,0.1)
            do i=1,nrange
               umn(i)=sin(usrmn(i)*fact/2)/awavl*4*pi
               umx(i)=sin(usrmx(i)*fact/2)/awavl*4*pi
            end do
         end if
      else if(iwl.eq.11) then
         qmn=qmind
         qmx=qmaxd
         dlt=delta
         do i=1,nrange
            umn(i)=usrmn(i)
            umx(i)=usrmx(i)
         end do
      end if
      return
      end

      subroutine scaledy(ywid,y,b,ymax,vscl,leny)
      real leny
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      if(iyax.eq.1) then
c        ywid=(y-b)*vscl*leny/ymax
         ywid=y*vscl*leny/ymax
      else if(iyax.eq.2) then
         ywid=y*vscl
         ywid=log(ywid)*leny/log(ymax)
      else
         call quit('invalid iyax in pltyoc')
      end if
      return
      end

      subroutine wtbox(lenx,leny,qmn,qmx,dlt,job,wavl)
      real lenx,leny,wavl(*)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      character*40 title
      character*10 scale
      real leng, leng1
      data pi/3.141592/
      data eps/0.0001/
      fact=pi/180
      call setfont('/Helvetica-Bold-Scand')
      if(job.eq.0) then
          ybtm=-4
      else
          ybtm=-1.5
      end if
      x1=-1.6
      y1=ybtm-1.6
      x2=lenx+0.6
      y2=leny+1.1
      x0=0.07
      y0=0.25
      x3=x1/29.7+x0
      y3=y1/29.7+y0
      x4=x2/29.7+x0
      y4=y2/29.7+y0
      call window(x1,y1,x2,y2)
      call viewpt(x3,y3,x4,y4)
c       write box
           call draw(0.,ybtm,lenx,ybtm)
           call draw(0.,0.,lenx,0.)
           call draw(lenx,ybtm,lenx,leny+1)
           call draw(lenx,leny+1,0.,leny+1)
           call draw(0.,leny+1,0.,ybtm)
           dx=dlt*lenx/(qmx-qmn)
           dy=leny/10
c       write x axis
           x0=(dlt-mod(qmn-eps,dlt))*lenx/(qmx-qmn)
           xx0=(dlt*5-mod(qmn-eps,dlt*5))*lenx/(qmx-qmn)
           leng=lenx-x0
           leng1=lenx-xx0
           ang=0.
           iside=1
           call axis(x0,ybtm,leng,dx,ang,iside,0.07)
           call axis(xx0,ybtm,leng,dx*5,ang,iside,0.15)
           iside=-1
           call axis(x0,leny+1,leng,dx,ang,iside,0.07)
           call axis(xx0,leny+1,leng,dx*5,ang,iside,0.15)
c       write scale
           nxs=(leng1+eps)/(dx*5)
           iq0=(int((qmn-eps)/(dlt*5))+1)*dlt*5+0.001
           iq1=(int((qmn-eps)/(dlt*5))+1)*dlt*50+0.01
           do i=0,nxs
              if(ixax.eq.1) then
                  iqx=iq0+dlt*5*i+0.001
                  xx1=xx0+dx*5*i
c                  if(iqx.lt.100) then
c                      xx=xx1-0.8
c                  else
c                      xx=xx1-0.6
c                  end if
                  xx=xx1
              else
                  qx=float(iq1)/10.+dlt*5*i+0.001
                  xx1=xx0+dx*5*i
c                  if(qx.lt.10) then
c                      xx=xx1-0.8
c                      yy=xx1-0.2
c                  else
c                      xx=xx1-0.6
c                      yy=xx1+0.0
c                  end if
                  xx=xx1
              end if
              if(ixax.eq.1) then
c                  write(title,'(i3)') iqx
                  if(iqx.lt.10) then
                       write(scale,'(i1)') iqx
                       call csymbol(xx,ybtm-0.6,0.4,scale,ang,1)
                  else if(iqx.lt.100) then
                       write(scale,'(i2)') iqx
                       call csymbol(xx,ybtm-0.6,0.4,scale,ang,2)
                  else
                       write(scale,'(i3)') iqx
                       call csymbol(xx,ybtm-0.6,0.4,scale,ang,3)
                  end if
c                  call symbol(xx,ybtm-0.6,0.4,title,ang,3)
              else if(ixax.eq.0) then
                 if(qx.gt.10.) then
                    write(scale,'(f4.1)') qx
                    call csymbol(xx,ybtm-0.6,0.4,scale,ang,4)
                 else
                    write(scale,'(f3.1)') qx
                    call csymbol(xx,ybtm-0.6,0.4,scale,ang,3)
                 end if
c                  write(title,'(i3)') int(qx*10)
c                  call symbol(xx,ybtm-0.6,0.4,title,ang,3)
c                  call symbol(yy,ybtm-0.6,0.4,'.',ang,1)
              end if
           end do
              if(ixax.eq.0) then
c                  title='Diffraction Vector Q (\\305'
c                  ntitle=26
                  title='Diffraction Vector Q'
                  ntitle=20
                  call csymbol(lenx/2.,ybtm-1.4,0.4,title,ang,ntitle)
c                  call supscr(0.4,'-1',2)
c                  call plntxt(0.4,')',1)
              else if(ixax.eq.1) then
                  title='Diffraction Angle (deg.)'
                  ntitle=24
                  call csymbol(lenx/2.,ybtm-1.4,0.4,title,ang,ntitle)
              end if
              xx=lenx/2-4.5
c       write y axis
           ang=90.
           iside=-1
           call axis(0.,0.,leny+1,dy,ang,iside,0.1)
           if(job.eq.0) then
               call axis(0.,-2.5,0.,dy,ang,iside,0.1)
           end if
           title='Intensity (arb. units)'
           ntitle=22
c           call symbol(-0.6,1.0,0.4,title,ang,ntitle)
           call csymbol(-0.6,leny/2.,0.4,title,ang,ntitle)
           iside=1
           call axis(lenx,0.,leny+1,dy,ang,iside,0.1)
           if(job.eq.0) then
               call axis(lenx,-2.5,0.,dy,ang,iside,0.1)
           end if
      return
      end

      subroutine wtbar(qk,nh,wavl,qmn,qmx)
      real qk(*),wavl(*)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
c      common /cdim/ idm,nde
      real lenx,leny
      common /ctodrw4/ lenx,leny,hscl,vscl,delta,ldev,nrange
      common /ctodrw6/ cp(0:2),pp(0:9),pg
      common /ctodrw9/ pb(0:12), dpb(0:12), zps(2)
      include 'qcdiff.inc'
      common /ctodrw0/ usrmn(nrmax),usrmx(nrmax)
      common /cwxyz/ xw(nmax+2),yw(nmax+2),zw(nmax+2)
      integer hklm(6)
      character brv
      data pi/3.141592/
c     write(6,*) 'nh,wavl(1),wavl(2),qmn,qmx,isat',
c    *            nh,wavl(1),wavl(2),qmn,qmx,isat
      call getbrv(brv)
      fact=pi/180
c      if(iwl.le.7) then
      if(iwl.le.9) then
         if(abs(ilp).eq.1) then
            lwe=2
         else
            lwe=1
         end if
c      else if(iwl.ge.8) then
      else if(iwl.ge.10) then
         lwe=1
      end if
      n=0
      do lw=1,lwe
         do i=1,nh
c           if(iwl.le.10) then
            if(iwl.le.9) then
               if(ixax.eq.0) then
c     x-ray
                  xx=qk(i)*wavl(lw)/2
                  if(xx.gt.0.999) go to 120
                  xk0=2*asin(xx)/fact ! 2-theta in degree
                  xk=xk0+zps(1)
                  xk=sin(xk*fact/2)/(wavl(1)*2/3+wavl(2)/3)*4*pi ! Q
               else if(ixax.eq.1) then
                  xx=qk(i)*wavl(lw)/2
                  if(xx.gt.0.999) go to 130
                  xk0=2*asin(xx)/fact
                  xk=xk0+zps(1) ! 2-theta in degree
               end if
            else if(iwl.eq.10) then
               if(ixax.eq.0) then
c     SOR x-ray or thermal neutron
                  xx=qk(i)*wavl(lw)*cp(1)/2
                  if(xx.gt.0.999) go to 120
                  xk0=2*asin(xx)/fact ! 2-theta in degree
                  xk=xk0+zps(1)
                  xk=sin(xk*fact/2)/(wavl(1)*2/3+wavl(2)/3)*4*pi ! Q
               else if(ixax.eq.1) then
                  xx=qk(i)*wavl(lw)*cp(1)/2
                  if(xx.gt.0.999) go to 130
                  xk0=2*asin(xx)/fact
                  xk=xk0+zps(1) ! 2-theta in degree
               end if
            else if(iwl.eq.11) then
c     TOF neutron
               xk=cp(0)+cp(1)*qk(i)*2*pi+cp(2)*(qk(i)*2*pi)**2 ! Q
            end if
            xk=(xk-qmn)/(qmx-qmn)*lenx*hscl
            call gethklm(i,hklm)
            isat=isatel(hklm,brv)
            if(isat.eq.1) then
               yk=-0.8
            else
               yk=-0.4
            end if
            n=n+1
            if(n.gt.nmax) call quit('n > nmax')
            xw(n)=xk
            yw(n)=yk
c     yw(n)=ykc 
            call vtbar(xk,yk,0.3)
 120        continue
         end do
         nmx=n
         xw(nmx+1)=0.
         yw(nmx+1)=0.
         zw(nmx+1)=0.
         xw(nmx+2)=1.0
         yw(nmx+2)=1.0
         zw(nmx+2)=1.0
c     plot vertical var
         call line1(xw,yw,nmx,1,-1,1,0.3)
 130     continue
      end do
      return
      end

      function fdhda(q,qk)
      real q(*)
      call getsys(isys)
      call geta(al)
      call getam(am)
      if(isys.le.2) then
          dq1da=-q(1)/al
          dq2da=-q(2)/al
          dq3da=-q(3)/al
          fdhda=(q(1)*dq1da+q(2)*dq2da+q(3)*dq3da)/qk
      else
          dq1da=-q(1)/al
          dq2da=-q(2)/al
          fdhda=(q(1)*dq1da+q(2)*dq2da)/qk
      end if
      return
      end

      function fdhdc(q,qk)
c       dummy function for decagonal case
      real q(*)
      call getc(cl)
      dq3dc=-q(3)/cl
      fdhdc=q(3)*dq3dc/qk
      return
      end

      function fdhde1(q,qk)
      real q(*)
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3)
      real dqde1(3)
      do i=1,3
         dqde1(i)=0
         do j=4,6
            dqde1(i)=dqde1(i)-q(j)*amij1(j-3,i)
         end do
c     if(isys.le.2) then
c     dqde1(i)=dqde1(i)/al
c     else
c     if(i.le.2) then
c     dqde1(i)=dqde1(i)/al
c     else
c     dqde1(i)=dqde1(i)/cl
c     end if
c     end if
      end do
      fdhde1=(q(1)*dqde1(1)+q(2)*dqde1(2)+q(3)*dqde1(3))/qk
      return
      end

      function fdhde2(q,qk)
      real q(*)
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3)
      real dqde2(3)

      do i=1,3
         dqde2(i)=0
         do j=4,6
            dqde2(i)=dqde2(i)-q(j)*amij2(j-3,i)
         end do
c     if(isys.le.2) then
c     dqde2(i)=dqde2(i)/al
c     else
c     if(i.le.2) then
c     dqde2(i)=dqde2(i)/al
c     else
c     dqde2(i)=dqde2(i)/cl
c     end if
c     end if
      end do
      fdhde2=(q(1)*dqde2(1)+q(2)*dqde2(2)+q(3)*dqde2(3))/qk
      return
      end

      function fdhde3(q,qk)
      real q(*)
      common /cphasn/ amij1(3,3),amij2(3,3),amij3(3,3)
      real dqde3(3)

      do i=1,3
         dqde3(i)=0
         do j=4,6
            dqde3(i)=dqde3(i)-q(j)*amij3(j-3,i)
         end do
c     if(isys.le.2) then
c     dqde3(i)=dqde3(i)/al
c     else
c     if(i.le.2) then
c     dqde3(i)=dqde3(i)/al
c     else
c     dqde3(i)=dqde3(i)/cl
c     end if
c     end if
      end do
      fdhde3=(q(1)*dqde3(1)+q(2)*dqde3(2)+q(3)*dqde3(3))/qk
      return
      end

      function fdhde4(q,qk)
      real q(*)

      common /cphonn/ bmij1(3,3)
      real dqde4(3)

      do i=1,3
         dqde4(i)=0
         do j=1,3
            dqde4(i)=dqde4(i)-q(j)*bmij1(j,i)
         end do
c     if(isys.le.2) then
c     dqde4(i)=dqde4(i)/al
c     else
c     if(i.le.2) then
c     dqde4(i)=dqde4(i)/al
c     else
c     dqde4(i)=dqde4(i)/cl
c     end if
c     end if
      end do
      fdhde4=(q(1)*dqde4(1)+q(2)*dqde4(2)+q(3)*dqde4(3))/qk
      return
      end

      function fdhdx(dhdgij,dhdkij,i)
      real dhdgij(3,*),dhdkij(3,*)
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      integer ks(15),ls(15)
      real s2(6,6),dhdabc(6)
      data ks/1,2,3,2,1,1,1,1,1,2,2,2,3,3,3/
      data ls/1,2,3,3,3,2,1,2,3,1,2,3,1,2,3/
      call gets2(s2)
      do j=1,6
         dhdabc(j)=0
         do m=1,6
            k=ks(m)
            l=ls(m)
            dhdabc(j)=dhdabc(j)+dhdgij(k,l)*s2(m,j)
         end do
      end do
      fdhdx=0
      do j=1,ntl(i)
         m=il(j,i)
c     k=ks(m)
c     l=ls(m)
         if(m.le.6) then
c     fdhdx=fdhdx+dhdgij(k,l)*cl(j,i)
            fdhdx=fdhdx+dhdabc(m)*cl(j,i)
         else
            fdhdx=fdhdx+dhdkij(k,l)*cl(j,i)
         end if
      end do
      return
      end

      function fd2hdx(dhdgij,dhdkij,l,m)
      real dhdgij(3,*),dhdkij(3,*)
      fd2hdx=-fdhdx(dhdgij,dhdkij,l)*fdhdx(dhdgij,dhdkij,m)
      return
      end

      subroutine dhdg(dhdgij,h,qk)
      integer h(*)
      real qk,dhdgij(3,*),hk,hl
c     derivatives with respect to g(k,l)
      do k=1,3
         do l=k,3
            hk=rh(h,k)
            hl=rh(h,l)
            if(k.eq.l) then
               dhdgij(k,l)=hk*hl/(2*qk)
            else
               dhdgij(k,l)=hk*hl/qk
            end if
            dhdgij(l,k)=dhdgij(k,l)
         end do
      end do
      return
      end

      subroutine dhdk(dhdkij,h,qk)
      integer h(*)
      real qk,dhdkij(3,*),hn
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
c      common /cdim/ idm,nde
      integer getndm
c     derivatives with respect to y(l,k)   
      nde=getndm()
      do k=1,nde
         do l=1,3
            dhdkij(k,l)=0
            do n=1,3
               hn=rh(h,n)
               dhdkij(k,l)=dhdkij(k,l)+h(3+k)*hn*gabn(l,n)/qk
            end do
         end do
      end do
      return
      end

      function rh(h,k)
      integer h(*),k
c      common /cdim/ idm,nde
      common /atomp2/ y(3,3)
      integer getndm
      nde=getndm()
      rh=h(k)
      do m=1,nde
         rh=rh+y(k,m)*h(3+m)
      end do
      return
      end

      function poffct(h,p1,p2,dpof)
      real h(*),dpof(*)
      common /mtrtns/ gabx(3,3),gaby(3,3),gab(3,3),gabn(3,3)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      integer hd
      common /cpref/ hd(6,120),iequiv,pop
      real q1(6),q2(6)
      data pi/3.141592/
c     call getqi0(h,q1)
      call vcpyr(h,q1,3)
      call norml(q1,3)
      arg1=0
      arg2=0
      do i=1,iequiv
         call getqi0(hd(1,i),q2)
         call norml(q2,3)
         cosang=abs(vinpr(q1,q2,3))
         arg1=arg1+(cosang**6-0.5**6)
         arg2=arg2+(cosang**10-0.5**10)
      end do
      arg1=arg1/iequiv
      arg2=arg2/iequiv
      poffct=exp(p1*arg1+p2*arg2)
      dpof(1)=arg1*poffct
      dpof(2)=arg2*poffct
c      write(6,*) 'iequiv,(q1(j),j=1,3),(q2(j),j=1,3),poffct',
c     *     iequiv,(q1(j),j=1,3),(q2(j),j=1,3),poffct
      return
      end

      function backgr(x,pb,dpb)
      real x,pb(0:*),dpb(0:*)
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      real y,pn
      data fact/0.0174533/  ! pi/180
      data pi4 /12.56637/   ! 4*pi
c       pn(i,y): i-th Legendre polynomial
c       -1<=y<=1
      y=(2*x-qmax-qmin)/(qmax-qmin)
      z=pi4*sin(x*fact/2)/wavl(1)
      nbm=12
      nbm1=nbm-6
      if(ibkgr.eq.0) then
         backgr=0
         do n=0,nbm-1
            backgr=backgr+pb(n)*pn(n,y)*1000
            dpb(n)=pn(n,y)*1000
         end do
      else if(ibkgr.eq.1) then
c     x: 2-theta in degree
         backgr=0
         do n=0,nbm1-1
            backgr=backgr+pb(n)*pn(n,y)*1000
            dpb(n)=pn(n,y)*1000
         end do
         do n=nbm1,nbm-1,2
            if(pb(n+1).eq.0) call quit('some pb(n+1) <= 0')
            backgr=backgr+pb(n)*sin(z*pb(n+1))/(z*pb(n+1))*1000
            dpb(n)=sin(z*pb(n+1))/(z*pb(n+1))*1000
            dpb(n+1)=pb(n)*z*cos(z*pb(n+1))/(z*pb(n+1))*1000
     *           -pb(n)*z*sin(z*pb(n+1))/(z*pb(n+1))**2*1000
         end do
      else
         call quit('invalid backgr')
      end if
      return
      end

      function pn(n,y)
!       n-th Legendre polynomial
      parameter (nx=12)
      common /clgndr/ coeff(0:nx/2,0:nx)
      integer s
      pn=0
      do s=0,n/2
         pn=pn+coeff(s,n)*y**(n-2*s)
      end do
      return
      end

      subroutine intpn()
!       initialization of pn
!       generate Legendre polynomial coefficients
      parameter (nx=12)
      common /clgndr/ coeff(0:nx/2,0:nx)
      do n=0,nx
         call lgndr(n,coeff(0,n))
c     write(6,*) 'coeff=',(coeff(i,n),i=0,n/2)
      end do
      return
      end

      subroutine lgndr(n,coeff)
!       calculation of Legendre polynomial coefficients
      real coeff(0:*)
      integer s,factr
      do s=0,n/2
         coeff(s)=((-1)**s/float(2**n))*float(factr(2*n-2*s))/
     *             float(factr(s)*factr(n-s)*factr(n-2*s))
      end do
      return
      end

      integer function factr(s)
      integer s
      if(s.eq.0) then
          factr=1
          return
      else if(s.eq.1) then
          factr=1
          return
      else if(s.eq.2) then
          factr=2
          return
      else
          factr=2
          do i=3,s
          factr=factr*i
          end do
          return
      end if
      end
c
      subroutine setise(i,j)
      common /cisie/ is,ie
      is=i
      ie=j
      return
      end

      subroutine updat1(n,nd,np,mpl,qk,qki,absfc,job) 
c     for xray or thermal neutron
      real absfc
      integer mpl
      include 'qcdiff.inc'
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      common /ctodrw6/ cp(0:2),pp(0:9),pg
      common /ctodrw9/ pb(0:12), dpb(0:12), zps(2)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      real lp
      common /clpfct/ lp(nb)
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      common /cisie/ is,ie
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      real dpof(2)
      data pi/3.141592/
c      write(6,*) 'hwhm(1),gamma,uvw(1),p1,p2,as',
c     *            hwhm(1),gamma,uvw(1),p1,p2,as

c       this routine assumes that is=ie=0 initially
c       to set these initial value ==> call setise(0,0)
      if(n.ge.is.and.n.le.ie) then
c         1<=np<=nb   position in a ring buffer
c         calculated value
********************************
          np=mod(n-1,nb)+1
********************************
          return
      else
c         save new value at np
********************************
          np=mod(n-1,nb)+1
********************************
          if(n.le.nb) then
              is=1
              ie=n
          else if(n.gt.nb) then
              ie=ie+1
              is=is+1
          end if

          xk0=theta(nd)
          yk0=xk0*fact
c         yk0: 2-theta in radian
          tanxk(np)=tan(yk0/2)
          if(ilp.ge.0) then
              tfct(np)=sqrt(uvw(1)*(tanxk(np))**2
     *               +uvw(2)*(tanxk(np))+1)
          else
              tfct(np)=uvw(1)*(tanxk(np))**2+uvw(2)*(tanxk(np))+1
          end if
c         half width at half maximum at xk0
          hwhme(1,np)=(hwhm(1)+hwhm(3)*qki)*tfct(np)
          hwhme(2,np)=(hwhm(2)+hwhm(4)*qki)*tfct(np)
c         normalization factor for g1 and g2
          c1(np)=sqrtpi*hwhme(1,np)
          c2(np)=pi*hwhme(2,np)
          peak(np)=gamma/c1(np)+(1-gamma)/c2(np)
          lp(np)=flp(yk0)
          pof(np)=poffct(qe(1,nd),p1,p2,dpof)
          abf(np)=absorp(yk0,sgm,dabf(np))
          dpodp(1,np)=dpof(1)
          dpodp(2,np)=dpof(2)
          extf(np) = extfct(pg,absfc,qk,mpl,dextfc)
          dextf(np) = dextfc
          if(job.eq.0) then
              if(pb(0).eq.0) then
                  coeff(np)=lp(np)*abf(np)*mpl*pof(np)
                  coeff0(np)=coeff(np)*absfc**2
                  return
              end if
          else
              coeff(np)=lp(np)*abf(np)*mpl*pof(np)
              coeff0(np)=coeff(np)*absfc**2
              return
          end if
c     derivative of theta with respect to diffraction vector
          scl=pb(0)/100
          coeff(np)=lp(np)*abf(np)*mpl*pof(np)
c         coefficient for profile parameters
          coeff0(np)=coeff(np)*absfc**2*scl
c         coefficient for structural parameters
          coeff1(np)=coeff(np)*2*absfc*scl
c         coefficient for prefered orientation function
          coeff2(np)=lp(np)*abf(np)*mpl*absfc**2*scl
c         coefficient for absorption correction parameter
          coeff3(np)=lp(np)*mpl*pof(np)*absfc**2*scl
c          write(6,*) 'coeff,coeff0,coeff1,coeff2,coeff3',
c     *        coeff(np),coeff0(np),coeff1(np),coeff2(np),coeff3(np)
          return
      end if
      end

      real function absorp(th2,sgm,dabf)
      include 'qcdiff.inc'
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      data a1 /1.7133/, b1 /-0.0368/, a2 /-0.0927/, b2 /-0.3750/
c        in order to remove the correlation with the scale factor
c        a1=a2=0 must be used ?
c     data a1 /0/, b1 /-0.0368/, a2 /0/, b2 /-0.3750/
c      if(iwl.le.7) then
      if(iwl.le.9) then          ! xray
          if(ilp.ne.2) then
             absorp=1
             dabf=0
          else if(ilp.eq.2) then
c            absorption for Guinier diffractometer
             secg=1/cos(fi)
             sect=1/cos(th2-fi)
             absorp=(exp(-sgm*secg)-exp(-sgm*sect))/(sgm*(sect-secg))
             dabf=absorp*(sect-secg)*(1.0-1.0/(sgm*(sect-secg)))
          end if
c      else if(iwl.eq.8) then
      else if(iwl.eq.10) then    ! thermal neutron
c         absorption for sylindorical sample
c         Acta Cryst A35 (1979) 248
c         cylinder with darious R, sgm=mu*R
          sn2=(sin(th2/2))**2
c         sn2=(sin(th2/2))**2-0.25
c         absorption for thermal newtron or SOR
          arg1=(a1+b1*sn2)
          arg2=(a2+b2*sn2)
          absorp=exp(-arg1*sgm-arg2*sgm**2)
          dabf=-(arg1+arg2*2*sgm)*absorp
c         write(6,*) 'absorp=',absorp,' dabf=',dabf
c      else if(iwl.eq.9) then
      else if(iwl.eq.11) then
c         no absorption correction for TOF neutron is allowed
          absorp=1
          dabf=0
      end if
      return
      end

      real function flp(th2)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      include 'qcdiff.inc'
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      data pi/3.141592/
c     th2 is 2-theta in radian or q (in TOF)
c      if(iwl.le.7) then   ! xray
      if(iwl.le.9) then   ! xray
c         lp factor for x-ray diffraction
          th2b=2*thbm
          cos2tb=cos(th2b)**2
          sint =sin(th2/2)
          cost =cos(th2/2)
          sin2t=sin(th2/2)**2
          cos2t=cos(th2)**2
          if(ilp.eq.0) then
              flp=1
          else if(ilp.eq.1) then
c             LP factor for usual  diffractometer
              flp=(1+cos2tb*cos2t)/(sin2t*cost)
          else if(ilp.eq.-1) then
c             LP factor for  diffractometer with auto-divergence slit
              flp=(1+cos2tb*cos2t)/(sin2t*cost)*sint
          else if(ilp.eq.2) then
c             LPG factor for Guinier camera (transmission)
c             where fi is the angle between the normal to the specimen
c                   and  primary beam in radian
              flp=(1+cos2tb*cos2t)/(sin2t*cost*cos(th2-fi))
          else
             write(6,*) 'ilp=',ilp,' iwl=',iwl
             call quit('invalid combination of x-ray and ilp?')
          end if
c      else if(iwl.eq.8) then  ! thermal neutron or SOR
      else if(iwl.eq.10) then  ! thermal neutron or SOR
c         lp factor for thermal neutron diffraction or SOR xray
          th2b=2*thbm
          cos2tb=cos(th2b)**2
          sint =sin(th2/2)
          cost =cos(th2/2)
          sin2t=sin(th2/2)**2
          cos2t=cos(th2)**2
          sina=sin(alpha*pi/180.)     ! for KEK SOR
          sinb=sin(th2-alpha*pi/180.)  ! for KEK SOR
          if(ilp.eq.0) then
c             flp=1
             flp=1.0/(sin2t*cost) ! L correction (thermal neutron)
          else if(ilp.eq.1) then
c             LP factor for usual  diffractometer
             flp=(1+cos2tb*cos2t)/(sin2t*cost)
          else if(ilp.eq.3) then  ! KEK  SOR
c             LP factor for usual  diffractometer for KEK SOR
             flp=2*(0.95+0.05*sqrt(cos2tb)*cos2t)/(sin2t*cost)/
     *            (1+sina/sinb)
          else if(ilp.eq.4) then
c     LP factor for ESRF SOR with 96 % polarization
             flp=2*(0.96+0.04*sqrt(cos2tb)*cos2t)/(sin2t*cost)
          else
             write(6,*) 'ilp=',ilp,' iwl=',iwl
             call quit('invalid combination of x-ray and ilp?')
          end if
c      else if(iwl.eq.9) then
      else if(iwl.eq.11) then
          qk=th2
c         lp factor for KEK TOF neutron
          flp=1/qk**2
      else
         call quit('invalid iwl in flp')
      end if
      return
      end

      function prfl1(np,dx0,xk)
      include 'qcdiff.inc'
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      real dx(2),dgdgm(2),dgdx(2),dgdth(2),dgdas(2)
      common /cprfl1/ dgdgmt,dgdtht,dgdast,dgdhei(2),asf,casf
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      real dxx0(1),wght0(1),dxx1(3),wght1(3),dxx2(5),wght2(5)
      real dxx3(7),wght3(7),dxx(7),wght(7)
      data pi/3.141592/

c      Simpson integral
c     data dxx1/0.0,0.5,1.0,0.0,0.0/          !for n=1 simpson
c     data wght1/1,4,1,0,0/                   !for n=1 simpson
c     data dxx2/0.0,0.25,0.5,0.75,1.0/        !for n=2 simpson
c     data wght2/1,4,2,4,1/                   !for n=2 simpson
c       Gauss integral
      data dxx0/0.0/                                           !for n=0 Gauss
      data wght0/2.0/                                          !for n=0 Gauss
      data dxx1/-0.774597,0.0,0.774597/                        !for n=1 Gauss
      data wght1/0.555555,0.888888,0.555555/                   !for n=1 Gauss
      data dxx2/-0.906180,-0.538469,0.0,0.538469,0.906180/     !for n=2 Gauss
      data wght2/0.236927,0.478629,0.568889,0.478629,0.236927/ !for n=2 Gauss
      data dxx3/-.949107,-.741531,-.405845,0.0,0.405845,
     *                   0.741531,0.949107/                    !for n=3 Gauss
      data wght3/0.129484,0.279705,0.381830,0.417959,
     *           0.381830,0.279705,0.129484/                   !for n=3 Gauss

      if(ilp.eq.0.or.ilp.eq.1.or.ilp.eq.-1.or.ilp.eq.3.or.ilp.eq.4)
     *     then
          cotxk=1/tan(xk)
      else if(ilp.eq.2) then
          cotxk=1/(2*cos(xk-fi)*sin(xk))
      else
          call quit('invalid combination of xray and ilp?')
      end if
      shft=as*cotxk
      prfl1=0
      dgdgmt=0
      dgdtht=0
      dgdast=0
      dgdhei(1)=0
      dgdhei(2)=0
      hm1=hwhme(1,np)/2
      hm2=hwhme(1,np)
      hm3=hwhme(1,np)*3/2
      abssft=abs(shft)
      if(abssft.lt.hm1) then
          n=0
      else if(abssft.ge.hm1.and.abssft.lt.hm2) then
          n=1
      else if(abssft.ge.hm2.and.abssft.lt.hm3) then
          n=2
      else
          n=3
      end if
      iend=2*n+1
      do i=1,iend
         if(n.eq.0) then
             dxx(i)=dxx0(i)
             wght(i)=wght0(i)
         else if(n.eq.1) then
             dxx(i)=dxx1(i)
             wght(i)=wght1(i)
         else if(n.eq.2) then
             dxx(i)=dxx2(i)
             wght(i)=wght2(i)
         else if(n.eq.3) then
             dxx(i)=dxx3(i)
             wght(i)=wght3(i)
         end if
      end do     
      do i=1,iend
c        dx1=dx0+dxx(i)**2*shft          !for Simpson
c        dx1das=dxx(i)**2*cotxk          !for Simpson
c        dx1dth=-2                       !for Simpson
         dx1=dx0+(dxx(i)/2+0.5)**2*shft  !for Gauss
         dx1das=(dxx(i)/2+0.5)**2*cotxk  !for Gauss
         dx1dth=-2                       !for Gauss
         dx(1)=dx1/hwhme(1,np)
         dx(2)=dx1/hwhme(2,np)
c        dgdgm(1)=wght(i)*exp(-ln2*dx(1)**2)/c1(np)       !for Simpson
c        dgdgm(2)=wght(i)/(1+dx(2)**2)/c2(np)             !for Simpson
         dgdgm(1)=0.5*wght(i)*exp(-ln2*dx(1)**2)/c1(np)   !for Gauss 
         dgdgm(2)=0.5*wght(i)/(1+dx(2)**2)/c2(np)         !for Gauss
         g1i=dgdgm(1)*gamma
         g2i=dgdgm(2)*(1-gamma)
         prfl1=prfl1+(g1i+g2i)
         dgdx(1)=-ln2*2*dx(1)*g1i
         dgdx(2)=-2.0*dx(2)*g2i/(1+dx(2)**2)
         dgdth(1)=dgdx(1)/hwhme(1,np)*dx1dth
         dgdth(2)=dgdx(2)/hwhme(2,np)*dx1dth
         dgdas(1)=dgdx(1)/hwhme(1,np)*dx1das
         dgdas(2)=dgdx(2)/hwhme(2,np)*dx1das
         dgdgmt=dgdgmt+dgdgm(1)-dgdgm(2)
         dgdtht=dgdtht+dgdth(1)+dgdth(2)
         dgdast=dgdast+dgdas(1)+dgdas(2)
         dgdhei(1)=dgdhei(1)+
     *        dgdx(1)*(-dx(1)/hwhme(1,np))-sqrtpi*g1i/c1(np)
         dgdhei(2)=dgdhei(2)+
     *        dgdx(2)*(-dx(2)/hwhme(2,np))-pi*g2i/c2(np)
      end do
      asf=1
      return
      end

      subroutine dprfl1(dth2dc1,np,derc,derp,qki)
                                ! for x-ray or thermal neutron
      real derc(0:*),derp(0:*)
      include 'qcdiff.inc'
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      common /cprfl1/ dgdgmt,dgdtht,dgdast,dgdhei(2),asf,casf
      data pi/3.141592/
c******* derivatives with respect to profile parameters*****
c     derp
c     0  : asymmetry parameter
c     1,2: u and v of the theta dependence of hwhm 
c     3  : ratio of gauss component    
c     4,5: hwhm of gauss and lorentz functions   
c     6,7: hwhm of gauss and lorentz functions   
c     derc
c     0 : zero point shift
c     1 : c1 (linier coefficient)
c        derp(0)=-casf*(g1+g2)
c          hwhme(1,np)=(hwhm(1)+hwhm(3)*qki)*tfct(np)
c          hwhme(2,np)=(hwhm(2)+hwhm(4)*qki)*tfct(np)
        derp(0)=dgdast*asf
        if(ilp.ge.0) then
            derp(1)=(dgdhei(1)*(hwhm(1)+hwhm(3)*qki)+
     *               dgdhei(2)*(hwhm(2)+hwhm(4)*qki))*
     *               (tanxk(np))**2/(2*tfct(np))*asf
            derp(2)=(dgdhei(1)*(hwhm(1)+hwhm(3)*qki)+
     *               dgdhei(2)*(hwhm(2)+hwhm(4)*qki))*
     *               (tanxk(np))/(2*tfct(np))*asf
        else
            derp(1)=(dgdhei(1)*(hwhm(1)+hwhm(3)*qki)+
     *               dgdhei(2)*(hwhm(2)+hwhm(4)*qki))*
     *               (tanxk(np))**2*asf
            derp(2)=(dgdhei(1)*(hwhm(1)+hwhm(3)*qki)+
     *               dgdhei(2)*(hwhm(2)+hwhm(4)*qki))*
     *               (tanxk(np))*asf
        end if
        derp(3)=dgdgmt*asf
        derp(4)=dgdhei(1)*tfct(np)*asf
        derp(5)=dgdhei(2)*tfct(np)*asf
        derp(6)=dgdhei(1)*tfct(np)*asf*qki
        derp(7)=dgdhei(2)*tfct(np)*asf*qki
        derc(0)=dgdtht*asf/2           ! for zero point shift in two-theta
        derc(1)=dgdtht*asf/2*dth2dc1   ! for linear factor in two-theta
c     write(6,*) 'derp(0-5),derc(0)',(derp(i),i=0,5),derc(0),derc(1)
      return
      end

