      function pwint(nh,xd,dfdxx,is,bgd,absfcm)
c        calculated intensity at xd and its derivatives
      real xd,dfdxx(*)
      real dhdx(15)
      include 'qcdiff.inc'
      common /ctodrw1/ qmin,qmax,dq,istep,ndata,iwg,mmax(3),wavl(2),
     *   job,ibkgr
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      common /ctodrw6/ cp(0:2),pp(0:9),pg
      common /csimul/ dfdx(nxprm,nhkl),nxx
      common /ctodrw8/ ipt(0:38),nlc
      common /ctodrw9/ pb(0:12), dpb(0:12), zps(2)
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      integer ns,st
      common /cqsort/ ns(mhkl),st(mhkl,2)
      common /cqks/ qs(6,mhkl),qks(mhkl),fcs(mhkl),mks(mhkl),ihkl(mhkl),
     *   nref,iqs(mhkl),qs0(6,mhkl)
      real sqrtpi,ln2,fact
      common /clins/ sqrtpi,ln2,fact
      complex fc
      real qk,qkd,derc(0:2),derp(0:11)
      integer hklm,fmpl
      common /chklfm/ hklm(6,nhkl),qk(nhkl),fmpl(nhkl),fc(nhkl),
c     *   fo(nhkl),theta0(nhkl)
     *   fo(nhkl),theta0(nhkl),ext(nhkl)
      common /criccut/ riccut
      character icn
      common /ctorms5/ nlp,ntl(15),il(5,15),cl(5,15),icn(5,15)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
c     common /cprfl1/ dgdgmt,dgdtht,dgdzps,dgdhei(2),asf,casf
      common /cprfl1/ dgdgmt,dgdtht,dgdast,dgdhei(2),asf,casf
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /cdfdbi/ dfdbi(nhkl)
      complex dfdbia
      integer getid,getnpf,getskip

      id=getid() ! current datasets
      npf=getnpf(id)
c     write(6,*) 'id,npf=',id,npf
c     stop
      data pi/3.141592/
c     nsx: position of scale factor in dfdx
c
c      2-theta angle of grafite
      fact=pi/180
      ln2=log(2.)
      sqrtpi=sqrt(pi/ln2)
c     initialize
      do j=1,nxx+nlc
         dfdxx(j)=0.
      end do
c     background intensity
c      bgd=backgr(xd,pb(1),dpb)
      bgd=backgr(xd,pb(1),dpb(1))
      pwint=bgd
      if(ipt(0).eq.0) then
          j=nxx
      else if(ipt(0).eq.1) then
          j=nxx+1
      end if
      do l1=1,12
         if(ipt(l1).eq.1) then
c     background parameters
            j=j+1
            dfdxx(j)=dfdxx(j)+dpb(l1)
         end if
      end do
      if(iwl.le.9) then         ! xray
         if(abs(ilp).eq.1) then
            lwe=2
         else
            lwe=1
         end if
      else if(iwl.ge.10) then   ! thermal neutron
         lwe=1
      end if
c**************
      isd=is
      do ii=is,nref
         id=ns(ii)              ! original reflection number before sort
         i=ihkl(id)
         iq=iqs(id)
         if(ii-is+1.ge.nb) then
            call quit('buffer full')
         end if
         absfc=fcs(id)
         qkd=qks(id)*2*pi
         qki=vabs(qs(4,id),3)
         if(iwl.le.10) then
            call updat1(ii,id,np,mks(id),qkd,qki,absfc,job)
         else if(iwl.eq.11) then
c     xk: diffraction vector 2*pi*q in inverse angstrome
            xk=cp(0)+cp(1)*qkd+cp(2)*qkd**2
            call updat2(ii,id,np,cp,pp,pg,xk,qkd,idpos,mks(id),
     *           absfc,job)
         end if
         do lw=1,lwe
            absfc=fcs(id)
            if(iwl.le.9) then
               cp1=1
            else if(iwl.eq.10) then
               cp1=cp(1)
            end if
c     xx: sin(theta)
            xx=qks(id)*wavl(lw)*cp1/2
            if(xx.gt.0.999) go to 100
c     xk:
c     xk=2*asin(xx)/fact+zps
            asinxx=asin(xx)
            th2=2*asinxx/fact   !2-theta in degree
            xk=th2+zps(1)  ! 2-theta in degree
            dth2dxx=2/sqrt(1.0-xx**2)/fact
            dxxdc1=xx/cp1
            dth2dc1=dth2dxx*dxxdc1
            if(xk.lt.qmin.or.xk.gt.qmax) go to 100
            if(lw.eq.1) then
               wght=2./3.
            else
               wght=1./3.
            end if
            dx0=xd-xk
c     gt: profile function
            if(iwl.le.10) then
               gt=prfl1(np,dx0,xk*fact)
               pt=peak(np)/1000
            else
               gt=prfl2(np,dx0)
               pt=fnorm(np)/1000
            end if
            iskip=getskip(dx0,gt,pt,np)

            if(iskip.eq.1) then
c     starting reflection for the next x
               if(lw.eq.1) isd=ii+1
            else if(iskip.eq.2) then
c     break
               go to 140
            else
               if(job.eq.1.or.(job.eq.0.and.pb(0).eq.0)) then
                  pwint=pwint+coeff0(np)*gt*wght*extf(np)
c     write(6,*) 'pwint,coeff0,gt,wght,extf',
c     *                  pwint,coeff0(np),gt,wght,extf(np)
               else
                  pwint=pwint+coeff0(np)*gt*wght*extf(np)
                  if(iwl.le.10) then
                     if(nlc.ne.0) then
                        call dprfl1(dth2dc1,np,derc,derp,qki)
                     end if
                     l1m=20
                     l2m=npf-1  ! 28-1=27   bia
                     l1e=l2m+nlp
                  else
                     if(nlc.ne.0) then
                        call dprfl2(pp,qkd,nh,np,dx0,derc,derp,dfdq)
                     end if
                     l1m=22
                     l2m=npf-1
                     l1e=l2m+nlp
                  end if
                  do j=1,nxx
c     structural parameters
                     dfdxx(j)=dfdxx(j)+dfdx(j,iq)*coeff1(np)*gt*wght
     *                    *extf(np)
                  end do
                  if(nlc.ne.0) then
                     j=nxx
                     l=0
                     do l1=0,l1e
                        if(ipt(l1).ne.0) then
                           j=j+1
                           if(l1.eq.0) then
c     scale
                              dfdxx(j)=dfdxx(j)+coeff(np)*gt*wght
     *                             *extf(np)*absfc**2/100
                           else if(l1.ge.13.and.l1.le.l1m) then
c     asym- or sigm-
                              dfdxx(j)=dfdxx(j)+derp(l1-13)*coeff0(np)
     *                             *extf(np)*wght
                           else if(l1.eq.l1m+1) then
c     pg or extinction
                              dfdxx(j)=dfdxx(j)+coeff0(np)*gt
     *                             *dextf(np)*wght
                           else if(l1.eq.l1m+2) then
c     sgm or absorption 
                              dfdxx(j)=dfdxx(j)+coeff3(np)*gt
     *                             *extf(np)*dabf(np)*wght
                           else if(l1.eq.l1m+3) then
c     p1
                              dfdxx(j)=dfdxx(j)+dpodp(1,np)*coeff2(np)
     *                             *gt*extf(np)*wght
                           else if(l1.eq.l1m+4) then
c     p2
                              dfdxx(j)=dfdxx(j)+dpodp(2,np)*coeff2(np)
     *                             *gt*extf(np)*wght
                           else if(l1.ge.l1m+5.and.l1.le.l2m-1) then 
c     zps & c1 or c0 c1 c2
                              dfdxx(j)=dfdxx(j)+
     *                             derc(l1-l1m-5)*coeff0(np)*
     *                             extf(np)*wght
                              
c     bia 
                           else if(l1.eq.l2m) then
                              dfdxx(j)=dfdxx(j)+dfdbi(id)*coeff1(np)*
     *                             gt*wght*extf(np)
c     
                           else if(l1.gt.l2m) then
c     lattice parameters
                              if(iwl.le.9) then
                                 dthdh=wavl(lw)/(2*cos(xk*fact/2))/fact
                              else if(iwl.eq.10) then
                                 dthdh=wavl(lw)*cp(1)/
     *                                (2*cos(xk*fact/2))/fact
                                 dgdh=dgdtht*dthdh
                              else if(iwl.eq.11) then
                                 dgdh=dfdq*2*pi
                              end if
                              k=il(1,l1-l2m)
                              l=l+1
                              if(k.eq.1) then
                                 dhdx(l)=fdhda(qs(1,id),qks(id))
                              else if(k.eq.2) then
                                 dhdx(l)=fdhdc(qs(1,id),qks(id))
                              else if(k.eq.3) then
                                 dhdx(l)=fdhde1(qs0(1,id),qks(id))
                              else if(k.eq.4) then
                                 dhdx(l)=fdhde2(qs0(1,id),qks(id))
                              else if(k.eq.5) then
                                 dhdx(l)=fdhde3(qs0(1,id),qks(id))
                              else if(k.eq.6) then
                                 dhdx(l)=fdhde4(qs0(1,id),qks(id))
                              end if
                              dfdxx(j)=dfdxx(j)+dgdh*dhdx(l)*
     *                             coeff0(np)*extf(np)*wght
                           end if
                        end if
                     end do
                  end if
               end if
            end if
         end do
 100     continue
      end do
 140  continue
      is=isd
      return
      end

      integer function getskip(dx0,gt,pt,np)
      include 'qcdiff.inc'
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      getskip=0
      if(dx0.ge.0.and.gt.lt.pt) then
         getskip=1
      else if(dx0.le.0.and.gt.lt.pt) then
         getskip=2
      end if
      if(iwl.le.10) then
c     hwhm(1) nearly equal to hwhm(2) is assumed
         if(dx0.gt. 15*max(hwhm(1),hwhm(2))) getskip=1
         if(dx0.lt.-15*max(hwhm(1),hwhm(2))) getskip=2
      else 
         if(dx0.gt. 10*sigma1(np)) getskip=1
         gammam=max(gamma1(np),gamma2(np))
         if(dx0.lt.-20*gammam) getskip=2
      end if
      return
      end

c***************subroutine by f. izumi**********************
c
      subroutine updat2(n,nd,np,c,p,pg,t0,d,idpos,mpl,absfc,job)
c     for TOF neutron

c      subroutine updat2(n,np,c,p,t0,d,nrefl,pc,t2,rtime,idpos)
**    update various variables that are related to profile parameters,
**    which are stored in common blocks der2, prfhrp, and trange.
**    this subroutine has to be called before calculating profile
**    shape functions from new parameters and their derivatives
**    with respect to refinable parameters.
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.

c      real c(0:2),p(0:9),t0(nrefl),d(nrefl),pc,t2,rtime(2,nrefl)
      real c(0:2),p(0:9),t0,d
c      integer nrefl,idpos
      common /ctodrw9/ pb(0:12), dpb(0:12), zps(2)

**    input
**            c: parameters to calculate peak positions, t0(i)
**               t0(i) = c(0) + c(1)*d(i) + c(2)*d(i)**2
**            p: profile parameters
**               p(0)=sigma11; p(1)=sigma12;
**               p(2)=sigma21; p(3)=sigma22;
**               p(4)=gamma11; p(5)=gamma12; p(6)=gamma13;
**               p(7)=gamma2;
**               p(8)=r1; p(9)=r2
**           t0: peak positions in microseconds ==> corrected
**                      diffraction vector  xk = c(0)+c(1)*qk+c(2)*qk**2
**            d: interplanar spacings in angstroms ==>  diffraction vector qk
**                          ***** by A. Yamamoto *****
**        nrefl: number of reflections
**           pc: profile cut-off.  intensity data which are lower than
**               (peak intensity) * pc are ignored.
**           t1: minimum time of flight in microseconds
**    output
**        rtime: the i'th reflection contributes to the intensity at t
**               between rtime(1,i) and rtime(2,i)
**        idpos  0: the profile shape function cannot be calculated
**                  from the present profile parameters, p(0)-p(9)
**               1: the profile shape function can be calculated from
**                  p(0)-p(9)
**     nb: maximum number of peaks
**

c     cc=sqrt(pi/2); root2=sqrt(2)
      include 'qcdiff.inc'
      common /ctodrw7/ iwl,ixax,ilp,alpha,iyax
      real lp
      common /clpfct/ lp(nb)
      common /cupdat/ tanxk(nb),tfct(nb),hwhme(2,nb),c1(nb),c2(nb),
     * coeff(nb),coeff0(nb),coeff1(nb),coeff2(nb),coeff3(nb),peak(nb)
      parameter (cc=1.253314,root2=1.414214)
      parameter (pw1=1.0,pw2=2.0,pw3=-0.5,pw4=2.0,pw5=2.0,pw6=-0.5)
      common /der2/c2vd(nb),ds1dp0(nb),ds1dp1(nb),ds2dp2(nb),ds2dp3(nb),
     &  dg1dp4(nb),dg1dp5(nb),dg2dp6(nb),dg2dp7(nb),drdp8(nb),drdp9(nb),
     &  dads1(nb),dads2(nb),dadg1(nb),dadg2(nb),dadr(nb),dadd(nb),
     &  da1ds1(nb),da1ds2(nb),da1dg1(nb),da1dg2(nb),da1dr(nb),da1dd(nb),
     &  da2ds1(nb),da2ds2(nb),da2dg1(nb),da2dg2(nb),da2dr(nb),da2dd(nb),
     &  sigm13(nb),sigm23(nb),dp9(nb),ds1dd(nb),ds2dd(nb),
     &  dg1dd(nb),dg2dd(nb),drdd(nb)
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /cpof/ pof(nb),dpodp(4,nb),extf(nb),dextf(nb),abf(nb),
     *              dabf(nb)
      common /cisie/ is,ie
      real icmax
      common /ctorms2/ theta(mhkl),qe(3,mhkl),thbm,awl,fi,icmax
      common /ctodrw3/ hwhm(4),gamma,uvw(2),p1,p2,as,sgm
      real dpof(2)
      data pi/3.141592/
c       this routine assumes that is=ie=0 initially
c       to set these initial value ==> call setise(0,0)
      if(n.ge.is.and.n.le.ie) then
c         1<=np<=nb   position in a ring buffer
c         calculated value
********************************
          np=mod(n-1,nb)+1
********************************
          return
      else
c         save new value at np
********************************
          np=mod(n-1,nb)+1
********************************
          if(n.le.nb) then
              is=1
              ie=n
          else if(n.gt.nb) then
              ie=ie+1
              is=is+1
          end if
          idpos=0
          i=np

          ds1dp0(i) = d ** pw1
          ds1dp1(i) = d ** pw2
          ds2dp2(i) = d ** pw3
          ds2dp3(i) = d ** pw4
          sigma1(i) = p(0) * ds1dp0(i) + p(1) * ds1dp1(i)
          sigma2(i) = p(2) * ds2dp2(i) + p(3) * ds2dp3(i)
c         dg1dp4(i) = d ** pw5
c         dg1dp5(i) = exp(-p(6) * d ** pw6)
c         dg1dp6(i) = -p(5) * d ** pw6 * dg1dp5(i)
c         dg2dp7(i) = d ** pw5
          dg1dp4(i) = d**p(5)
          dg1dp5(i) = p(4)*dg1dp4(i)*log(d)
          dg2dp6(i) = d**p(7)
          dg2dp7(i) = p(6)*dg2dp6(i)*log(d)
          gamma1(i) = p(4) * dg1dp4(i)
          gamma2(i) = p(6) * dg2dp6(i)
          dp9(i)=d**p(9)
c         r(i) = 1.0 - exp(-p(8) * dp9(i))
          r(i) = exp(-p(8) * dp9(i))
          extf(i) = extfct(pg,absfc,d,mpl,dextfc)
          dextf(i) = dextfc
          if(sigma1(i) .lt. 0 .or. sigma2(i) .lt. 0) then
              call quit('parameter sigma1 or sigma2 negative ???')
          else if (gamma1(i) .lt. 0.0 .or. gamma2(i) .lt. 0.0) then
              call quit('parameter gamma1 or gamma2 negative ???')
          else if(r(i) .lt. 0 .or. r(i) .gt. 1 .or. p(8) .eq.0) then
              call quit('parameter r<0 or r>1  ???')
          end if
c         r is approximated by avrami's equation
          gs12(i)=sigma2(i)**2/gamma1(i)
          exp12(i)=exp((sigma2(i)/gamma1(i))**2/2)
          erf12(i)=erf(sigma2(i)/(gamma1(i)*root2))
          gs22(i)=sigma2(i)**2/gamma2(i)
          exp22(i)=exp((sigma2(i)/gamma2(i))**2/2)
          erf22(i)=erf(sigma2(i)/(gamma2(i)*root2))
c         fnorm: normalization factor
          fnorm(i)=cc*(sigma1(i)+(1.0-r(i))*sigma2(i)*erf12(i)+
     &    r(i)*sigma2(i)*erf22(i))+(1.0-r(i))*gamma1(i)/exp12(i)
     &    +r(i)*gamma2(i)/exp22(i)
          fnorm(i)=1.0/fnorm(i)
          fnorm1(i)=fnorm(i)*exp12(i)
          fnorm2(i)=fnorm(i)*exp22(i)
c         arrays used to calculate partial derivatives with respect to
c         (1) c(0), c(1), c(2), (2) profile parameters, and (3) d(i)
c                       in subroutine dprfl
          c2vd(i)=c(1)+2.0*c(2)*d
          sigm13(i)=sigma1(i)**3
          sigm23(i)=sigma2(i)**3
c         lp(i)=1/d**2
          lp(i)=flp(q)
          pof(i)=poffct(qe(1,nd),p1,p2,dpof)
          abf(i)=absorp(yk0,sgm,dabf(i))
c         write(6,*) 'n,pof,extf',n,pof(i),extf(i)
          dpodp(1,i)=dpof(1)
          dpodp(2,i)=dpof(2)
          if(job.eq.0) then
              if(pb(0).eq.0) then
                  coeff(i)=lp(i)*mpl*pof(i)
                  coeff0(i)=coeff(i)*absfc**2
                  return
              end if
          else
              coeff(i)=lp(i)*mpl*pof(i)
              coeff0(i)=coeff(i)*absfc**2
              return
          end if
          scl=pb(0)/100
          coeff(i)=lp(i)*mpl*pof(i)
c         coefficient for profile parameters
          coeff0(i)=coeff(i)*absfc**2*scl
c         coefficient for structural parameters
          coeff1(i)=coeff(i)*2*absfc*scl
c         coefficient for prefered orientation function
          coeff2(i)=lp(i)*mpl*absfc**2*scl
c          write(6,*) 'coeff,coeff0,coeff1,coeff2',coeff(i),coeff0(i),
c     *                coeff1(i),coeff2(i)
          drdp8(i)=(1.0 - r(i))*dp9(i)
c         drdp9(i)=drdp8(i)*p(8)*log(d(i))
          drdp9(i)=drdp8(i)*p(8)*log(d)
c         drdp8(i)= - r(i)*dp9(i)
c         drdp9(i)=drdp8(i)*p(8)*log(d)
          dads1(i)=-cc*fnorm(i)**2
          dads2(i)=dads1(i)*((1.0-r(i))*erf12(i)+r(i)*erf22(i))
c         dadg1(i)=fnorm(i)**2*(1.0-r(i))/(gamma1(i)**2*exp12(i))
c         dadg2(i)=fnorm(i)**2*r(i)/(gamma2(i)**2*exp22(i))
c         dadr(i)=cc*sigma2(i)*(erf22(i)-erf12(i))+1.0/(gamma2(i)*
c    &              exp22(i))-1.0/(gamma1(i)*exp12(i))
          dadg1(i)=-fnorm(i)**2*(1.0-r(i))/exp12(i)
          dadg2(i)=-fnorm(i)**2*r(i)/exp22(i)
          dadr(i)=cc*sigma2(i)*(erf22(i)-erf12(i))
     &        +gamma2(i)/exp22(i)-gamma1(i)/exp12(i)
          dadr(i)=-fnorm(i)**2*dadr(i)
          da1ds1(i)=dads1(i)*exp12(i)
c         da1ds2(i)=(dads2(i)+fnorm(i)*gamma1(i)**2*sigma2(i))*exp12(i)
          da1ds2(i)=(dads2(i)+fnorm(i)*sigma2(i)/gamma1(i)**2)*exp12(i)
c           da1dg1 ==> a part of df1dg1
c           da1dg2 ==> a part of df1dg2
c         da1dg1(i)=(dadg1(i)+fnorm(i)*gs12(i))*exp12(i)
c         da1dg2(i)=dadg2(i)*exp12(i)
          da1dg1(i)=(dadg1(i)-2*fnorm(i)*gs12(i)/gamma1(i)**2)*exp12(i)
          da1dg2(i)=dadg2(i)*exp12(i)
          da1dr(i)=dadr(i)*exp12(i)
          da2ds1(i)=dads1(i)*exp22(i)
c         da2ds2(i)=(dads2(i)+fnorm(i)*gamma2(i)**2*sigma2(i))*exp22(i)
          da2ds2(i)=(dads2(i)+fnorm(i)*sigma2(i)/gamma2(i)**2)*exp22(i)
c         da2dg1(i)=dadg1(i)*exp22(i)
c         da2dg2(i)=(dadg2(i)+fnorm(i)*gs22(i))*exp22(i)
          da2dg1(i)=dadg1(i)*exp22(i)
          da2dg2(i)=(dadg2(i)-2*fnorm(i)*gs22(i)/gamma2(i)**2)*exp22(i)
          da2dr(i)=dadr(i)*exp22(i)
c         ds2dd(i)=p(3)*power*ds2dp3(i)/d(i)
c         dg1dd(i)=-2.0*p(5)*p(6)*d(i)*dg1dp4(i)
c         drdd(i)=p(8)*p(9)*dp9(i)/d(i)*(1.0-r(i))
c         dadd(i)=cc*p(1)+cc*erf12(i)*((1.0-r(i))*ds2dd(i)-
c    &    sigma2(i)*drdd(i))-(drdd(i)+(1.0-r(i))/gamma1(i)*
c    &    dg1dd(i))/(gamma1(i)*exp12(i))+cc*erf22(i)*(r(i)*ds2dd(i)
c    &    +sigma2(i)*drdd(i))+drdd(i)/(gamma2(i)*exp22(i))
          ds1dd(i)=p(0)*pw1*ds1dp0(i)/d+p(1)*pw2*ds1dp1(i)/d
          ds2dd(i)=p(2)*pw3*ds2dp2(i)/d+p(3)*pw4*ds2dp3(i)/d
c         dg1dd(i)=-pw6*p(5)*p(6)*d*dg1dp5(i)
c         dg1dd(i)= p(4)*pw5*d**(pw5-1)-p(5)*p(6)*pw6*d**(pw6-1)
c     &                 *dg1dp5(i)
          dg1dd(i)=p(4)*p(5)*d**(p(5)-1)
          dg2dd(i)=p(6)*p(7)*d**(p(7)-1)
          drdd(i)=-p(8)*p(9)*dp9(i)/d*r(i)
c          dadd(i)=cc*ds1dd(i)+cc*erf12(i)*((1.0-r(i))*ds2dd(i)-
c     &    sigma2(i)*drdd(i))-(drdd(i)+(1.0-r(i))/gamma1(i)*
c     &    dg1dd(i))/(gamma1(i)*exp12(i))+cc*erf22(i)*(r(i)*ds2dd(i)
c     &    +sigma2(i)*drdd(i))+drdd(i)/(gamma2(i)*exp22(i))
          dadd(i)=cc*ds1dd(i)+
     &    cc*erf12(i)*((1.0-r(i))*ds2dd(i)-sigma2(i)*drdd(i))
     &    +(-drdd(i)*gamma1(i)+(1.0-r(i))*dg1dd(i))/exp12(i)+
     &    cc*erf22(i)*(      r(i)*ds2dd(i)+sigma2(i)*drdd(i))
     &    +( drdd(i)*gamma2(i)     +r(i) *dg2dd(i))/exp22(i)
          dadd(i)=-fnorm(i)**2*dadd(i)

c          da1dd(i)=(dadd(i)+fnorm(i)*(gs12(i)*dg1dd(i)
c     &            +gamma1(i)**2*sigma2(i)*ds2dd(i)))*exp12(i)
c          da2dd=(dadd(i)+fnorm(i)*gamma2(i)**2*sigma2(i)*
c     &         ds2dd(i))*exp22(i)
c          cdf2dd(i)=da2dd+fnorm2(i)*gamma2(i)*c2vd(i
          da1dd(i)=(dadd(i)+fnorm(i)*(gs12(i)*dg1dd(i)
     &            +sigma2(i)*ds2dd(i)/gamma1(i)**2))*exp12(i)
          da2dd(i)=(dadd(i)+fnorm(i)*(gs22(i)*dg2dd(i)
     &            +sigma2(i)*ds2dd(i)/gamma2(i)**2))*exp22(i)
c          cdf2dd(i)=da2dd(i)+fnorm2(i)*gamma2(i)*c2vd(i)
c   50   continue
         idpos=1
         return
       end if
       end

************************************************************************
c           gt=prfl2(np,dx0)
      function prfl2(i,delta)
**    profile shape function at delta (=t0(i)-t) for the i'th reflection
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.
**    variables gauss1, gauss2, tail1, tail2, f1, and f2 are used in
**    subroutine dprfl2; therefore, prfl2 must be calculated prior to
**    calling dprfl2.

      integer i
      real delta

**    input
**            i: reflection number
**        delta: t0(i) - t, where t0(i) is the peak position and
**               t is the time of flight at this step
**    output
**        prfl2: this function
**
      include 'qcdiff.inc'
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /prf2/ gauss1,gauss2,tail1,tail2,f1,f2
c     if (delta .le. 0.0) then
      if (delta .ge. 0.0) then
         gauss1=exp(-0.5*(delta/sigma1(i))**2)
         prfl2=fnorm(i)*gauss1
      else
c        if (delta .le. gs12(i) .or. delta .lt. gs22(i)) then
         if (-delta .le. gs12(i) .or. -delta .lt. gs22(i)) then
            gauss2=exp(-0.5*(delta/sigma2(i))**2)
         end if
c        if (delta .le. gs12(i)) then
         if (-delta .le. gs12(i)) then
            f1=fnorm(i)*gauss2
         else
******* following change is necessary for d ==> q   A. Yamamoto
c           tail1=exp(-gamma1(i)*delta)
c            tail1=exp(gamma1(i)*delta)
            tail1=exp(delta/gamma1(i))
            f1=fnorm1(i)*tail1
         end if
c        if (delta .le. gs22(i)) then
         if (-delta .le. gs22(i)) then
            f2=fnorm(i)*gauss2
         else
******* following change is necessary for d ==> q   A. Yamamoto
c            tail2=exp(-gamma2(i)*delta)
c            tail2=exp(gamma2(i)*delta)
            tail2=exp(delta/gamma2(i))
            f2=fnorm2(i)*tail2
         end if
         prfl2=(1.0-r(i))*f1+r(i)*f2
      end if
      return
      end

************************************************************************
c           call dprfl2(pp,qkd,nh,np,dx0,derc,derp,dfdq)
c           for TOF neutron
      subroutine dprfl2(p,d,nrefl,i,delta,derc,derp,dfdq)
**    calculate the contribution of the i'th reflection to the partial
**    derivatives of the profile shape function at delta with respect to
**       (1) c(0), c(1), and c(2)
**           t0(i) = c(0) + c(1)*d(i) + c(2)*d(i)*d(i)
**       (2) profile parameters, p(0) - p(9)
**       (3) 1/d(i)
**    the value of nb (number of bragg reflections) must be altered by
**    the user of this subroutine.

c      real p(0:9),d(nrefl),delta,derc(0:2),derp(0:9),dfdq
      real p(0:9),d,delta,derc(0:2),derp(0:9),dfdq
      integer nrefl,i

**    input
**            p: profile parameters
**               p(0)=sigma11; p(1)=sigma12;
**               p(2)=sigma21; p(3)=sigma22;
**               p(4)=gamma11; p(5)=gamma12; p(6)=gamma13;
**               p(7)=gamma2;
**               p(8)=r1; p(9)=r2
**            d: interplanar spacings in angstroms
**        nrefl: number of reflections
**            i: reflection number
**        delta: t0(i) - t, where t0(i) is the peak position and
**               t is the time of flight at this step
**    output
**         derc: derivatives of prfik with respect to (c(j),j=0,2)
**         derp: derivatives of prfik with respect to (p(j),j=0,9)
**         dfdq: derivative of prfik with respect to 1/d(i)
**               where prfik is the value of the profile shape function
**               for the i'th reflection at t
**
      include 'qcdiff.inc'
      common /der2/c2vd(nb),ds1dp0(nb),ds1dp1(nb),ds2dp2(nb),ds2dp3(nb),
     &  dg1dp4(nb),dg1dp5(nb),dg2dp6(nb),dg2dp7(nb),drdp8(nb),drdp9(nb),
     &  dads1(nb),dads2(nb),dadg1(nb),dadg2(nb),dadr(nb),dadd(nb),
     &  da1ds1(nb),da1ds2(nb),da1dg1(nb),da1dg2(nb),da1dr(nb),da1dd(nb),
     &  da2ds1(nb),da2ds2(nb),da2dg1(nb),da2dg2(nb),da2dr(nb),da2dd(nb),
     &  sigm13(nb),sigm23(nb),dp9(nb),ds1dd(nb),ds2dd(nb),
     &  dg1dd(nb),dg2dd(nb),drdd(nb)
      common /prfhrp/ r(nb),sigma1(nb),sigma2(nb),gamma1(nb),gamma2(nb),
     &  gs12(nb),exp12(nb),erf12(nb),gs22(nb),exp22(nb),erf22(nb),
     &  fnorm(nb),fnorm1(nb),fnorm2(nb)
      common /prf2/ gauss1,gauss2,tail1,tail2,f1,f2
c
c      if (delta .le. 0.0) then
      if (delta .ge. 0.0) then
*        (1)
         dfdt0=fnorm(i)*delta/sigma1(i)**2*gauss1
*        (2)
         dfds1=(dads1(i)+fnorm(i)*delta**2/sigm13(i))*gauss1
         dfds2=dads2(i)*gauss1
         dfdg1=dadg1(i)*gauss1
         dfdg2=dadg2(i)*gauss1
         dfdr=dadr(i)*gauss1
*        (3)
c        dfdd=(dadd(i)+fnorm(i)*(delta**2/sigm13(i)*p(1)+
c    &           delta/sigma1(i)**2*c2vd(i)))*gauss1
         dfdd=(dadd(i)+fnorm(i)*(delta**2/sigm13(i)*ds1dd(i)+
     &           delta/sigma1(i)**2*c2vd(i)))*gauss1
      else
c        if (delta .le. gs12(i)) then
         if (-delta .le. gs12(i)) then
*           f1: fnorm(i)*gauss2
*           (1)
            df1dt0=f1*delta/sigma2(i)**2
*           (2)
            df1ds1=dads1(i)*gauss2
            df1ds2=(dads2(i)+fnorm(i)*delta**2/sigm23(i))*gauss2
            df1dg1=dadg1(i)*gauss2
            df1dg2=dadg2(i)*gauss2
            df1dr=dadr(i)*gauss2
*           (3)
            df1dd=(dadd(i)+fnorm(i)*(delta**2/sigm23(i)*ds2dd(i)+
     &            delta/sigma2(i)**2*c2vd(i)))*gauss2
         else
*           f1: fnorm1(i)*tail1
*           (1)
c           df1dt0=f1*gamma1(i)
            df1dt0=f1/gamma1(i)
*           (2)
            df1ds1=da1ds1(i)*tail1
            df1ds2=da1ds2(i)*tail1
c           df1dg1=(da1dg1(i)-fnorm1(i)*delta)*tail1
c           df1dg2=da1dg2(i)*tail1
            df1dg1=(da1dg1(i)-fnorm1(i)*delta/gamma1(i)**2)*tail1
            df1dg2=da1dg2(i)*tail1
            df1dr=da1dr(i)*tail1
*           (3)
c           df1dd=(da1dd(i)+fnorm1(i)*(gamma1(i)*c2vd(i)-dg1dd(i)*
c    &            delta))*tail1
            df1dd=(da1dd(i)+fnorm1(i)*(c2vd(i)/gamma1(i)-dg1dd(i)*
     &            delta))*tail1
         end if
c        if (delta .le. gs22(i)) then
         if (-delta .le. gs22(i)) then
*           (1)
*           f2: fnorm(i)*gauss2
            df2dt0=f2*delta/sigma2(i)**2
*           (2)
            df2ds1=dads1(i)*gauss2
            df2ds2=(dads2(i)+fnorm(i)*delta**2/sigm23(i))*gauss2
            df2dg1=dadg1(i)*gauss2
            df2dg2=dadg2(i)*gauss2
            df2dr=dadr(i)*gauss2
*           (3)
            df2dd=(dadd(i)+fnorm(i)*(delta**2/sigm23(i)*ds2dd(i)+
     &            delta/sigma2(i)**2*c2vd(i)))*gauss2
         else
*           f2: fnorm2(i)*tail2
*           (1)
c           df2dt0=f2*gamma2(i)
            df2dt0=f2/gamma2(i)
*           (2)
            df2ds1=da2ds1(i)*tail2
            df2ds2=da2ds2(i)*tail2
c           df2dg1=da2dg1(i)*tail2
c           df2dg2=(da2dg2(i)-fnorm2(i)*delta)*tail2
            df2dg1=da2dg1(i)*tail2
            df2dg2=(da2dg2(i)-fnorm2(i)*delta/gamma2(i)**2)*tail2
            df2dr=da2dr(i)*tail2
*           (3)
            df2dd=(da2dd(i)+fnorm2(i)*(c2vd(i)/gamma2(i)-dg2dd(i)*
     &            delta))*tail2
         end if
*        (1)
         dfdt0 = (1.0-r(i))*df1dt0 + r(i)*df2dt0
*        (2)
         dfds1 = (1.0-r(i))*df1ds1 + r(i)*df2ds1
         dfds2 = (1.0-r(i))*df1ds2 + r(i)*df2ds2
         dfdg1 = (1.0-r(i))*df1dg1 + r(i)*df2dg1
         dfdg2 = (1.0-r(i))*df1dg2 + r(i)*df2dg2
         dfdr = f2 - f1 + (1.0-r(i))*df1dr + r(i)*df2dr
*        (3)
         dfdd = drdd(i)*(f2 - f1) + (1.0-r(i))*df1dd + r(i)*df2dd
      end if

*     (1)
      derc(0)=dfdt0
      derc(1)=dfdt0*d
      derc(2)=dfdt0*d**2
*     (2)
      derp(0)=dfds1*ds1dp0(i)
      derp(1)=dfds1*ds1dp1(i)
      derp(2)=dfds2*ds2dp2(i)
      derp(3)=dfds2*ds2dp3(i)
      derp(4)=dfdg1*dg1dp4(i)
      derp(5)=dfdg1*dg1dp5(i)
      derp(6)=dfdg2*dg2dp6(i)
      derp(7)=dfdg2*dg2dp7(i)
      derp(8)=dfdr*drdp8(i)
      derp(9)=dfdr*drdp9(i)
*     (3)
*     derivative with respect to d(i) ==> derivative with respect to q
      dfdq=dfdd
c      write(6,*) 'derc,derp',(derc(k),k=0,2),(derp(k),k=0,9),dfdq
      return
      end

      function extfct(pg,absfc,q,mpl,dextfc)
      real pg,absfc,q,dextfc
      integer mpl
      dextfc=-absfc**2*mpl/q**4
c     extfct=1-pg*absfc**2*mpl/q**4
      extfct=1+pg*dextfc
      if(extfct.le.0) call quit('extinction factor negative?')
      return
      end

      subroutine empty(np)
      return
      end
