c
c     main
c
      parameter (np=4)
      real dd(np),dp(np),mm(np*(np+1)/2),md(np*(np+1)/2),sqrtm(np)
      real m0(np*(np+1)/2)
      real m1(np,np),m2(np,np),m3(np,np)  
      integer getij
      data mm /1,1,2,1,2,3,1,2,3,4/

      do i=1,np
         dd(i)=i
         dp(i)=1
      end do

      dmp=0
      do i=1,np*(np+1)/2
         m0(i)=mm(i)
      end do

      call wtmm(m0,np) ! before invese
      write(6,*)
      call chlsk(mm, dd, dp, np, 2, isng, iret, dmp, sqrtm)  
      call wtmm(mm,np) ! after inverse

      do i=1,np
         do j=1,i
            ij=getij(i,j,np) 
            m1(i,j)=m0(ij)
            m1(j,i)=m0(ij)
            m2(i,j)=mm(ij)
            m2(j,i)=mm(ij)
         end do
      end do
      call mtmlt(m1, m2, m3, np)
      write(6,*)
      call wtm3(m3,np)
      stop
      end

      integer function getij( i, j, np)
      if(j .le. i) then
         ij=j+(i-1)*i/2
      else 
         ij=i+(j-1)*j/2
      end if
      getij=ij
      return
      end 

      subroutine wtmm( mm, np) 
      real mm(*)
      do  i=1,np
         j0=i*(i-1)/2
         write(6,*) (mm(j0+j),j=1,i)
      end do
      return
      end

      subroutine wtm3( m3, np)
      real m3(np,*)
      do i=1,np
         write(6,*) (m3(i,j),j=1,np)
      end do
      return
      end
