      subroutine caluid(ui,uid)
      real ui(6,3),uid(6,3),dq(6,6)
      call getsys(isys)
      call getdq(dq)  ! get transformation matrix M
      do i=1,6
         do j=1,3
            uid(i,j)=0
            do k=1,6
               uid(i,j)=uid(i,j)+dq(i,k)*ui(k,j)
            end do
         end do
      end do
      return
      end

      subroutine rotate(x,z,deg)
      real x(3),z(3),deg
      real n(3,3),y(3),yd(3)
      ang=deg*3.1415926/180
c      write(6,*) 'x0=',x
c      write(6,*) 'deg=',deg
c     normal vector along the rotation axis (z-axis)
      cc=sqrt(z(1)**2+z(2)**2+z(3)**2)
      n(3,1)=z(1)/cc
      n(3,2)=z(2)/cc
      n(3,3)=z(3)/cc
      zz=n(3,1)*x(1)+n(3,2)*x(2)+n(3,3)*x(3)
c     remove z component of vector x
      n(1,1)=x(1)-zz*n(3,1)
      n(1,2)=x(2)-zz*n(3,2)
      n(1,3)=x(3)-zz*n(3,3)
      aa=sqrt(n(1,1)**2+n(1,2)**2+n(1,3)**2)
c     normalization  (x-axis)
      n(1,1)=n(1,1)/aa
      n(1,2)=n(1,2)/aa
      n(1,3)=n(1,3)/aa
c     vector product of z and x (y-axis)
      n(2,1)=n(3,2)*n(1,3)-n(3,3)*n(1,2)
      n(2,2)=n(3,3)*n(1,1)-n(3,1)*n(1,3)
      n(2,3)=n(3,1)*n(1,2)-n(3,2)*n(1,1)
c     n(i,j) transformation matrix (orthogonal matrix)
c      write(6,*) 'n(i,j)'
c      do i=1,3
c         write(6,'(3f10.5)') (n(i,j),j=1,3)
c      end do
      do i=1,3
         y(i)=0
         do j=1,3
            y(i)=y(i)+n(i,j)*x(j)
         end do
      end do
c      write(6,*) 'y=',y
c     rotation around the z-axis
      cosang=cos(ang)
      sinang=sin(ang)
      yd(1)=cosang*y(1)-sinang*y(2)
      yd(2)=sinang*y(1)+cosang*y(2)
      yd(3)=y(3)
c      write(6,*) 'yd=',yd
c     transform into the original coordinates
      do i=1,3
         x(i)=0
         do j=1,3
            x(i)=x(i)+n(j,i)*yd(j)   ! note that n(i,j) is orthogonal
         end do
      end do
c      write(6,*) 'x=',x
      return
      end

      subroutine setnvec(nvec)
      common /cnvec/ nvecs
      nvecs=nvec
      return
      end

      subroutine getnvec(nvec)
      common /cnvec/ nvecs
      nvec=nvecs
      return
      end

      subroutine setui(uid)
      real uid(6,3)
      common /cui/ ui(6,3)
      do i=1,6
         do j=1,3
            ui(i,j)=uid(i,j)
         end do
      end do
      return
      end

      subroutine getui(uid)
      real uid(6,3)
      common /cui/ ui(6,3)
      call mcpymn(ui,uid,6,3)
      return
      end

