      integer function getien(n)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getien=ien(n)
      return
      end

      integer function getish(n)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getish=ish(n)
      return
      end

      integer function getna()
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      getna=na
      return
      end

      subroutine setui0(na)
      include 'qcdiff.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      do n=1,na
         call getbtoui(n,be0(n),b10(n))
      end do
      return
      end

      subroutine getxi(xid,id)
      real xid(*)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(xi(1,id),xid,6)
      return
      end

      integer function getisyd(id)
      real isydd
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      getisyd=isyd(id)
      return
      end

      subroutine getx0(x0d,id)
      real x0d(*)
      real mpl
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(x0(1,id),x0d,6)
      return
      end

      subroutine getx(x,id)
      real x(*)
      real mpl
      include 'qcdiff.inc'
      common /toqcd2/na,mpl(namax),isk(0:120,namax),irs(0:120,namax),
     *     isymo(0:120)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      do j=1,6
         x(j)=x0(j,id)+u01(id)*xe1(j,id)+u02(id)*xe2(j,id)+
     *        u03(id)*xe3(j,id)+v0(id)*xi(j,id)
      end do
      return
      end

      subroutine xtoxs(na)
      include 'qcdiff.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      real xd(6)
      character brv

      call getbrv(brv)
      if(brv.ne.'s') then
         return
      end if

      call getsys(isys)
      if(isys.le.2) then
c     transformation of x0,xe,xi, and ej for the 2 or 32-fold superstructure
         do i=1,na
            call celltr(x0(1,i),1)
            v0(i)=v0(i)/2
            ramin0(i)=ramin0(i)/2
            ramax0(i)=ramax0(i)/2
c            write(6,*) 'x0=',(x0(j,i),j=1,6),
c     *           ' ra=',ramin0(i),' rb=',ramax0(i)
         end do
      else if(isys.eq.3) then
c     transformation of x0,xe,xi, and ej for the 5-fold superstructure
         do i=1,na
            call celltr(x0(1,i),1)
            call celltr(xi(1,i),1)
            do j=1,nej(i)
               call getxe(ej(1,j,i),xd)
               call celltr(xd,1)
               call getqe(xd,ej(1,j,i))
            end do
c            write(6,*) 'x0=',(x0(j,i),j=1,6)
c            write(6,*) 'ej=',(ej(j,1,i),j=1,6)
         end do
      else if(isys.eq.5) then
c     transformation of x0,xe,xi, and ej for the 9-fold superstructure
         do i=1,na
            call celltr(x0(1,i),1)
            call celltr(xi(1,i),1)
            do j=1,nej(i)
c               call getxe(ej(1,j,i),xd)
c               call celltr(xd,1)
c               call getqe(xd,ej(1,j,i))
               do k=1,6
                  ej(k,j,i)=ej(k,j,i)/sqrt(3.)
               end do
            end do
c            write(6,*) 'x0=',(x0(j,i),j=1,6)
c            write(6,*) 'ej=',(ej(j,1,i),j=1,6)
         end do
      end if
      return
      end

      subroutine rdap(na)
      call rdap1(na)
c     call rdap0(na)
      return
      end

      subroutine rdap0(na)
      character*6 atom
      include 'qcdiff.inc'
      common /cwflag/ iwflag(6)
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real ramin00(namax),ramax00(namax)
      real q(6),fj(7,nemax),xd(7),yd(6),icount(namax)
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      real q1(6),q2(6),q3(6)
      integer getidm
      character*80 frmt1,frmt2
      character*11 e12
      data eps /0.0001/
      call getsys(isys)
      call getinp(inpu)
      call getout(iout)
      call getnpod(npod)
      idm=getidm()
      if(isys.eq.5) then
         nd=7
         frmt1='(1h ,a,7f9.5,2x,a,f9.5)'
      else
         nd=6
         frmt1='(1h ,a,6f9.5,2x,a,f9.5)'
      end if

      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(iout,301) na
         write(iout,'(1h ,2a)')
     *      'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *      '       s1      s2'
      end if
      do i=1,npod
         ramin00(i)=0
         ramax00(i)=0
         icount(i)=0
      end do
      do i=1,na
          read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *       be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),s0(2,i)
             write(iout,302) ik,atom(i),ien(i),ish(i),nej(i),
     *            be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),
     *            s0(2,i)
c         be1(i)=0
          if(ien(i).le.0) then
             call quit('ien should be a positive integer')
          end if
          if(ish(i).gt.npod) then
             write(6,*) 'OD number=',ish(i), ' npod=',npod
             call quit('OD number > npod')
          end if

          if(ish(i).gt.0) then
             if(icount(ish(i)).eq.0) then
                ramin00(ish(i))=ramin0(i)
                ramax00(ish(i))=ramax0(i)
                icount(ish(i))=icount(ish(i))+1
             else if(icount(ish(i)).ge.1) then
                if(ramin00(ish(i)).ne.ramin0(i)) then
                   call quit('all the ramin must be the same for ish>0')
                end if
                if(ramax00(ish(i)).ne.ramax0(i)) then
                   call quit('all the ramax must be the same for ish>0')
                end if
             end if
          end if
          
*************
          if(nej(i).gt.nemax) call quit('ne > nemax')
          call freadra('x=',6,x0(1,i),1)
          write(iout,frmt1) 'x=  ', (x0(j,i),j=1,6)
          call freadra('xe1=',nd,xe1d,1)
          call freadrs('u1=',1,u01(i),0)
          write(iout,frmt1) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
          call freadra('xe2=',nd,xe2d,1)
          call freadrs('u2=',1,u02(i),0)
          write(iout,frmt1) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
          call freadra('xe3=',nd,xe3d,1)
          call freadrs('u3=',1,u03(i),0)
          write(iout,frmt1) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
          call freadra('xi=',nd,xid,1)
          call freadrs('v=',1,v0(i),0)
          write(iout,frmt1) 'xi=  ', (xid(j),j=1,nd),'v= ',v0(i)

          if(ish(i).eq.-1.or.ish(i).eq.0) then
             do j=1,nej(i)
                call freadra('ej=',nd,fj(1,j),1)
             end do
          else if(ish(i).gt.0) then
             nej(i)=nej0(ish(i))
             do j=1,nej(i)
                call vcpyr(ej0(1,j,ish(i)),fj(1,j),nd)
             end do
          end if
          if(ish(i).ge.0) then
             if(ish(i).eq.0) then
                call freadis('nth=',1,nth(i),1)
                isyd(i)=1
                if(nth(i).gt.nemax) call quit('nth > nemax')
                do j=1,nth(i)
                   call freadia(' ',idm,mej(1,j,i),0)
                end do
             else
                call freadis('isyd=',1,isyd(i),1)
                nth(i)=nth0(ish(i))
                do j=1,nth(i)
                   call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),idm)
                end do
             end if
             if(ish(i).ge.0) then
                do j=1,nej(i)
                   write(iout,frmt1) 'ej=', (fj(k,j),k=1,nd)
                end do
                call wtmej0(mej(1,1,i),nth(i))
             end if
             write(iout,*) 'isyd=',isyd(i)
          else if(ish(i).eq.-1) then
             do j=1,nej(i)
                write(iout,frmt1) 'ej=', (fj(k,j),k=1,nd)
             end do
          end if

c          call trhtole(xe1d)     ! tr6to5d etc
c          call trhtole(xe2d)
c          call trhtole(xe3d)
c          call prjext0(xe1d,xe1(1,i)) ! projection onto external space
c          call prjext0(xe2d,xe2(1,i))
c          call prjext0(xe3d,xe3(1,i))
c          call norml(xe1(1,i),6) ! normalize
c          call norml(xe2(1,i),6)
c          call norml(xe3(1,i),6)
c          call trhtole(xid)          
c          call prjint0(xid,xi(1,i))

c         getqe:  ve and vi components of f  (x to q in real space)
          do ii=1,3
             if(ii.eq.1) then
                call vcpyr(xe1d,xd,nd)
             else if(ii.eq.2) then
                call vcpyr(xe2d,xd,nd)
             else if(ii.eq.3) then
                call vcpyr(xe3d,xd,nd)
             end if

             if(isys.le.2) then
                call getqe(xd,q)
             else if(isys.eq.3) then
                call tr6to5e(xd,yd)
                call getqe(yd,q)
             else if(isys.eq.5) then
                call tr7to5e(xd,yd)
                call getqe(yd,q)
             else 
                call getqe(xd,q)
             end if
c            remove internal components
             q(4)=0
             q(5)=0
             q(6)=0
c            normalize q in the external space
             call norml(q,3)
c            convert q to x
             if(ii.eq.1) then
                call getxe(q,xe1(1,i))
             else if(ii.eq.2) then
                call getxe(q,xe2(1,i))
             else if(ii.eq.3) then
                call getxe(q,xe3(1,i))
             end if
          end do

***********************test***************************************
c             write(iout,frmt1) 'xe1=', (xe1(j,i),j=1,6),'u1=',u01(i)
c             write(iout,frmt1) 'xe2=', (xe2(j,i),j=1,6),'u2=',u02(i)
c             write(iout,frmt1) 'xe3=', (xe3(j,i),j=1,6),'u3=',u03(i)
******************************************************************

          if(isys.le.2) then
             call getqe(xid,q)
          else if(isys.eq.3) then
             call tr6to5e(xid,xd)
             call getqe(xd,q)
          else if(isys.eq.5) then
             call tr7to5e(xid,xd)
             call getqe(xd,q)
          else
             call getqe(xid,q)
          end if
c         remove external components
          q(1)=0
          q(2)=0
          q(3)=0
c         convert q to x
          call getxe(q,xi(1,i))
     
         do j=1,nej(i)
            if(isys.le.2) then
               call getqe(fj(1,j),ej(1,j,i))
            else if(isys.eq.3) then
               call tr6to5e(fj(1,j),xd)
               call getqe(xd,ej(1,j,i))
            else if(isys.eq.5) then
               call tr7to5e(fj(1,j),xd)
               call getqe(xd,ej(1,j,i))
            else
               call getqe(fj(1,j),ej(1,j,i))
            end if
c     absej=sqrt(ej(4,j,i)**2+ej(5,j,i)**2)
c     write(iout,*) 'ej(4),ej(5)=',ej(4,j,i),ej(5,j,i)
c     write(iout,*) 'absej=',absej
         end do
      end do
      if(iwflag(3).eq.1) then
         write(iout,300)
      end if
 102  format(i2,a,2i2,7f8.5/(6f8.5))
 300  format(1h )
 301  format(1h ,'na=',i3)
 302  format(1h ,i4,2x,a,2x,3i2,2x,7f8.5)
      end

      subroutine rdap1(na)
      character*6 atom
      include 'qcdiff.inc'
      common /cwflag/ iwflag(6)
      common /cltc/ atom(namax)
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc4/ ej(6,nemax,namax),nej(namax),nth(namax),
     *              mej(3,nemax,namax)
      common /copd2/ ej0(7,nemax,namax),nej0(namax),nth0(namax),
     *     mej0(3,nemax,namax)
      real ramin00(namax),ramax00(namax)
      real q(6),fj(7,nemax),xd(7),yd(6),icount(namax)
      real xe1d(7),xe2d(7),xe3d(7),xid(7)
      real q1(6),q2(6),q3(6)
      character*80 frmt1
      character*11 e12
      integer getidm
      data eps /0.0001/
      call getsys(isys)
      call getinp(inpu)
      call getout(iout)
      call getnpod(npod)
      idm=getidm()

      if(isys.eq.5) then
         nd=7
         frmt1='(1h ,a,7f9.5,2x,a,f9.5)'
      else
         nd=6
         frmt1='(1h ,a,6f9.5,2x,a,f9.5)'
      end if

      iwflag(3)=1
      if(iwflag(3).eq.1) then
         write(iout,301) na
         write(iout,'(1h ,2a)')
     *      'no symbol ien ish ne  be    bi   ramin   ramax    p',
     *      '       s1      s2'
      end if
      do i=1,npod
         ramin00(i)=0
         ramax00(i)=0
         icount(i)=0
      end do
      do i=1,na
         read(inpu,*) ik,atom(i),ien(i),ish(i),nej(i),
     *        be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),s0(2,i)
         write(iout,302) ik,atom(i),ien(i),ish(i),nej(i),
     *        be0(i),bi0(i),ramin0(i),ramax0(i),p0(i),s0(1,i),
     *        s0(2,i)
c     be1(i)=0
         if(ien(i).le.0) then
            call quit('ien should be a positive integer')
         end if
         if(ish(i).gt.npod) then
            write(6,*) 'OD number=',ish(i),' npod=',npod
            call quit('OD number > npod')
         end if
         if(ish(i).gt.0) then
            if(icount(ish(i)).eq.0) then
               ramin00(ish(i))=ramin0(i)
               ramax00(ish(i))=ramax0(i)
               icount(ish(i))=icount(ish(i))+1
            else if(icount(ish(i)).ge.1) then
               if(ramin00(ish(i)).ne.ramin0(i)) then
                  call quit('all the ramin must be the same for ish>0')
               end if
               if(ramax00(ish(i)).ne.ramax0(i)) then
                  call quit('all the ramax must be the same for ish>0')
               end if
            end if
         end if
*************
         if(nej(i).gt.nemax) call quit('ne > nemax')
         call freadra('x=',6,x0(1,i),1)
         write(iout,frmt1) 'x=  ', (x0(j,i),j=1,6)
         call freadra('xe1=',nd,xe1d,1)
         call freadrs('u1=',1,u01(i),0)
         write(iout,frmt1) 'xe1=', (xe1d(j),j=1,nd),'u1=',u01(i)
         call freadra('xe2=',nd,xe2d,1)
         call freadrs('u2=',1,u02(i),0)
         write(iout,frmt1) 'xe2=', (xe2d(j),j=1,nd),'u2=',u02(i)
         call freadra('xe3=',nd,xe3d,1)
         call freadrs('u3=',1,u03(i),0)
         write(iout,frmt1) 'xe3=', (xe3d(j),j=1,nd),'u3=',u03(i)
         call freadra('xi=',nd,xid,1)
         call freadrs('v=',1,v0(i),0)
         write(iout,frmt1) 'xi=  ', (xid(j),j=1,nd),'v= ',v0(i)
         
         if(ish(i).eq.-1.or.ish(i).eq.0) then
            do j=1,nej(i)
               call freadra('ej=',nd,fj(1,j),1)
            end do
         else if(ish(i).gt.0) then
            nej(i)=nej0(ish(i))
            do j=1,nej(i)
               call vcpyr(ej0(1,j,ish(i)),fj(1,j),nd)
            end do
         end if
         if(ish(i).ge.0) then
            if(ish(i).eq.0) then
               call freadis('nth=',1,nth(i),1)
               isyd(i)=1
               if(nth(i).gt.nemax) call quit('nth > nemax')
               do j=1,nth(i)
                  call freadia(' ',idm,mej(1,j,i),0)
               end do
            else
               call freadis('isyd=',1,isyd(i),1)
               nth(i)=nth0(ish(i))
               do j=1,nth(i)
                  call vcpyi(mej0(1,j,ish(i)),mej(1,j,i),idm)
               end do
            end if
            if(ish(i).ge.0) then
               do j=1,nej(i)
                  write(iout,frmt1) 'ej=', (fj(k,j),k=1,nd)
               end do
               call wtmej0(mej(1,1,i),nth(i))
            end if
            write(iout,*) 'isyd=',isyd(i)
         else if(ish(i).eq.-1) then
            do j=1,nej(i)
               write(iout,frmt1) 'ej=', (fj(k,j),k=1,nd)
            end do
         end if

         call trhtole(xe1d)     ! tr6to5d etc
         call trhtole(xe2d)
         call trhtole(xe3d)
         call prjext1(xe1d,xe1(1,i)) ! projection onto external space and
         call prjext1(xe2d,xe2(1,i)) ! normalize
         call prjext1(xe3d,xe3(1,i))
         call trhtole(xid)          
         call prjint0(xid,xi(1,i))

c     call wtvctrr('xe1d',xe1d,6)
c     call wtvctrr('xe2d',xe2d,6)
c     call wtvctrr('xid ',xid,6)
c     call wtvctrr('xe1',xe1(1,i),6)
c     call wtvctrr('xe2',xe2(1,i),6)
c     call wtvctrr('xi ',xi(1,i),6)

         do j=1,nej(i)
            if(isys.le.2) then
               call getqe(fj(1,j),ej(1,j,i))
            else if(isys.eq.3) then
               call tr6to5e(fj(1,j),xd)
               call getqe(xd,ej(1,j,i))
            else if(isys.eq.5) then
               call tr7to5e(fj(1,j),xd)
               call getqe(xd,ej(1,j,i))
            else
               call getqe(fj(1,j),ej(1,j,i))
            end if
c     absej=sqrt(ej(4,j,i)**2+ej(5,j,i)**2)
c     write(iout,*) 'ej(4),ej(5)=',ej(4,j,i),ej(5,j,i)
c     write(iout,*) 'absej=',absej
         end do
      end do
      if(iwflag(3).eq.1) then
         write(iout,300)
      end if
 102  format(i2,a,2i2,7f8.5/(6f8.5))
 300  format(1h )
 301  format(1h ,'na=',i3)
 302  format(1h ,i4,2x,a,2x,3i2,2x,7f8.5)
      return
      end

      subroutine getxe123(id,xe1d,xe2d,xe3d)      
      real xe1d(*),xe2d(*),xe3d(*)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call vcpyr(xe1(1,id),xe1d,6)
      call vcpyr(xe2(1,id),xe2d,6)
      call vcpyr(xe3(1,id),xe3d,6)
      return
      end

      subroutine resetips0(ny)  
c     reset ips for itempfi = 0 or 1 and if p=0 all fix all parameters
      include 'qcdiff.inc'
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cips/ ips(0:nxprm)
      common /cips0/ ips0(0:nxprm)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      real pd(namax)
      integer getitempfi
      call vcpyi(ips0,ips,ny+1)  ! copy ips0 into ips  including (0)

      n0=0
      do l=1,ny
         do k=1,jz(l)
            n=n0+k
            ii=ja(1,n)  ! OD number
            j=ja(2,n)   ! u1,u2,u3,be...
            if(p0(ii).eq.0) then  ! fix all parameters with OD No. ii
               ips(l)=0
            else 
               itempf=getitempfi(ii)
               if(itempf.eq.0) then ! isotropic temperature factors
                  if(ips0(l).eq.1.and.(j.ge.13.and.j.le.18)) then
                     ips(l)=0   ! reset ips for b1,b2...b6
                  end if
               else if(itempf.eq.1) then ! anisotropic temperature factors
                  if(ips0(l).eq.1.and.j.eq.4) then
                     ips(l)=0   ! reset ips for be
                  end if
               end if
            end if
         end do
         n0=n0+jz(l)
      end do
c      stop
      return
      end

      subroutine resetips0l(l)
      include 'qcdiff.inc'
      common /cips0/ ips0(0:nxprm)
      if(ips0(l).eq.1) then
         ips0(l)=0              ! reset ips for s1
      end if
      return
      end

      subroutine resetipsl(l)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      if(ips(l).eq.1) then
         ips(l)=0               ! reset ips for s1
      end if
      return
      end

      subroutine resetips1(x,ny) ! reset p,s1,s2 
      real x(*)
c     reset p,s1 and s2 to zero if they are less than 0.02
c     to 1  if they are greater than 0.98 and reset corresponding
c     ips to zero (fix)
      include 'qcdiff.inc'
      common /cips0/ ips0(0:nxprm)
      common /cips/ ips(0:nxprm)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      integer getipreset,getisreset
      n0=0
      do l=1,ny
         do k=1,jz(l)
            n=n0+k
            ii=ja(1,n)          ! OD number
            j=ja(2,n)           ! ...s1,s2...
            if(getipreset().eq.1) then
               if(j.eq.7) then  ! p
                  if(p(ii).le.0.02) then 
                     pd=0
                     x(l)=pd/ea(l)-p0(ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  else if(p(ii).ge.0.98) then 
                     pd=1
                     x(l)=pd/ea(l)-p0(ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  end if
               end if
            end if
            if(getisreset().eq.1) then
               if(j.eq.8) then  ! s1
                  if(s(1,ii).le.0.02) then 
                     s1=0
                     x(l)=s1/ea(l)-s0(1,ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  else if(s(1,ii).ge.0.98) then 
                     s1=1
                     x(l)=s1/ea(l)-s0(1,ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  end if
               end if
               if(j.eq.9) then  ! s2
                  if(s(2,ii).le.0.02) then 
                     s2=0
                     x(l)=s2/ea(l)-s0(2,ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  else if(s(2,ii).ge.0.98) then 
                     s2=1
                     x(l)=s2/ea(l)-s0(2,ii)
                     call resetipsl(l)
                     call resetips0l(l)
                  end if
               end if
            end if
         end do
         n0=n0+jz(l)
      end do
c     stop
      return
      end

      subroutine resetips(df,ny)
c     if occupancy becomes zero fix all parameters for that OD
      real df(*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      real pd(namax)
      integer getna
c     calculate occupation probability for each OD
      na=getna()
      do i=1,na
         pd(i)=p(i)
         n0=0
         do l=1,ny
            if(ips(l) .eq. 1) then
               do k=1,jz(l)
                  n=n0+k
                  ii=ja(1,n)
                  j=ja(2,n)
                  if(ii .eq. i) then
                     if(j .eq. 7) then
                        pd(i)=pd(i)+df(l)*ea(n)
                     end if
                  end if
               end do
            end if
            n0=n0+jz(l)
         end do
c        write(6,*) 'pd(i)=',pd(i)
      end do

c     reset ips for OD with p=0
      n0=0
      do l=1,ny
         do k=1,jz(l)
            n=n0+k
            ii=ja(1,n)  ! OD number
            j=ja(2,n)   ! u1,u2,...
c           write(6,*) 'ii,pd(ii)=',ii,pd(ii)
            if(pd(ii).eq.0) then
               if(ips(l).eq.1) then
                  ips(l)=0      ! reset ips for OD with p=0
                  write(6,*) 'reset ips(',l,')=0 since p=0'
               end if
            end if
         end do
         n0=n0+jz(l)
      end do
      return
      end

      subroutine prmtbl(df,ny)
      real df(*)
      include 'qcdiff.inc'
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      character*6 wx(18)
      integer getitempfi,getna
      na=getna()
      write(6,'(a,7x,10(a,10x),2(a,8x))')
     *     ' atom','u1','u2','u3','be','b1','bi','p ','s1','s2',
     *     'v','ramin','ramax'

      do i=1,na
         call getwx(wx,i,df,ny)
         if(getitempfi(i).eq.1) then
            be(i)=getbeq(i,ui(1,i)) ! equivalent temp. fac.
         end if
         write(6,'((i3,2x,10(f6.2,a),2(f8.4,a)))')
     *        i,u1(i),wx(1),u2(i),wx(2),u3(i),wx(3),be(i),wx(4),
     *        b1(i),wx(5),bi(i),wx(6),p(i),wx(7),s(1,i),wx(8),s(2,i),
     *        wx(9),v(i),wx(10),ramin(i),wx(11),ramax(i),wx(12)
      end do
      write(6,'(a,7x,8(a,11x))') ' atom','u11','u22','u33','u23','u31',
     *     'u12'
      do i=1,na
         if(getitempfi(i).eq.1) then
            call getwx(wx,i,df,ny)
            be(i)=getbeq(i,ui(1,i)) ! equivalent temp. fac.
            write(6,'(i3,2x,6(f8.4,a))')
     *           i,ui(1,i),wx(13),ui(2,i),wx(14),ui(3,i),wx(15),
     *           ui(4,i),wx(16),ui(5,i),wx(17),ui(6,i),wx(18)
         end if
      end do
      return
      end

      subroutine setxbp(z,ny)
      real z(*)
      include 'qcdiff.inc'
      common /cips/ ips(0:nxprm)
      common /cipt/ ipt(0:40*idsmax),nlc
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc2/ p0(namax),s0(2,namax),ramin0(namax),ramax0(namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      integer getitempf,getitempfi,getna
      itempf=getitempf()
      na=getna()
      do i=1,na
         u1(i)=u01(i)
         u2(i)=u02(i)
         u3(i)=u03(i)
         v(i)=v0(i)
         be(i)=be0(i)
         b1(i)=b10(i)
         bi(i)=bi0(i)
         ramin(i)=ramin0(i)
         ramax(i)=ramax0(i)
         p(i)=p0(i)
         s(1,i)=s0(1,i)
         s(2,i)=s0(2,i)
         itempfi=getitempfi(i)
         if(itempf.eq.1) then
            if(itempfi.eq.0) then
               be(i)=be0(i)
               b1(i)=b10(i)
            else
               call vcpyr(ui0(1,i),ui(1,i),6)
            end if
         end if
      end do

      n=0
      do l=1,ny
         do k=1,jz(l)
            n=n+1
            i=ja(1,n)
            j=ja(2,n)
            if(j .eq. 1) then
               u1(i)=u1(i)+z(l)*ea(n)
            else if(j .eq. 2) then
               u2(i)=u2(i)+z(l)*ea(n)
            else if(j .eq. 3) then
               u3(i)=u3(i)+z(l)*ea(n)
            else if(j .eq. 4) then
               be(i)=be(i)+z(l)*ea(n)
            else if(j .eq. 5) then
               b1(i)=b1(i)+z(l)*ea(n)
            else if(j .eq. 6) then
               bi(i)=bi(i)+z(l)*ea(n)
            else if(j .eq. 7) then
               p(i)=p(i)+z(l)*ea(n)
            else if(j .eq. 8) then
               s(1,i)=s(1,i)+z(l)*ea(n)
            else if(j .eq. 9) then
               s(2,i)=s(2,i)+z(l)*ea(n)
            else if(j .eq. 10) then
               v(i)=v(i)+z(l)*ea(n)
            else if(j .eq. 11) then
               ramin(i)=ramin(i)+z(l)*ea(n)
            else if(j .eq. 12) then
               ramax(i)=ramax(i)+z(l)*ea(n)
            else if(j .ge. 13 .and. j .le. 18) then
               ui(j-12,i)=ui(j-12,i)+z(l)*ea(n)
            end if
         end do
      end do

c     calculate equivalent aniso or isotropic temperature factors
c     for display
      do i=1,na
         itempfi=getitempfi(i)
         if(itempf.eq.1) then
            if(itempfi.eq.0) then
               call getbtoui(i,be(i),ui(1,i))  ! equivalent ui
            else
               be(i)=getbeq(i,ui(1,i))         ! equivalent beq
            end if
         end if
         call setnewx(i)
      end do

      return
      end

      subroutine settmp2x(z,ny)  ! be and uij to z==x
      real z(*)
      include 'qcdiff.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc5/ jz(nxprm),ja(2,nxprm*jzm),ea(nxprm*jzm)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      common /cstrc7/ p(namax),s(2,namax),ramin(namax),ramax(namax)
      integer getitempf,getitempfi
      if(getitempf().eq.0) then
         return
      end if
      n=1
      do l=1,ny
         i=ja(1,n)
         j=ja(2,n)
         itempfi=getitempfi(i)
         if(itempfi.eq.1) then
            if(j.eq.4) then
               bei=getbeq(i,ui(1,i))     ! equivalent b
               z(l)=(bei-be0(i))/ea(n)   ! difference
            end if
         else if(itempfi.eq.0) then
            if(j .ge. 13 .and. j .le. 18) then
               jd=j-12
               z(l)=(ui(jd,i)-ui0(jd,i))/ea(n)
            end if
         end if
         n=n+jz(l)
      end do
      return
      end

      subroutine setnewx(i)
      include 'qcdiff.inc'
      common /cstfc1/ x0(6,namax),u01(namax),u02(namax),u03(namax),
     *     v0(namax),be0(namax),bi0(namax),b10(namax),ui0(6,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      common /cstrc6/ x(6,namax),u1(namax),u2(namax),u3(namax),
     *     v(namax),be(namax),bi(namax),b1(namax),ui(6,namax)
      do j=1,6
         x(j,i)=x0(j,i)+u1(i)*xe1(j,i)+u2(i)*xe2(j,i)+u3(i)*xe3(j,i)
     *        +v(i)*xi(j,i)
      end do
      return
      end
