      subroutine setitempfi(itempfid)
      integer itempfid(*)
      include 'qcdiff.inc'
      common /citempfi/ itempfi(namax)
      integer getna
      na=getna()
      call vcpyi(itempfid,itempfi,na)
      return
      end

      subroutine setitempfi0()
      include 'qcdiff.inc'
      common /citempfi/ itempfi(namax)
      integer getna
      na=getna()
      call zerovi(itempfi,na)
      return
      end

      integer function getitempfi(n)
      include 'qcdiff.inc'
      common /citempfi/ itempfi(namax)
      getitempfi=itempfi(n)
      return
      end

      integer function getitempf()         ! get itempf
      integer pcol,dspmdl,tmpmdl,sctmdl
      common /jobctl/ sctmdl,itempf,itwin,iphfl,volr(48)
      getitempf=itempf
      return
      end

      subroutine setitempf(itempfd)
      integer pcol,dspmdl,tmpmdl,sctmdl
      common /jobctl/ sctmdl,itempf,itwin,iphfl,volr(48)
      itempf=itempfd
      return
      end

      subroutine setbia(id,biad)   ! overall random phason temperature factors
      include 'qcdiff.inc'
      common /cbia/ bia(idsmax)
c     write(6,*) 'id,setbia=',id,biad
      bia(id)=biad
      return
      end

      function getbia(id)   ! overall random phason temperature factors
      include 'qcdiff.inc'
      common /cbia/ bia(idsmax)
      getbia=bia(id)
      return
      end

      function gettmpf(n,hr,b,biat,dtmpf)  ! calculate Debye-Waller factors
      ! b(1) isotropic temperature factor
      ! b(2) anisotropic phason temperature factor for dihedral
      ! b(3) isotropic phason temperature factor *** not used
      ! b(4)-b(9) anisotropic thermal parameters
      ! biat overall phason temperature factor
      ! n QD number
      real qe,qi,b(*),biat,dtmpf(*)
      integer hr(*)
      real q(6)
      integer getitempfi
      itempf=getitempfi(n)  ! temperature factor for n-th atom
      call getqi(hr,q)
      call getsys(isys)
c     write(6,*) 'isys=',isys
c     write(6,*) 'biat=',biat
      if(isys.le.2) then
         qe=vabs(q,3)
         qi=vabs(q(4),3)
      else
         qe=vabs(q,3)
         qi=vabs(q(4),2)
      end if
      q12=q(1)**2+q(2)**2-q(3)**2
      if(itempf.eq.0) then
         t1=exp(-(b(3)+biat)*qi**2/4) ! phason Debye-Waller factor
         tmpf=exp(-b(1)*qe**2/4-b(2)*q12/4)*t1
                                ! isotropic phonon  Debye-Waller factor
         dtmpf(1)=-qe**2/4*tmpf
         dtmpf(2)=-q12/4*tmpf
         dtmpf(3)=-qi**2/4*tmpf
      else
         t1=exp(-(b(3)+biat)*qi**2/4) ! phason Debye-Waller factor
         tmpf=anstmpf(n,hr,b(4),dtmpf(4))*t1
                                ! anisotropic phonon Debye-Waller factor
         dtmpf(3)=-qi**2/4*tmpf
         do j=4,9
            dtmpf(j)=dtmpf(j)*t1
         end do
      end if
      gettmpf=tmpf
      return
      end

      function anstmpf(id,hr,b,dtmpf) ! choose version
      integer id ! occupation domain number
      integer hr(*)
      real b(*),dtmpf(*)        ! b(1)-b(6) : u11,u22,u33..,u12
      anstmpf=anstmpf1(id,hr,b,dtmpf) ! anisotoropic temperature factor
c     anstmpf=anstmpf2(id,hr,b,dtmpf) ! anisotoropic temperature factor
      return
      end

      function anstmpf1(id,hr,b,dtmpf) ! anisotoropic temperature factor
      integer hr(*)
      real b(*),dtmpf(*)        ! b(1)-b(6) : u11,u22,u33..,u12
      include 'qcdiff.inc'
      integer id ! occupation domain number
      real qr(6)
      call getqi(hr,qr)
      call getq123(id,qr,q1,q2,q3)
      anstmpf1=anstmpf0(id,q1,q2,q3,b,dtmpf)
      return
      end

      function anstmpf2(id,hr,b,dtmpf) ! anisotoropic temperature factor
      integer hr(*)
      real b(*),dtmpf(*)        ! b(1)-b(6) : u11,u22,u33..,u12
      include 'qcdiff.inc'
      integer id ! occupation domain number
      real qr(6)
      call getf123(id,hr,q1,q2,q3)
      anstmpf2=anstmpf0(id,q1,q2,q3,b,dtmpf)
      return
      end

      function getebt(i,n)
      include 'qcdiff.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      getebt=ebt(i,n)           ! coefficient for ui to b transformation
      return
      end

      function anstmpf0(id,q1,q2,q3,ui,dtmpf)
      real ui(*),dtmpf(*)
      include 'qcdiff.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      real ec(6)
      call vcpyr(ect(1,id),ec,6)
      sum=-ui(1)*q1*q1*ec(1)-ui(2)*q2*q2*ec(2)-ui(3)*q3*q3*ec(3)
     *     -2*(ui(4)*q2*q3*ec(4)+ui(5)*q1*q3*ec(5)+ui(6)*q1*q2*ec(6))
      tmpf=exp(sum)
c     derivatives of anstmpf with respect to ui(1),..,ui(6)
      dtmpf(1)=-q1*q1*ec(1)*tmpf  ! danstmpf/dq1 etc
      dtmpf(2)=-q2*q2*ec(2)*tmpf
      dtmpf(3)=-q3*q3*ec(3)*tmpf
      dtmpf(4)=-2*q2*q3*ec(4)*tmpf
      dtmpf(5)=-2*q1*q3*ec(5)*tmpf
      dtmpf(6)=-2*q1*q2*ec(6)*tmpf
      anstmpf0=tmpf
      return
      end

      function getbeq(n,ui)  ! ui to b
      real ui(*)
c     ui(1): u11, ui(2): u22, ... ui(6): u12
      include 'qcdiff.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      getbeq=0
      do i=1,3
         getbeq=getbeq+ui(i)*ebt(i,n)
      end do
      do i=4,6
         getbeq=getbeq+ui(i)*ebt(i,n)*2
      end do
      return
      end

      subroutine getbtoui(n,be,b)  ! iso B into uij
      real b(*)
      include 'qcdiff.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      do i=1,6
         b(i)=eat(i,n)*be
      end do
      return
      end

      subroutine btouij(na)   ! calculation of transformation coeff.
      include 'qcdiff.inc'
      common /ceat/ eat(6,namax),ebt(6,namax),ect(6,namax)
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real gab(3,3,namax)   ! metric tensor for each domain
      real gabn(3,3,namax)  ! reciprocal metric tensor for each domain
      real b(3),pivot(3)            ! for matinv
      integer ipivot(3),index(3*2)  ! for matinv
      integer j1(6),j2(6)
      real q1(6),q2(6),q3(6)
      real abccosd(6),abccosr(6)  ! lattice const. in direct and reciprocal sp.
      data j1/1,2,3,2,3,1/, j2/1,2,3,3,1,2/
      data pi /3.141592/
      data eps /0.000001/

c     eat for anisotropic temperature factor
      nonorth=0
      do n=1,na
         if(ifzerovr(xe1(1,n),3).eq.1.or.
     *      ifzerovr(xe2(1,n),3).eq.1) then
            write(6,*) 'For OD No. ',n
            write(6,*) 'non zero xe1 xe2 should be given',
     *           ' for asiso temp. fac.'
            call quit('n')
         end if
         if(ifzerovr(xe3(1,n),3).eq.1) then
            write(6,*) 'For OD No. ',n
            write(6,*) 'non zero xe3 should be given',
     *           ' for asiso temp. fac.'
            call quit('n')
         end if
         call getqe(xe1(1,n),q1)
         call getqe(xe2(1,n),q2)
         if(abs(vinpr(q1,q2,3)).lt.eps) then
            call vprdr(q1,q2,q3)  ! q3 = vector product of q1 and q2
            call norml(q3,3)      ! normalize q3 to make sure
         else
            call getqe(xe3(1,n),q3)
         end if

         call calgab(q1,q2,q3,gab(1,1,n))  ! cal. metric tensor gab
         call mcpyr(gab(1,1,n),gabn(1,1,n),3)
         call matinv(gabn(1,1,n),3,3,b,0,det,ipivot,index,pivot)
         if(det.lt.eps) then
            write(6,*) 'In OD No. ',n
            call quit('1 or 2 vectors are not independent')
         end if
         call getabc(gab(1,1,n),abccosd)
         call getabc(gabn(1,1,n),abccosr)
         if(iforthg(abccosd).eq.0) then
            nonorth=nonorth+1
            if(nonorth.eq.1) then
               write(6,'(2a)') 'non-orthogonal axes used in',
     *              ' anisotropic temp. fac.'
            end if
            fct=180.0/pi
            write(6,'(a,i3,6f7.2)') 'OD No,alpha,beta,gamma=',n,
     *           acos(abccosd(4))*fct,acos(abccosd(5))*fct,
     *           acos(abccosd(6))*fct
         end if
      end do
      do n=1,na
         do j=1,6
            k=j1(j)
            l=j2(j)
            gkk=gabn(k,k,n)
            gll=gabn(l,l,n)
            ect(j,n)=(8*pi**2)*sqrt(gkk*gll)     ! bi to ui
            eat(j,n)=gabn(k,l,n)/ect(j,n)/4      ! b to ui
            ebt(j,n)=4.0/3*gab(k,l,n)*ect(j,n)   ! ui to b
         end do
      end do
      return 
      end

      subroutine checkxe123(n)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      if(ifzerovr(xe1(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe1 should not be zero vector for aniso temp f.')
      end if
      if(ifzerovr(xe2(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe2 should not be zero vector for aniso temp f.')
      end if
      if(ifzerovr(xe3(1,n),3).eq.1) then
         write(6,*) 'for atom no. ',n
         call quit('xe3 should not be zero vector for aniso temp f.')
      end if
      return
      end
      
      subroutine getq123(n,q,q1,q2,q3)
      real q(*)
      real x1(6),x2(6),x3(6)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      call checkxe123(n)
      call getqe(xe1(1,n),x1)
      call getqe(xe2(1,n),x2)
      call getqe(xe3(1,n),x3)
      q1=vinpr(q,x1,3)
      q2=vinpr(q,x2,3)
      q3=vinpr(q,x3,3)
c     write(6,*) 'q1,q2,q3 in getq123',q1,q2,q3
      return
      end 

      subroutine getf123(n,hr,q1,q2,q3)  ! for temperature factor
      integer hr(*)
      call checkxe123(n)
      call gethrx123(n,hr,q1,q2,q3)
c      write(6,*) 'q1,q2,q3 in getf123',q1,q2,q3
      return
      end 

      subroutine gethrx123(n,hr,q1,q2,q3)
      integer hr(*)
      include 'qcdiff.inc'
      common /cstfc3/ xe1(6,namax),xe2(6,namax),xe3(6,namax),
     *     xi(6,namax),ien(namax),ish(namax),isyd(namax)
      real qr(6),qe1(6)
      q1=vinpir(hr,xe1(1,n),6)
      q2=vinpir(hr,xe2(1,n),6)
      q3=vinpir(hr,xe3(1,n),6)
c      write(6,*) 'hr=',(hr(j),j=1,6)
c      write(6,*) 'xe1=',(xe1(j,n),j=1,6)
      call getqi(hr,qr)
c      write(6,*) 'qr=',(qr(j),j=1,6)
      call getqe(xe1(1,n),qe1)
c      write(6,*) 'qe1=',(qe1(j),j=1,6)
      return
      end 
